package clientFunction;

import java.util.LinkedList;











/**
 * @author Tommaso
 * Classe che permette di dichiarare un oggetto access list e di collegarlo alle access list padre e figlie. 
 * Fornisce anche alcuni metodi utli per effettuare operazioni sull'oggetto ACL.
 */
public class ACLSEL {

	/** ID identificativo della access list */
	private String ID;
	/** Lista degli ID degli utenti presenti nella access list*/
	private LinkedList<String> UserList = null;
	/** Lista delle access list padre*/
	private LinkedList<ACLSEL> Ancestors = null;
	/** Lista delle access list figlie*/
	private LinkedList<ACLSEL> Descendents = null;
	private boolean all;
	private LinkedList<String> esclusi = null;
	private int NumNodo;
	private LinkedList<Intervallo> Interval=null; 
	
	/**
	 * Costruttore della classe
	 * 
	 * @param	ASSENTE
	 * 
	 * @return	ASSENTE
	 * 
	 */
	public ACLSEL() {
		super();
		UserList = new LinkedList<String>();
		Ancestors = new LinkedList<ACLSEL>();
		Descendents = new LinkedList<ACLSEL>();
		esclusi = new LinkedList<String>();
		Interval=new LinkedList<Intervallo>();
		all=false;
	}
	
	/**
	 * Costruttore della classe
	 * 
	 * @param	String	id	-	Parametro per inizializzare la variabile ID della classe
	 * 
	 * @return	ASSENTE
	 * 
	 */
	public ACLSEL(String id) {
		super();
		ID = id;
		UserList = new LinkedList<String>();
		Ancestors = new LinkedList<ACLSEL>();
		Descendents = new LinkedList<ACLSEL>();
		Interval=new LinkedList<Intervallo>();
		all=false;
	}
	
	/**
	 * Costruttore della classe
	 * 
	 * @param	String			id			-	Parametro per inizializzare la variabile ID della classe
	 * @param	List<String>	userlist	-	Lista degli utenti da inserire	
	 * 
	 * @return	ASSENTE
	 * 
	 */
	public ACLSEL(String id, LinkedList<String> userlist) {
		super();
		ID = id;
		UserList = new LinkedList<String>();
		addUsers(userlist);
		Ancestors = new LinkedList<ACLSEL>();
		Descendents = new LinkedList<ACLSEL>();
		Interval=new LinkedList<Intervallo>();
		all=false;
	}
	
	/**
	 * Metodo che setta l'ID della access List
	 * 
	 * @param	String id	-	Id da settare
	 * 
	 * @return	ASSENTE
	 * 
	 */
	public void setID(String id) {
		ID = id;
	}
	
	public void setall(boolean a) {
		all = a;
	}
	
	public boolean getall() {
		return all;
	}
	
	public int getEstremo(LinkedList<ACLSEL> albero)
	{
		int min=Integer.MAX_VALUE;
		
		if(this.getDescendents().size()>0)
		for(int i=0;i<this.getDescendents().size();++i)
		{   
			ACLSEL disc=new ACLSEL();
			for(int j=0;j<albero.size();++j)
				if(this.getDescendents().get(i).getID().equals(albero.get(j).getID()))
			        disc=albero.get(j);
			
			if(disc.getNum()<min)
				min=disc.getIntervalli().get(0).getMin();
		}
		else
			min=this.NumNodo;
		
		return min;
	}
	
	public int getNum()
	{
		return this.NumNodo;
	}
	
	public void setNum(int n)
	{
		this.NumNodo=n;
	}
	
	public void setIntervallo(int min,int max)
	{
		Intervallo i=new Intervallo();
		i.setMinMax(min, max);
		
		Interval.add(i);
		
		SistemaIntervalli();
		
	}
	
	public void setIntervalli(LinkedList<Intervallo> list)
	{
		for(int i=0;i<list.size();++i)
		 	{ Interval.add(list.get(i));
		     
		     
		 	  SistemaIntervalli();}
		
	}
	
	public void copiaIntervalli(LinkedList<Intervallo> list)
	{
		Interval=new LinkedList<Intervallo>();
		for(int i=0;i<list.size();++i)
		  Interval.add(list.get(i));
		      
		    
		 	  
		
	}
	
	public int RicavaMax()
	{
		int max=0;
		
		for(int i=0;i<Interval.size();++i)
			if(Interval.get(i).getMax()>max)
				max=Interval.get(i).getMax();
		
		return max;
	}
	
	public LinkedList<Intervallo> getIntervalli()
	{
		return this.Interval;
	}
	
	public String CreaStringaIntervalli()
	{
		String s="";
		for(int i=0;i<this.getIntervalli().size();++i)
			{s+=this.getIntervalli().get(i).getMin()+","+this.getIntervalli().get(i).getMax();
			 if(i!=this.getIntervalli().size()-1)
				 s+="/";
			}
		return s;
		
	}
	
	private void SistemaIntervalli()
	{
	
		boolean fatto=false;
		LinkedList<Integer> vet=new LinkedList<Integer>();
		for(int j=0;j<Interval.size();++j)
			vet.add(0);
		
		
		
		do
		{	fatto=false;
			for(int i=0;i<Interval.size();++i)
				for(int j=0;j<Interval.size();++j)
					if((i!=j)&&(vet.get(i)==0)&&(vet.get(j)==0))
						{
						
						
						if(Interval.get(i).contains(Interval.get(j)))
							{
							 vet.set(j, 1);
							 fatto=true;
							}
						else
						 if(Interval.get(i).Consecutivo(Interval.get(j)))
						 {
						 
						 Interval.add(Intervallo.unisci(Interval.get(i), Interval.get(j)));
						 vet.add(0);
						 vet.set(i, 1);
						     vet.set(j, 1);
							 fatto=true;
						 }
						}
			}
			while(fatto==true);
	
		
		int cont=0;
		for(int j=0;j<vet.size();++j)
			if(vet.get(j)==1)
				{Interval.remove(j-cont);
				++cont;
				}
						
							
		
	}
	
	public boolean AddEsclusi(String a) {
		
		if(esclusi!=null){
		for(int i=0; i<esclusi.size(); i++)
			if(esclusi.get(i).equals(a))
					return false; }
		else
			esclusi=new LinkedList<String>();
		
		
		
		esclusi.add(a);
		
		int[] vet=new int[esclusi.size()];
		for(int i=0;i<esclusi.size();++i)
			vet[i]=Integer.parseInt(esclusi.get(i));
		
		
		for(int i=0;i<vet.length;++i)
			for(int j=0;j<vet.length-1;++j)
				if(vet[j]>vet[j+1])
				{
					int s=vet[j];
					vet[j]=vet[j+1];
					vet[j+1]=s;
				}
		esclusi.clear();
		
		for(int i=0;i<vet.length;++i)
			esclusi.add(Integer.toString(vet[i]));
		
		//aggiorno id
		String s="ALL-";
		
		for(  int i=0; i<esclusi.size(); i++)
		  {if(i!=0)s=s+"-";
			s=s+esclusi.get(i);
		  
		  }
		
		ID=s;
		
		return true;
	}
	
	/**
	 * Metodo che setta i predecessori della access List
	 * 
	 * @param	LinkedList<ACLSEL>	ancestor	-	Lista predecessori
	 * 
	 * @return	ASSENTE
	 * 
	 */
	public void setAncestor(LinkedList<ACLSEL> ancestor){
		this.Ancestors = ancestor;
	}
	
	/**
	 * Metodo che setta i successori della access List
	 * 
	 * @param	LinkedList<ACLSEL>	descendents	-	Lista successori
	 * 
	 * @return	ASSENTE
	 * 
	 */
	public void setDescendents(LinkedList<ACLSEL> descendents){
		this.Descendents = descendents;
	}

	/**
	 * Metodo che ritorna l'ID della access List
	 * 
	 * @param	ASSENTE
	 * 
	 * @return	String	-	ID della access list
	 * 
	 */
	public String getID() {
		return ID;
	}

	/**
	 * Metodo che ritorna i predecessori della access List
	 * 
	 * @param	ASSENTE
	 * 
	 * @return	LinkedList<ACLSEL>	-	Lista predecessori
	 * 
	 */
	public LinkedList<ACLSEL> getAncestor(){
		return this.Ancestors;
	}
	
	/**
	 * Metodo che ritorna i successori della access List
	 * 
	 * @param	ASSENTE
	 * 
	 * @return	LinkedList<ACLSEL>	-	Lista successori
	 * 
	 */
	public LinkedList<ACLSEL> getDescendents(){
		return this.Descendents;
	}
	
	/**
	 * Metodo che aggiunge un utente alla access list
	 * 
	 * @param	String	user	-	Utente da aggiungere
	 * 
	 * @return	ASSENTE
	 * 
	 */
	public boolean addUser(String user) {
		for(int i=0; i<UserList.size(); i++)
			if(UserList.get(i).equals(user))
					return false;

		UserList.add(user);
		
	
		int[] vet=new int[UserList.size()];
		for(int i=0;i<UserList.size();++i)
			vet[i]=Integer.parseInt(UserList.get(i));
		
		
		for(int i=0;i<vet.length;++i)
			for(int j=0;j<vet.length-1;++j)
				if(vet[j]>vet[j+1])
				{
					int s=vet[j];
					vet[j]=vet[j+1];
					vet[j+1]=s;
				}
		UserList.clear();
		
		for(int i=0;i<vet.length;++i)
			UserList.add(Integer.toString(vet[i]));
		//aggiorno id
		String s="";
		
		for(  int i=0; i<UserList.size(); i++)
		  {if(i!=0)s=s+"-";
			s=s+UserList.get(i);
		  
		  }
		
		ID=s;
			
		return true;
	}
	
	/**
	 * Metodo che aggiunge una lista di utenti alla access list
	 * 
	 * @param	List<String>	users	-	Lista utenti da aggiungere
	 * 
	 * @return	ASSENTE
	 * 
	 */
	public void addUsers(LinkedList<String> users) {
		for(int i=0; i<users.size(); i++)
			addUser(users.get(i));
	}

	/**
	 * Metodo che ritorna la dimensione della access list
	 * 
	 * @param	ASSENTE
	 * 
	 * @return	int	-	numero di elementi nella access list
	 * 
	 */
	public int getSize() {
		if(all)
			return Integer.MAX_VALUE;
		return UserList.size();
	}

	/**
	 * Metodo che ritorna la lista degli utenti presenti nella access list
	 * 
	 * @param	ASSENTE
	 * 
	 * @return	List<String>	-	lista degli utenti presenti nella access list
	 * 
	 */
	public LinkedList<String> getUserList() {
		return UserList;
	}

	public LinkedList<String> getEsclusi() {
		return esclusi;
	}
	
	

	
	/**
	 * Metodo che confronta le access list di due oggetti ACLSEL
	 * 
	 * @param	ACLSEL	toCheck	-	Oggetto con cui effettuare il confronto
	 * 
	 * @return	boolean		-	True	->	Le access list dei due oggetti son uguali
	 * 							False	->	Le access list dei due oggetti sono diverse
	 * 
	 */
	public boolean equals(ACLSEL toCheck) {

		int a, i;
		if (toCheck.getSize() == getSize()) {
			for (i = 0; i < getSize(); i++) {
				for (a = 0; a < toCheck.getSize(); a++) {
					if (UserList.get(i).equals(toCheck.getUserList().get(a))) {
						break;
					}
				}
				if (a == toCheck.getSize())
					return false;
			}
		} else
			return false;
		return true;
	}

	/**
	 * Metodo che confronta le access list di due oggetti ACLSEL per verificare che quella passata sia
	 *  contenuta in quella che invoca il metodo
	 * 
	 * @param	ACLSEL	toCheck	-	Oggetto con cui effettuare il confronto
	 * 
	 * @return	boolean		-	True	->	La access list � contenuta in quella che invoca il metodo
	 * 							False	->	La access list non � contenuta in quella che invoca il metodo
	 * 
	 */
	public boolean contains(ACLSEL toCheck) {
		int a, i;
		if (getSize() >= toCheck.getSize()) {
			for (i = 0; i < toCheck.getSize(); i++) {
				for (a = 0; a < getSize(); a++) {
					if (toCheck.getUserList().get(i).equals(UserList.get(a)))
						break;
				}
				if (a == getSize())
					return false;
			}
		} else
			return false;
		return true;
	}
	
	/**
	 * Metodo che calcola la differenza tra due oggetti ACLSEL e restituisce la lista degli utenti 
	 * risultante dall'operazione, l'oggetto passato per parametro deve essere contenuto in quello 
	 * che invoca il metodo
	 * 
	 * @param	ACLSEL	toCheck		-	Oggetto ACLSEL da sottrarre
	 * 
	 * @return	List<String>	-	Lista degli utenti risultanti dalla differenza	
	 * 
	 */
	public LinkedList<String> sub(ACLSEL	toSubtract){
		LinkedList<String> result = getUserList();
		for( int i = 0; i < toSubtract.getUserList().size();i++)
			for(int  a=0; a < result.size(); a++ ){
				if(result.get(a).equals(toSubtract.getUserList().get(i))){
					result.remove(a);
					break;
				}
			}
		return result;
	}
	
	/**
	 * Aggiungo un nuovo elemento padre all'oggetto ACLSEL
	 * 
	 * @param	ACLSEL		anc	-	ACLSEL da inserire nella lista dei predecessori
	 * 
	 * @return	boolean		-	True	->	Inserimento avvenuto correttamente
	 * 
	 */
	public boolean addAncestor(ACLSEL anc){
		
		for(int i=0;i<Ancestors.size();i++)
			if(Ancestors.get(i).getID().equals(anc.getID()))
				return false;
		Ancestors.add(anc);
		
		return true;
	}
	
	/**
	 * Aggiungo un nuovo elemento figlio all'oggetto ACLSEL
	 * 
	 * @param	ACLSEL		anc	-	ACLSEL da inserire nella lista dei successori
	 * 
	 * @return	boolean		-	True	->	Inserimento avvenuto correttamente
	 * 
	 */
	public boolean addDescendent(ACLSEL desc){
		for(int i=0;i<Descendents.size();i++)
			if(Descendents.get(i).getID().equals(desc.getID()))
				return true;
		Descendents.add(desc);
		return true;
	}

}