package clientFunction;
import java.sql.Connection;
import java.sql.DriverManager;

/**
 * @author Tommaso
 * Classe che implementa la connessione con il database 
 */
public class DBConnection {
	/** Driver per la connessione al database */
	static final String DRIVER_CLASS = "org.postgresql.Driver";
	/** URL del database */
	static final String DB_URL = "jdbc:postgresql://localhost:5432/iOverEncryptDB";
	/** Utente per la connessione al database */
	static final String DB_USER = "postgres";
	/** Password dell'utente per connettersi al database */
	static final String DB_PASSWORD = "postgres";
	/** La variabile connessione */
	public Connection conn;

	/** Costruttore della classe, crea la connessione con il database
	 * 
	 * @param	ASSENTE
	 * 
	 * @return	ASSENTE
	 *
	 */
	public DBConnection() {
		try {
			Class.forName(DRIVER_CLASS);
			conn = DriverManager.getConnection(DB_URL, DB_USER, DB_PASSWORD);
		} catch (Exception e) {
			System.err.println(e.toString());
		}
	}
	
	/** Metodo per chiudere la connessione con il database 
	 *  
	 * @param	ASSENTE
	 * 
	 * @return	ASSENTE
	 *
	 * */
	public void closeConnection() {
		try {
			conn.close();
		} catch (Exception e) {
			System.err.println(e.toString());
		}
	}
	
	/** Metodo che restituisce la variabile connessione, che verr utilizzata per 
	 * effettuare operazioni sul database.
	 *  
	 * @param	ASSENTE
	 * 
	 * @return	Connection	- connessione corrente
	 *
	 * */
	public Connection getConnection() {
		try {
			if(!conn.isClosed())
				return conn;
		} catch (Exception e) {
			System.err.println(e.toString());
		}	
		return null;
	}
}
