package clientFunction;

public class FileListElement {
	private String fileID;
	private String filename;
	private String fileIDKeyBEL;
	private String fileIDKeySEL=null;
	private String ownerID;
	
	/**
	 * Costruttore della classe
	 * 
	 * @param	String	fileID			-	ID del file
	 * 
	 */
	public FileListElement(String fileID) {
		super();
		this.fileID = fileID;
	}
	
	
	
	/**
	 * Costruttore della classe che inizzializza tutti i campi
	 * 
	 * @param	String	fileID			-	ID del file
	 * @param	String	filename		-	Nome del file
	 * @param	String	fileIDKeyBEL	-	Id chiave livello BEL
	 * 
	 */
	public FileListElement(String fileID, String filename,String fileIDKeyBEL) {
		super();
		this.fileID = fileID;
		this.filename = filename;
		this.fileIDKeyBEL=fileIDKeyBEL;
	}
	
	/**
	 * Costruttore della classe che inizzializza tutti i campi
	 * 
	 * @param	String	fileID			-	ID del file
	 * @param	String	filename		-	Nome del file
	 * @param	String	fileIDKeyBEL	-	Id chiave livello BEL
	 * @param	String	fileIDKeySEL	-	Id chiave livello SEL
	 * 
	 */
	public FileListElement(String fileID, String filename,String fileIDKeyBEL,String fileIDKeySEL) {
		super();
		this.fileID = fileID;
		this.filename = filename;
		this.fileIDKeyBEL=fileIDKeyBEL;
		this.fileIDKeySEL=fileIDKeySEL;
	}
	
	/**
	 * Costruttore della classe che inizzializza tutti i campi
	 * 
	 * @param	String	fileID			-	ID del file
	 * @param	String	filename		-	Nome del file
	 * @param	String	fileIDKeyBEL	-	Id chiave livello BEL
	 * @param	String	fileIDKeySEL	-	Id chiave livello SEL
	 * @param	String	ownerID			-	Id del proprietario del file
	 * 
	 */
	public FileListElement(String fileID, String filename,String fileIDKeyBEL,String fileIDKeySEL,String ownerID) {
		super();
		this.fileID = fileID;
		this.filename = filename;
		this.fileIDKeyBEL=fileIDKeyBEL;
		this.fileIDKeySEL=fileIDKeySEL;
		this.ownerID=ownerID;
	}
	
	/** 
	 * Ridefinisco il metodo toString() in modo che venga restituito il nome del file
	 * 
	 * @param	ASSENTE
	 * 
	 * @return	String	-	Nome  del file
	 * 
	 * */
	public String toString(){
		return filename;
	}
	
	/**
	 * Metodo che mi ritorna l'id del file
	 * 
	 * @param	ASSENTE
	 * 
	 * @return	String	-	ID del file
	 * 
	 */
	public String getID(){
		return fileID;
	}
	
	/**
	 * Metodo che mi ritorna il nome del file
	 * 
	 * @param	ASSENTE
	 * 
	 * @return	String	-	Nome del file
	 * 
	 */
	public String getFileName(){
		return filename;
	}
	
	/**
	 * Metodo che mi ritorna l'id (BEL) della chiave usata per criptare il file
	 * 
	 * @param	ASSENTE
	 * 
	 * @return	String	-	Id della chiave usata per criptare il file
	 * 
	 */
	public String getFileIDKeyBEL(){
		return fileIDKeyBEL;
	}
	
	/**
	 * Metodo che mi ritorna l'id (SEL) della chiave usata per criptare il file
	 * 
	 * @param	ASSENTE
	 * 
	 * @return	String	-	Id della chiave usata per criptare il file
	 * 
	 */
	public String getFileIDKeySEL(){
		return fileIDKeySEL;
	}
	
	/**
	 * Metodo che mi ritorna l'ID del proprietario del file file
	 * 
	 * @param	ASSENTE
	 * 
	 * @return	String	-	ID del proprietario del file file
	 * 
	 */
	public String getOwnerID(){
		return ownerID;
	}
	
}
