package clientFunction;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Arrays;
import java.util.LinkedList;
import java.util.StringTokenizer;
import java.util.Properties;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

/**
 * @author Flavio e Estevan
 *
 */
public class SELSharedFile {

	/**
	 *  path file configurazione solo per windows
	 */
	protected static String configPath = ""; 

	/** Contiene il path del File */
	static String filePath;
	/** ID dell'utente che condivide il file */
	final public String ownerID = "0";
	/** ID dell'utente che deve scaricare il file */
	public String userID;
	/** ID assegnato al file */
	public String fileID;
	/** Chiave radice del proprietario del file */
	//final byte[] ownerKey = "ed026383fcb3298000a16295d837e6d1".getBytes(); //server_sel_flavio_estevan
	final byte[] ownerKey = "ed026383fcb3298000a16295d837e6d1".getBytes(); //flavio
	
	/** PIN X ecrypt decrypt */
	//final static String PIN = "server_sel_flavio_estevan";
	final static String PIN = "flavio";

	/** Chiave privata per il protocollo di Key Agreement */
	byte[] ownerPrivateDHKey;
	/** Vettore contenente tutti gli utenti da autorizzare all'accesso al File */
	UserListElement[] authList;
	/** Accessgraph pubblico */
	static AccessGraph accessGraph;
	/** chiave id key bel */
	static String groupIDBEL = null;
	
	public String getGroupIDBEL() {
		return groupIDBEL;
	}

	public SELSharedFile() {
		return;
	}

	/**
	 * Costruttore della classe
	 * 
	 * @param String
	 *            filePath - Contiene il path del File
	 * @param UserListElement
	 *            [] authList - Vettore contenente tutti gli utenti da
	 *            autorizzare all'accesso al File
	 * @return ASSENTE
	 * 
	 */
	public SELSharedFile(String filePath, UserListElement[] authList) {
		this.filePath = filePath;
		this.authList = authList;

		try {
			FileInputStream fin;
			DataInputStream dis = null;
			fin = new FileInputStream("Key" + File.separatorChar
					+ "SERVER");
			dis = new DataInputStream(fin);
			fin.close();
		} catch (Exception e) {
			System.err.println(e.toString());
		}

	}
	
	public void setSharedFile(String filePath, UserListElement[] authList) {
		this.filePath = filePath;
		this.authList = authList;
	}
	

	//SETTO I PARAMETRI PER CRIPTARE UN NUOVO FILE
	public boolean setFileToEncrypt(String filePath, String[] authList, String userId) {
		this.filePath = filePath;

		int numUser = authList.length;
		
		if (authList[0].equals(""))
			numUser = 0;
		
		UserListElement[] userAuth = new UserListElement[numUser + 2];
		for (int i=0; i< authList.length; i++ ) {
			if (!authList[i].equals(""))
			    userAuth[i] = new UserListElement(authList[i]);
		}
		
		//aggiungo l'owner alla lista
		userAuth[numUser+1] = new UserListElement(userId);
		userAuth[numUser] = new UserListElement(ownerID);
				
		this.authList = userAuth;
		
		//controllo l'autlist con quella vecchia
		String users = "";
		
		try {
			DBConnection connection = new DBConnection();
			Statement stmt = connection.getConnection().createStatement();
			ResultSet rset = stmt
					.executeQuery("SELECT keyidsel from filetable where objectid = '"
							+ filePath + "' ");
			if (rset != null) {
				rset.next();
				users = rset.getString(1);
				
				//se il sel non esiste prendo gli utenti del bel
				if(users.length() <=0) {
					rset = stmt
					.executeQuery("SELECT keyidbel from filetable where objectid = '"
							+ filePath + "' ");
					if (rset != null) {
						rset.next();
						users = rset.getString(1);
					}
				}
				
			}
		
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		String newUsers = "";
		for (UserListElement t:userAuth) {
			if (newUsers.length() == 0) newUsers = t.getID();
			else newUsers = newUsers + "-" + t.getID();
		}
		
		return newUsers.equals(users);
		
		
	}
	
	
	
	
	//SETTO I PARAMETRI PER CRIPTARE UN NUOVO FILE
	public void setFileToDecrypt(String filePath) {
		this.filePath = filePath;
	}
	
	
	
	

	public void setID(String id) {
		this.fileID = id;
	}

	/**
	 * Metodo pubblico che cripta il File a livello BEL (Base Encrypt Level) e
	 * lo salva su hard creando se necessario gli opportuni token per la
	 * derivazione delle chiavi
	 * 
	 * @param ASSENTE
	 * 
	 * @return ASSENTE
	 * 
	 */
	public boolean createBEL(String keysel) {

		String groupIDBEL = null;
		accessGraph = new AccessGraph(1);

		ACL newAcl = new ACL();

		for (int a = 0; a < authList.length; a++) {
			newAcl.addUser(authList[a].getID());
		}
		groupIDBEL = newAcl.getID();

		LinkedList<String> listcod = new LinkedList<String>();
		for (int t = 0; t < accessGraph.getAllAcl().size(); ++t)
			listcod.add(accessGraph.getAllAcl().get(t).getID());

		if (!listcod.contains(newAcl.getID()))// se non esiste gia questo gruppo
		{
			if (authList.length == 1) { // CONDIVIDO IL FILE SOLO CON ME STESSO
			

			} else {
				accessGraph.addAcl(newAcl);
				if (newAcl.getSize() == 2) // CONDIVIDO IL FILE TRA ME E UN SOLO
											// ALTRO UTENTE
				{
					String userID = null;
					if (newAcl.getUserList().get(0).equals(ownerID.toString()))
						userID = newAcl.getUserList().get(1);
					if (newAcl.getUserList().get(1).equals(ownerID.toString()))
						userID = newAcl.getUserList().get(0);
				} else
				try {
					System.err.println(createTokenToEncrypt(accessGraph, groupIDBEL));
				} catch (JSONException e) {
					e.printStackTrace();
				}

			}
		} else {// se il gruppo esiste
			accessGraph.CaricaIntervalli();

			try {
				System.err.println(createTokenToEncrypt(accessGraph, groupIDBEL));
			} catch (JSONException e) {
				e.printStackTrace();
			}
		}
		return true;
	}

	private static void abort(String msg) throws IOException {
		throw new IOException("FileCopy: " + msg);
	}

	public static void copy(String from_name, String to_name)
			throws IOException {
		File from_file = new File(from_name); // Get File objects from Strings
		File to_file = new File(to_name);

		// First make sure the source file exists, is a file, and is readable.
		if (!from_file.exists())
			abort("no such source file: " + from_name);
		if (!from_file.isFile())
			abort("can't copy directory: " + from_name);
		if (!from_file.canRead())
			abort("source file is unreadable: " + from_name);

		// If the destination is a directory, use the source file name
		// as the destination file name
		if (to_file.isDirectory())
			to_file = new File(to_file, from_file.getName());


		// If file doesn't exist, check if directory exists and is
		// writeable. If getParent() returns null, then the directory is
		// the current dir. so look up the user.dir system property to
		// find out what that is.
		String parent = to_file.getParent(); // The destination directory
		if (parent == null) // If none, use the current directory
			parent = System.getProperty("user.dir");
		File dir = new File(parent); // Convert it to a file.
		if (!dir.exists())
			abort("destination directory doesn't exist: " + parent);
		if (dir.isFile())
			abort("destination is not a directory: " + parent);
		if (!dir.canWrite())
			abort("destination directory is unwriteable: " + parent);
		// }

		// If we've gotten this far, then everything is okay.
		// So we copy the file, a buffer of bytes at a time.
		FileInputStream from = null; // Stream to read from source
		FileOutputStream to = null; // Stream to write to destination
		try {
			from = new FileInputStream(from_file); // Create input stream
			to = new FileOutputStream(to_file); // Create output stream
			byte[] buffer = new byte[4096]; // To hold file contents
			int bytes_read; // How many bytes in buffer

			// Read a chunk of bytes into the buffer, then write them out,
			// looping until we reach the end of the file (when read() returns
			// -1). Note the combination of assignment and comparison in this
			// while loop. This is a common I/O programming idiom.
			while ((bytes_read = from.read(buffer)) != -1)
				// Read until EOF
				to.write(buffer, 0, bytes_read); // write
		}
		// Always close the streams, even if exceptions were thrown
		finally {
			if (from != null)
				try {
					from.close();
				} catch (IOException e) {
					;
				}
			if (to != null)
				try {
					to.close();
				} catch (IOException e) {
					;
				}
		}
	}

	private boolean ingiafatto(ACL acl, LinkedList<ACL> giafatto) {
		int i = 0;
		while (i < giafatto.size()) {
			if (giafatto.get(i).contains(acl)) {
				return true;
			}
			i++;

		}
		return false;
	}

	public static byte[] getKeySEL(String keyID, AccessGraphSEL accessgraph,
			String ownerID, String userid) {

		byte[] aesKey = null;
		String key = keyID;
		Token newToken;
		DBConnection connection = new DBConnection();
		ACL antenato = new ACL();
		LinkedList<Token> tokenPath = new LinkedList<Token>();

		try {

			ACLSEL acl = new ACLSEL();
			acl = accessgraph.getACLfromID(key);

			LinkedList<String> codici = new LinkedList<String>();
			codici = acl.getUserList();
			LinkedList<ACLSEL> foglie = new LinkedList<ACLSEL>();
			foglie = accessgraph.getAclListBySize(2);
			// String userid= new String();
			if (acl.getSize() == 2)// gruppo da due utenti,chiave da DH
			{

				aesKey = DHKeyAgreementFunction.buildDHKey(userid, ownerID
						.toString());

			} else {

				antenato.addUser(ownerID);
				antenato.addUser(userid);
				LinkedList<ACLSEL> percorso = new LinkedList<ACLSEL>();

				// trovo percorso di acl da antenato a destinazione
				esplora_albero(accessgraph, antenato.getID(), percorso, acl);

				Statement stmt = connection.getConnection().createStatement(
						ResultSet.TYPE_SCROLL_INSENSITIVE,
						ResultSet.CONCUR_UPDATABLE);
				ResultSet rset = stmt
						.executeQuery("SELECT groupidsource,groupiddestination,token,label from tokentable where level = 'SEL'");
				for (int j = 0; j < percorso.size() - 1; j++) {
					rset.first();
					do {

						if ((rset.getString(1).equals(percorso.get(j).getID()))
								&& (rset.getString(2).equals(percorso
										.get(j + 1).getID()))) {
							newToken = new Token(rset.getString(1), rset
									.getString(2), Conversion.toBytes(rset
									.getString(3)), rset.getString(4));
							tokenPath.add(newToken);

						}
					} while (rset.next());
				}

				aesKey = DHKeyAgreementFunction.buildDHKey(userid, ownerID
						.toString());

				for (int i = 0; i < tokenPath.size(); i++) {

					aesKey = Token.rebuildKey(aesKey, tokenPath.get(i)
							.getToken(), tokenPath.get(i).getLabel());
				}
			}

		} catch (Exception e) {
			System.err.println(e.toString());
		}
		connection.closeConnection();

		return aesKey;
	}

	public static boolean checkEncStatus(String fileID) {
		DBConnection connection = new DBConnection();
		boolean status = true;
		String keyidsel;

		try {
			Statement stmt = connection.getConnection().createStatement();
			ResultSet rset = stmt
					.executeQuery("SELECT * from filetable  where objectid ='"
							+ fileID + "'");
			if (rset != null) {
				while (rset.next()) {
					keyidsel = rset.getString(3);
					if ((keyidsel.equals("")) || (keyidsel == null)) {
						status = false;
					}
				}
			}
			rset.close();
			stmt.close();
		} catch (Exception e) {
			System.err.println(e.toString());
		}
		connection.closeConnection();
		return status;
	}

	private static void pulisci(ACL newAcl, ACL figlio) {

		LinkedList<ACL> padri = newAcl.getAncestor();
		for (int i = 0; i < padri.size(); ++i) {
			if (figlio.contains(padri.get(i))) {
				removeTokenFromDB(padri.get(i).getID(), figlio.getID(), "SEL");
			}
		}
	}

	/**
	 * Elimino il token specificato dal DB
	 * 
	 * @param String
	 *            keyIDSource - ID della chiave sorgente
	 * @param String
	 *            keyIDDestination - ID della chiave destinazione
	 * 
	 * @return ASSENTE
	 */
	private static boolean removeTokenFromDB(String keyIDSource,
			String keyIDDestination, String tipo) {

		DBConnection connection = new DBConnection();
		try {
			Statement stmt = connection.getConnection().createStatement();
			ResultSet rset = stmt
					.executeQuery("select * from tokentable where groupidsource = '"
							+ keyIDSource
							+ "' and groupiddestination ="
							+ "'"
							+ keyIDDestination + "'and level='" + tipo + "'");
			if (rset != null) {
				stmt.execute("delete from tokentable where groupidsource = '"
						+ keyIDSource + "' and groupiddestination =" + "'"
						+ keyIDDestination + "'and level='" + tipo + "'");
				stmt.close();
			}

			rset.close();
			stmt.close();

		} catch (Exception e) {
			System.err.println(e.toString());
			return false;
		}

		return true;
	}

	/**
	 * Metodo ricorsivo che recupera il percorso da percorrerre per andare da un
	 * determinato nodo ad un altro
	 * 
	 * 
	 * @param ASSENTE
	 * @param ASSENTE
	 * 
	 * @return ASSENTE
	 * 
	 */
	private static void esplora_albero(AccessGraph ag, String sorgente,
			LinkedList<ACL> list, ACL destinazione) {
		int ndest = ag.getACLfromID(destinazione.getID()).getNum();
				
		String corr = sorgente;
		do {
			list.add(ag.getACLfromID(corr));
			ACL acl = ag.getACLfromID(corr);
			
			String copia = corr;
			for (int i = 0; i < acl.getDescendents().size(); ++i) {
				
				ACL disc = ag.getACLfromID(acl.getDescendents().get(i).getID());
				for (int j = 0; j < disc.getIntervalli().size(); ++j) {
					
					if (disc.getIntervalli().get(j).contiene(ndest)) {
						corr = disc.getID();
					}
				}
			}
			if (copia.equals(corr))
				break;
		} while (!corr.equals(destinazione));
		if (corr.equals(destinazione.getID())) {
			
		} else {
			list.clear();
			list = new LinkedList<ACL>();

		}
		return;
	}

	private static void esplora_albero(AccessGraphSEL ag, String sorgente,
			LinkedList<ACLSEL> list, ACLSEL destinazione) {
		int ndest = ag.getACLfromID(destinazione.getID()).getNum();

		String corr = sorgente;
		do {
			list.add(ag.getACLfromID(corr));
			ACLSEL acl = ag.getACLfromID(corr);
			String copia = corr;
			for (int i = 0; i < acl.getDescendents().size(); ++i) {
				ACLSEL disc = ag.getACLfromID(acl.getDescendents().get(i).getID());
				for (int j = 0; j < disc.getIntervalli().size(); ++j)
					if (disc.getIntervalli().get(j).contiene(ndest))
						corr = disc.getID();
			}
			if (copia.equals(corr))
				break;
		} while (!corr.equals(destinazione));
		if (corr.equals(destinazione.getID())) {
		
		} else {
			list.clear();
			list = new LinkedList<ACLSEL>();

		}
		return;
	}
	
	//-------------------------------------------------------------------------------------------------------------
	
	/**
	 * Metodo che crea un nuovo gruppo e crea i token necessari a raggiungerlo
	 * 
	 * @param AccessGraph
	 *            accessGraph - grafico di accesso alle risorse
	 * @param String
	 *            newGroup - ID del gruppo da inserire
	 * @param byte[] newKey - Chiave del gruppo
	 * 
	 * @return ASSENTE
	 * @throws JSONException 
	 * 
	 */

	private JSONObject createTokenToEncrypt(AccessGraph accessGraph, String newGroup) throws JSONException {

		ACL newAcl = new ACL();
		accessGraph.CaricaIntervalli();
		JSONObject response = new JSONObject();
		JSONArray array = new JSONArray();
		
		for (int a = 0; a < authList.length; a++) {
			newAcl.addUser(authList[a].getID());
		}

		LinkedList<String> userList = newAcl.getUserList();
				
		if (newAcl.getSize() > 2)
		{
			// controllo che ci siano tutti i gruppi da due di partenza da cui
			// partire
			LinkedList<ACL> antenati = new LinkedList<ACL>();
			for (int i = 0; i < userList.size(); i++) {
				if (!userList.get(i).equals(ownerID.toString()))
				// creo lista con tutti gli antenati che servono
				{
					ACL nuovo = new ACL();
					nuovo.addUser(userList.get(i));
					nuovo.addUser(ownerID.toString());
					antenati.add(nuovo);
				}
			}
			
			for (int i = 0; i < antenati.size(); i++) {
				if (!accessGraph.getAllAcl().contains(antenati.get(i)))
				{
					accessGraph.addAcl(antenati.get(i));
				}
			}
		}
		
		LinkedList<ACL> giafatto = new LinkedList<ACL>();
		LinkedList<ACL> list = new LinkedList<ACL>();
		
		for (int i = newAcl.getSize() - 1; i > 1; --i) {
			list = accessGraph.getAclListBySize(i);
			if (list != null) {
				for (int j = 0; j < list.size(); ++j) {
					if (list.get(j).getUserList().contains(ownerID.toString()))
						if (newAcl.contains(list.get(j)) && (!ingiafatto(list.get(j), giafatto))) {
							list.get(j).addDescendent(newAcl);
							newAcl.addAncestor(list.get(j));
							//chiavi pub e priv x il dh
							JSONObject keys = getTokenToEncrypt(list.get(j).getID(), accessGraph);
							
							//se si parte da un gruppo pre-esistente, resitutisco i token ok
							AccessGraph temp = new AccessGraph(1);
							temp.CaricaIntervalli();
							if (list.get(j).getSize() > 2)
								keys = getExistentTokenToEncrypt(list.get(j).getID(), temp);
							
							//creo l'oggetto json per il token corrente
							JSONObject ob = new JSONObject();
							ob.put("private", keys.get("private"));
							ob.put("public", keys.get("public"));
							ob.put("grpsrc", list.get(j).getID());
							ob.put("grpdst", newGroup);
							ob.put("tokens", keys.get("tokens"));
							array.put(ob);
							
							giafatto.add(list.get(j));
						}

				}
			}
		}

		response.put("values", array);
		return response;
	}
	
	/**
	 * Metodo che recupera la chiave a partire dal suo id grazie all'utilizzo
	 * dei token memorizzati nel DB, quando si conosce la chiave del
	 * proprietario
	 * 
	 * @param ASSENTE
	 * @param ASSENTE
	 * 
	 * @return byte[] - Vettore di byte contenente la chiave ricavata
	 * 
	 */
	private JSONObject getTokenToEncrypt(String keyID, AccessGraph accessgraph) {
		
		byte[] aesKey = null;
		String key = keyID;
		Token newToken;
		DBConnection connection = new DBConnection();
		ACL antenato = new ACL();
		LinkedList<Token> tokenPath = new LinkedList<Token>();
		
		//RETURN
		JSONObject ob = new JSONObject();
		JSONArray array = new JSONArray();
		JSONObject temp = new JSONObject();
		
		try {

			ACL acl = new ACL();
			acl = accessgraph.getACLfromID(key);

			LinkedList<String> codici = new LinkedList<String>();
			codici = acl.getUserList();
			LinkedList<ACL> foglie = new LinkedList<ACL>();
			foglie = accessgraph.getAclListBySize(2);
			String userid = new String();
			if (acl.getSize() == 2)// gruppo da due utenti,chiave da DH
			{
				if (acl.getUserList().get(0).equals(ownerID.toString())) {
					userid = acl.getUserList().get(1);
				}
				if (acl.getUserList().get(1).equals(ownerID.toString())) {
					userid = acl.getUserList().get(0);
				}
				
				//restituisco i dati per fare il diffie hellman in c++ ----------------------------------
				
				Statement stmt = connection.getConnection().createStatement(
						ResultSet.TYPE_SCROLL_INSENSITIVE,
						ResultSet.CONCUR_UPDATABLE);
				ResultSet rset = stmt
						.executeQuery("SELECT privatekey from dhkatable where subjectid = " + ownerID.toString());
				rset.first();
				
				ob.put("private", rset.getString(1));

				rset = stmt
					.executeQuery("SELECT publickey from dhkatable where subjectid = " + userid);
				rset.first();
				 
				ob.put("public", rset.getString(1));
				ob.put("tokens", array);
				 
								 
//---------------------------------------------------------------------------------------				  

			} else {

				// trovo un antenato per la destinazione che cerco
				for (int i = 0; i < foglie.size(); ++i) {
					LinkedList<String> list = new LinkedList<String>();
					list = foglie.get(i).getUserList();

					if (ownerID.toString().equals(list.get(0))) {
						for (int j = 0; j < codici.size(); ++j)
							if (list.get(1).equals(codici.get(j)))
								antenato = foglie.get(i);
					}
					if (ownerID.toString().equals(list.get(1))) {
						for (int j = 0; j < codici.size(); ++j)
							if (list.get(0).equals(codici.get(j)))
								antenato = foglie.get(i);
					}

				}
								
				LinkedList<ACL> percorso = new LinkedList<ACL>();
				// trovo percorso di acl da antenato a destinazione
				esplora_albero(accessgraph, antenato.getID(), percorso, acl);
				
				Statement stmt = connection.getConnection().createStatement(
						ResultSet.TYPE_SCROLL_INSENSITIVE,
						ResultSet.CONCUR_UPDATABLE);
				ResultSet rset = stmt
						.executeQuery("SELECT groupidsource,groupiddestination,token,label from tokentable where level = 'SEL'");
				for (int j = 0; j < percorso.size() - 1; j++) {
					
					rset.first();
					do {

						if ((rset.getString(1).equals(percorso.get(j).getID()))
								&& (rset.getString(2).equals(percorso
										.get(j + 1).getID()))) {
							temp.put("token", rset.getString(3));
							temp.put("label", rset.getString(4));
							array.put(temp);

						}
					} while (rset.next());
				}

				// recupero la chiave di partenza dalla tabella di DH

				if (antenato.getUserList().get(0).equals(ownerID.toString())) {
					userid = antenato.getUserList().get(1);
				}
				if (antenato.getUserList().get(1).equals(ownerID.toString())) {
					userid = antenato.getUserList().get(0);
				}
				
				//restituisco i dati per fare il diffie hellman in c++ ----------------------------------

				rset = stmt
						.executeQuery("SELECT privatekey from dhkatable where subjectid = " + ownerID.toString());
				rset.first();
				
				ob.put("private", rset.getString(1));

				rset = stmt
					.executeQuery("SELECT publickey from dhkatable where subjectid = " + userid);
				rset.first();
				 
				ob.put("public", rset.getString(1));
				
				ob.put("tokens", array);
			}

		} catch (Exception e) {
			System.err.println(e.toString());
		}
		connection.closeConnection();

		return ob;
	}
	
	
	
	
private JSONObject getTokenToDecrypt(String keyID, AccessGraph accessgraph) {
		
		byte[] aesKey = null;
		String key = keyID;
		Token newToken;
		DBConnection connection = new DBConnection();
		ACL antenato = new ACL();
		LinkedList<Token> tokenPath = new LinkedList<Token>();
		
		//RETURN
		JSONObject ob = new JSONObject();
		JSONArray array = new JSONArray();
		JSONObject temp = new JSONObject();
		
		try {

			ACL acl = new ACL();
			acl = accessgraph.getACLfromID(key);

			LinkedList<String> codici = new LinkedList<String>();
			codici = acl.getUserList();
			LinkedList<ACL> foglie = new LinkedList<ACL>();
			foglie = accessgraph.getAclListBySize(2);
			String userid = new String();
			if (acl.getSize() == 2)// gruppo da due utenti,chiave da DH
			{
				if (acl.getUserList().get(0).equals(ownerID.toString())) {
					userid = acl.getUserList().get(1);
				}
				if (acl.getUserList().get(1).equals(ownerID.toString())) {
					userid = acl.getUserList().get(0);
				}
				
				//restituisco i dati per fare il diffie hellman in c++ ----------------------------------
				
				Statement stmt = connection.getConnection().createStatement(
						ResultSet.TYPE_SCROLL_INSENSITIVE,
						ResultSet.CONCUR_UPDATABLE);
				ResultSet rset = stmt
						.executeQuery("SELECT privatekey from dhkatable where subjectid = " + userid);
				rset.first();
				
				ob.put("private", rset.getString(1));

				
				
				rset = stmt
					.executeQuery("SELECT publickey from dhkatable where subjectid = " + userID);
				rset.first();
				 
				ob.put("public", rset.getString(1));
				ob.put("tokens", array);
				 
								 
//---------------------------------------------------------------------------------------				  

			} else {

				// trovo un antenato per la destinazione che cerco
				for (int i = 0; i < foglie.size(); ++i) {
					LinkedList<String> list = new LinkedList<String>();
					list = foglie.get(i).getUserList();

					if (ownerID.toString().equals(list.get(0))) {
						for (int j = 0; j < codici.size(); ++j)
							if (list.get(1).equals(codici.get(j)))
								antenato = foglie.get(i);
					}
					if (ownerID.toString().equals(list.get(1))) {
						for (int j = 0; j < codici.size(); ++j)
							if (list.get(0).equals(codici.get(j)))
								antenato = foglie.get(i);
					}

				}
								
				LinkedList<ACL> percorso = new LinkedList<ACL>();
				// trovo percorso di acl da antenato a destinazione
				esplora_albero(accessgraph, antenato.getID(), percorso, acl);
				
				Statement stmt = connection.getConnection().createStatement(
						ResultSet.TYPE_SCROLL_INSENSITIVE,
						ResultSet.CONCUR_UPDATABLE);
				ResultSet rset = stmt
						.executeQuery("SELECT groupidsource,groupiddestination,token,label from tokentable where level = 'SEL'");
				for (int j = 0; j < percorso.size() - 1; j++) {
					
					rset.first();
					do {

						if ((rset.getString(1).equals(percorso.get(j).getID()))
								&& (rset.getString(2).equals(percorso
										.get(j + 1).getID()))) {
							temp.put("token", rset.getString(3));
							temp.put("label", rset.getString(4));
							array.put(temp);

						}
					} while (rset.next());
				}

				// recupero la chiave di partenza dalla tabella di DH

				if (antenato.getUserList().get(0).equals(ownerID.toString())) {
					userid = antenato.getUserList().get(1);
				}
				if (antenato.getUserList().get(1).equals(ownerID.toString())) {
					userid = antenato.getUserList().get(0);
				}
				
				//restituisco i dati per fare il diffie hellman in c++ ----------------------------------

				rset = stmt
						.executeQuery("SELECT privatekey from dhkatable where subjectid = " + ownerID.toString());
				rset.first();
				
				ob.put("private", rset.getString(1));

				rset = stmt
					.executeQuery("SELECT publickey from dhkatable where subjectid = " + userid);
				rset.first();
				 
				ob.put("public", rset.getString(1));
				
				ob.put("tokens", array);
			}

		} catch (Exception e) {
			System.err.println(e.toString());
		}
		connection.closeConnection();

		return ob;
	}
	
	

	/**
	 * Metodo che recupera la chiave a partire dal suo id grazie all'utilizzo
	 * dei token memorizzati nel DB, quando si conosce la chiave del
	 * proprietario
	 * 
	 * @param ASSENTE
	 * @param ASSENTE
	 * 
	 * @return byte[] - Vettore di byte contenente la chiave ricavata
	 * se server = false inverto pub e privata
	 */
	private JSONObject getExistentTokenToDecrypt(String keyID, AccessGraph accessgraph, boolean server) {
		
		String key = keyID;
		DBConnection connection = new DBConnection();
		ACL antenato = new ACL();
		
		//RETURN
		JSONObject ob = new JSONObject();
		JSONArray array = new JSONArray();
		JSONObject temp = new JSONObject();
		
		try {
				
			ACL acl = new ACL();
			acl = accessgraph.getACLfromID(key);

			String userid = new String();

			//if (acl.getSize() == 2)// gruppo da due utenti,chiave da DH
			if (groupLength(key) == 2)
			{
				
				/*if (acl.getUserList().get(0).equals(ownerID.toString())) {
					userid = acl.getUserList().get(1);
				}
				if (acl.getUserList().get(1).equals(ownerID.toString())) {
					userid = acl.getUserList().get(0);
				}*/
				
				userid = userID;
				
				//restituisco i dati per fare il diffie hellman in c++ ----------------------------------
				
				Statement stmt = connection.getConnection().createStatement(
						ResultSet.TYPE_SCROLL_INSENSITIVE,
						ResultSet.CONCUR_UPDATABLE);
				ResultSet rset = stmt
						.executeQuery("SELECT privatekey from dhkatable where subjectid = " + userid);
				rset.first();
				
				ob.put("private", rset.getString(1));

				rset = stmt
					.executeQuery("SELECT publickey from dhkatable where subjectid = " + ownerID);
				rset.first();
				 
				ob.put("public", rset.getString(1));
				ob.put("tokens", array);
				 
//---------------------------------------------------------------------------------------				  

			} else {

				String idPubblica = null;
				String idPrivata = null;
				// NEW! calcolo il gruppo sorgente da destinazione!!!!
				String corr = keyID;
				String dest = keyID;
				String currentGroup = "";
				do {
					ACL tempAcl = accessgraph.getACLfromID(dest);
					for (int i = 0; i < tempAcl.getAncestor().size(); ++i) {
						currentGroup = tempAcl.getAncestor().get(i).getID();
						if (groupContainsUser(currentGroup, userID) && (groupLength(currentGroup) < groupLength(dest))) {
							dest = currentGroup;
						}
					}
				}  while (groupLength(dest) > 2);
				
				antenato = accessgraph.getACLfromID(dest);
				//-------------------------------------------------------------
				//lato server -> userID pubblica, ownerID privata
				//lato client -> userID privata, ownerID pubblica
				if(server == true) {
					if (userID.equals(antenato.getUserList().get(0))) {
						idPrivata = antenato.getUserList().get(1);
						idPubblica = antenato.getUserList().get(0);
					}  else if(userID.equals(antenato.getUserList().get(1))) {
						idPrivata = antenato.getUserList().get(0);
						idPubblica = antenato.getUserList().get(1);
					}
				} else {
						if (userID.equals(antenato.getUserList().get(0))) {
							idPrivata = antenato.getUserList().get(0);
							idPubblica = antenato.getUserList().get(1);
						}  else if(userID.equals(antenato.getUserList().get(1))) {
							idPrivata = antenato.getUserList().get(1);
							idPubblica = antenato.getUserList().get(0);
						}
				}
				
				LinkedList<ACL> percorso = new LinkedList<ACL>();
				// trovo percorso di acl da antenato a destinazione
				esplora_albero(accessgraph, antenato.getID(), percorso, acl);
				
				

				Statement stmt = connection.getConnection().createStatement(
						ResultSet.TYPE_SCROLL_INSENSITIVE,
						ResultSet.CONCUR_UPDATABLE);
				ResultSet rset = stmt
						.executeQuery("SELECT groupidsource,groupiddestination,token,label from tokentable where level = 'SEL'");
				for (int j = 0; j < percorso.size() - 1; j++) {

					
					rset.first();
					do {

						if ((rset.getString(1).equals(percorso.get(j).getID()))
								&& (rset.getString(2).equals(percorso
										.get(j + 1).getID()))) {

							temp = new JSONObject();
							
							temp.put("token", rset.getString(3));
							temp.put("label", rset.getString(4));
							
							array.put(temp);

						}
					} while (rset.next());
				}
				
				//restituisco i dati per fare il diffie hellman in c++ ----------------------------------

				rset = stmt
						.executeQuery("SELECT privatekey from dhkatable where subjectid = " + idPrivata);
				rset.first();
				
				ob.put("private", rset.getString(1));

				
				rset = stmt
					.executeQuery("SELECT publickey from dhkatable where subjectid = " + idPubblica);
				rset.first();
				 
				ob.put("public", rset.getString(1));

				ob.put("tokens", array);
				
			}

		} catch (Exception e) {
			System.err.println(e.toString());
		}
		connection.closeConnection();

		return ob;
	}
	
	/**
	 * metodo che restituisce true se il gruppo contiene l'utente
	 * false altrimeni
	 */
	private boolean groupContainsUser(String group, String user) {
		StringTokenizer users = new StringTokenizer(group,"-");
        while (users.hasMoreTokens())
        {
        	if (users.nextToken().equals(user))
        		return true;
        }
		return false;
	}
	
	/**
	 * metodo che restituisce la lunghezza di un gruppo
	 */
	private int groupLength(String group) {
		StringTokenizer users = new StringTokenizer(group,"-");
		return users.countTokens();
	}
	/**
	 * Metodo che recupera la chiave a partire dal suo id grazie all'utilizzo
	 * dei token memorizzati nel DB, quando si conosce la chiave del
	 * proprietario
	 * 
	 * @param ASSENTE
	 * @param ASSENTE
	 * 
	 * @return byte[] - Vettore di byte contenente la chiave ricavata
	 * 
	 */
	private JSONObject getExistentTokenToEncrypt(String keyID, AccessGraph accessgraph) {
		
		byte[] aesKey = null;
		String key = keyID;
		Token newToken;
		DBConnection connection = new DBConnection();
		ACL antenato = new ACL();
		LinkedList<Token> tokenPath = new LinkedList<Token>();
		
		//RETURN
		JSONObject ob = new JSONObject();
		JSONArray array = new JSONArray();
		JSONObject temp = new JSONObject();
		
		try {

			ACL acl = new ACL();
			acl = accessgraph.getACLfromID(key);

			LinkedList<String> codici = new LinkedList<String>();
			codici = acl.getUserList();
			LinkedList<ACL> foglie = new LinkedList<ACL>();
			foglie = accessgraph.getAclListBySize(2);
			String userid = new String();
			if (acl.getSize() == 2)// gruppo da due utenti,chiave da DH
			{
				if (acl.getUserList().get(0).equals(ownerID.toString())) {
					userid = acl.getUserList().get(1);
				}
				if (acl.getUserList().get(1).equals(ownerID.toString())) {
					userid = acl.getUserList().get(0);
				}
				
				//restituisco i dati per fare il diffie hellman in c++ ----------------------------------
				
				Statement stmt = connection.getConnection().createStatement(
						ResultSet.TYPE_SCROLL_INSENSITIVE,
						ResultSet.CONCUR_UPDATABLE);
				ResultSet rset = stmt
						.executeQuery("SELECT privatekey from dhkatable where subjectid = " + ownerID.toString());
				rset.first();
				
				ob.put("private", rset.getString(1));

				rset = stmt
					.executeQuery("SELECT publickey from dhkatable where subjectid = " + userid);
				rset.first();
				 
				ob.put("public", rset.getString(1));
				ob.put("tokens", array);
				 
								 
//---------------------------------------------------------------------------------------				  

			} else {
				
				// NEW!!!!!!! calcolo il gruppo sorgente da destinazione!!!!
				String corr = keyID;
				String dest = keyID;
				String currentGroup = "";
				do {
					ACL tempAcl = accessgraph.getACLfromID(dest);
					for (int i = 0; i < tempAcl.getAncestor().size(); ++i) {
						currentGroup = tempAcl.getAncestor().get(i).getID();
						if (groupContainsUser(currentGroup, ownerID) && (groupLength(currentGroup) < groupLength(dest))) {
							dest = currentGroup;
						}
					}
				}  while (groupLength(dest) > 2);
				
				antenato = accessgraph.getACLfromID(dest);
								
				LinkedList<ACL> percorso = new LinkedList<ACL>();
				// trovo percorso di acl da antenato a destinazione
				esplora_albero(accessgraph, antenato.getID(), percorso, acl);

				Statement stmt = connection.getConnection().createStatement(
						ResultSet.TYPE_SCROLL_INSENSITIVE,
						ResultSet.CONCUR_UPDATABLE);
				ResultSet rset = stmt
						.executeQuery("SELECT groupidsource,groupiddestination,token,label from tokentable where level = 'SEL'");
				for (int j = 0; j < percorso.size() - 1; j++) {
					
	
					rset.first();
					do {

						if ((rset.getString(1).equals(percorso.get(j).getID()))
								&& (rset.getString(2).equals(percorso
										.get(j + 1).getID()))) {
							temp = new JSONObject();
							temp.put("token", rset.getString(3));
							temp.put("label", rset.getString(4));
							array.put(temp);

						}
					} while (rset.next());
				}

				// recupero la chiave di partenza dalla tabella di DH

				if (antenato.getUserList().get(0).equals(ownerID.toString())) {
					userid = antenato.getUserList().get(1);
				}
				if (antenato.getUserList().get(1).equals(ownerID.toString())) {
					userid = antenato.getUserList().get(0);
				}
				
				//restituisco i dati per fare il diffie hellman in c++ ----------------------------------

				rset = stmt
						.executeQuery("SELECT privatekey from dhkatable where subjectid = " + ownerID);
				rset.first();
				
				ob.put("private", rset.getString(1));

				rset = stmt
					.executeQuery("SELECT publickey from dhkatable where subjectid = " + userid);
				rset.first();
				 
				ob.put("public", rset.getString(1));
				
				for (int i = 0; i < tokenPath.size(); i++) {
					 
					//aesKey = Token.rebuildKey(aesKey, tokenPath.get(i)
					//		.getToken(), tokenPath.get(i).getLabel());
				}
				
				ob.put("tokens", array);
			}

		} catch (Exception e) {
			System.err.println(e.toString());
		}
		connection.closeConnection();

		return ob;
	}
	
	
	public final static String getWinPath(){
		if(configPath.equals("")){
			Properties properties = new Properties();
			try {
	        	FileInputStream dd = new FileInputStream("ioverenc.conf");
	                properties.load(dd);
	                configPath = properties.getProperty("serverpath");
	                dd.close();
			} catch (Exception e) {
				configPath ="";
			}
		}
		return configPath;
	}
	
	public static final String getOS(){
		
		String nameOS = System.getProperty("os.name");
		String mystr;
		if(nameOS.startsWith("Windows"))
			mystr = new String("win");
		else if(nameOS.startsWith("Linux"))
			mystr = new String("linux");
		else if(nameOS.startsWith("Mac"))
			mystr = new String("mac");
		else 
			mystr = new String("unknow");
	    return mystr;
	}
	
	public static boolean putTokensInDB() throws Exception {
		// i formati dei file jsoninout e jsonin sono diversi 
		String input = "";
		
		String path = "";
		if(getOS().equals("win"))
			path = getWinPath() + "executable\\jsoninout.txt";
		else
			path = getPath() + "executable/jsoninout.txt";
		
		File file = new File(path);
	    

		FileInputStream fis = null;
	    BufferedInputStream bis = null;
	    DataInputStream dis = null;

	    try {
	      fis = new FileInputStream(file);
	      // Here BufferedInputStream is added for fast reading.
	      bis = new BufferedInputStream(fis);
	      dis = new DataInputStream(bis);
	      // dis.available() returns 0 if the file does not have more lines.
	      while (dis.available() != 0) {
	        // this statement reads the line from the file and print it to
	        // the console.
		input = input + dis.readLine();
	      }
	      // dispose all the resources after using them.
	      dis.close();
	      bis.close();
	      fis.close();
	    } catch (FileNotFoundException e) {
	        e.printStackTrace();
	    } catch (IOException e) {
	        e.printStackTrace();
	    }

		Connection NewUserConnection = Configuration.getConnection();
		Statement stmt = NewUserConnection.createStatement();

		JSONObject tokens = new JSONObject(input);
		JSONArray array = tokens.getJSONArray("values");
		JSONObject temp;
		
		try {
			for (int i=0; i<array.length(); i++) {
				
				temp = array.getJSONObject(i);
				String ss = "Insert into tokentable (groupidsource,groupiddestination,token,label,level)";
				ss = ss + "values ( '" + temp.getString("grpsrc") + "','";
				ss = ss + temp.getString("grpdst") + "','";
				ss = ss + temp.getString("token") + "','";
				ss = ss + temp.getString("label") + "','" + "SEL')";
				stmt.execute(ss);
			}
			stmt.close();
			
			accessGraph = new AccessGraph(1);
			accessGraph.CreaIntervalli();
			
		} catch (Exception e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}
	
	
	/**
	 * Metodo pubblico che cripta il File a livello BEL (Base Encrypt Level) e
	 * lo salva su hard creando se necessario gli opportuni token per la
	 * derivazione delle chiavi
	 * 
	 * @param ASSENTE
	 * 
	 * @return ASSENTE
	 * @throws Exception 
	 * @throws SQLException 
	 * 
	 */
	public JSONObject getJSONSEL(String fileId, String userId, boolean server) throws SQLException, Exception {

		accessGraph = new AccessGraph(1);

		ACL newAcl = new ACL();

		Statement stmt = Configuration.getConnection().createStatement(
				ResultSet.TYPE_SCROLL_INSENSITIVE,
				ResultSet.CONCUR_UPDATABLE);
		ResultSet rset = stmt
				.executeQuery("SELECT * from filetable where objectid = " + fileId);
		rset.first();
		
				
		//this.ownerID = ownerID;
		this.userID = userId;

		//cambio l'id dello user se l'utente � il proprietario
		if(ownerID.toString().equals(userId)) { //scarico un file condivido di cui sono il proprietario
			StringTokenizer tempStringTokenizer = new StringTokenizer(rset.getString("keyidsel"), "-");
			String tempToken;
			while (tempStringTokenizer.hasMoreTokens()) {
				tempToken = (String)tempStringTokenizer.nextElement();
	            if (!tempToken.equals(ownerID.toString())) {
	            	break;
	            }
	            
	        }
		}
		
		

		//aggiungo gli utenti alla lista
		StringTokenizer tempStringTokenizer = new StringTokenizer(rset.getString("keyidsel"), "-");
		UserListElement[] userAuth = new UserListElement[tempStringTokenizer.countTokens()];
		int cont = 0;
		while (tempStringTokenizer.hasMoreTokens()) {
			userAuth[cont] = new UserListElement((String)tempStringTokenizer.nextElement());
			cont++;
		}
		this.authList = userAuth;
		//---

		
		
		//aggiungo alla lista
		for (int a = 0; a < authList.length; a++) {
			newAcl.addUser(authList[a].getID());
		}
		
		groupIDBEL = newAcl.getID();
		
		LinkedList<String> listcod = new LinkedList<String>();
		for (int t = 0; t < accessGraph.getAllAcl().size(); ++t)
			listcod.add(accessGraph.getAllAcl().get(t).getID());

			//byte[] key = null;
			accessGraph.CaricaIntervalli();
				if (authList.length == 1) {
					JSONObject temp = new JSONObject();
					JSONArray array = new JSONArray();
					temp.put("values", array);
					return temp;
				} else {
			    	JSONObject result = new JSONObject();
		    		JSONArray array = new JSONArray();
		    		JSONObject temp = new JSONObject();
		    	
		    		temp = getExistentTokenToDecrypt(groupIDBEL, accessGraph, server);
		    		temp.put("grpsrc","");
		    		temp.put("grpdst","");
		    		array.put(temp);
		    		result.put("values", array);
					return result;
				}
	}
	
	public JSONObject createJSONSEL(String keysel) throws SQLException, Exception {


		accessGraph = new AccessGraph(1);

		ACL newAcl = new ACL();
		
		for (int a = 0; a < authList.length; a++) {
			newAcl.addUser(authList[a].getID());
		}
		groupIDBEL = newAcl.getID();
		

		LinkedList<String> listcod = new LinkedList<String>();
		for (int t = 0; t < accessGraph.getAllAcl().size(); ++t)
			listcod.add(accessGraph.getAllAcl().get(t).getID());

		if (!listcod.contains(newAcl.getID()))// se non esiste gia questo gruppo
		{
			
			if (authList.length == 1) { // CONDIVIDO IL FILE SOLO CON ME STESSO
				//newKey = ownerKey;
				JSONObject temp = new JSONObject();
				JSONArray array = new JSONArray();
				temp.put("values", array);
				return temp;

			} else {
				accessGraph.addAcl(newAcl);
				if (newAcl.getSize() == 2) // CONDIVIDO IL FILE TRA ME E UN SOLO
											// ALTRO UTENTE
				{
					String userID = null;
					if (newAcl.getUserList().get(0).equals(ownerID.toString()))
						userID = newAcl.getUserList().get(1);
					if (newAcl.getUserList().get(1).equals(ownerID.toString()))
						userID = newAcl.getUserList().get(0);
					
					//----------------------------------------------------------------
					JSONObject temp = new JSONObject();
					
					Statement stmt = Configuration.getConnection().createStatement(
							ResultSet.TYPE_SCROLL_INSENSITIVE,
							ResultSet.CONCUR_UPDATABLE);
					ResultSet rset = stmt
							.executeQuery("SELECT privatekey from dhkatable where subjectid = " + ownerID.toString());
					rset.first();
					
					temp.put("private", rset.getString(1));
					
					rset = stmt
						.executeQuery("SELECT publickey from dhkatable where subjectid = " + userID);
					rset.first();
					 
					temp.put("public", rset.getString(1));
					temp.put("tokens", new JSONArray());
					temp.put("grpsrc","");
		    		        temp.put("grpdst","");
					JSONObject response = new JSONObject();
					JSONArray array = new JSONArray();
					array.put(temp);
					
					response.put("values", array);
					return response;
				} else
					// CONDIVIDO IL FILE CON N UTENTI
					//newKey = CryptoFunction.createKey();
					
				//buildNewKeyTokens(accessGraph, groupIDBEL, newKey);
				try {
					return createTokenToEncrypt(accessGraph, groupIDBEL);
				} catch (JSONException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}

			}
			
		} else {// se il gruppo esiste
			//byte[] key = null;
			accessGraph.CaricaIntervalli();
			
				if (authList.length == 1) {
					JSONObject temp = new JSONObject();
					temp.put("values", "ownerkey");
					return temp;
				} else {
			    	JSONObject result = new JSONObject();
		    		JSONArray array = new JSONArray();
		    		JSONObject temp = new JSONObject();
		    	
		    		temp = getExistentTokenToEncrypt(groupIDBEL, accessGraph);
		    		temp.put("grpsrc","");
		    		temp.put("grpdst","");
		    		array.put(temp);
		    		result.put("values", array);
					return result;
				}
		}
		return null;

	}
	
	public String putJSONFileInDB(String keyidsel) {

		DBConnection connection = new DBConnection();
		String ID;
		try {
			Statement stmt = connection.getConnection().createStatement();

			stmt.execute("Insert into filetable (keyidsel,owner,filename)"
							+ "values ( '"
							+ keyidsel
							+ "','"
							+ ownerID
							+ "','"
							+ filePath + "','')");

			ResultSet rset = stmt
					.executeQuery("SELECT max(objectID) from filetable");

			rset.next();
			ID = rset.getString(1);

			rset.close();
			stmt.close();
			
			return ID;

		} catch (Exception e) {
			System.err.println(e.toString());
			return "";
		}
	}
	
	
	/**
	 * Restituisce la lista dei proprietari di file che hanno condiviso almeno
	 * un file con l'utente con l'ID specificato
	 * 
	 * @param userID
	 *            - ID dell'utente
	 * @return LinkedList<UserListElement> - la lista dei proprietari di file
	 *         che hanno condiviso almeno un file
	 * @throws JSONException 
	 */
	public static JSONObject getFriendList(String userID) throws JSONException {

		//LinkedList<UserListElement> ownerList = new LinkedList<UserListElement>();
		JSONObject response = new JSONObject();
		JSONArray array = new JSONArray();
		
		DBConnection connection = new DBConnection();
		LinkedList<String> proprietari = new LinkedList<String>();
		try {
			Statement stmt = connection.getConnection().createStatement();
			ResultSet rset = stmt
					.executeQuery("SELECT keyidsel,keyidsel,owner from filetable");

			if (rset != null) {
				while (rset.next()) {

					StringTokenizer group = new StringTokenizer(rset
							.getString(1), "-");
					LinkedList<String> list = new LinkedList<String>();
					if ((rset.getString(2) == null)
							|| (rset.getString(2).equals(""))
							|| (controllaALL(rset.getString(2), userID))) {

						// se codice utente è contenuto nel gruppo metto il
						// proprietario nella lista
						if ((controllaALL(rset.getString(2), userID))
								&& (rset.getString(1).equals("ALL"))) {
							proprietari.add(rset.getString(3));

						} else {
							if (((rset.getString(1).equals("ALL")))
									&& (rset.getString(2).equals("")))
								proprietari.add(rset.getString(3));

							while (group.hasMoreTokens()) {
								list.add(group.nextToken());
							}
							if (list.contains(userID))
								proprietari.add(rset.getString(3));
						}
					} else {
						if (((controllaALL(rset.getString(2), userID)) && (rset
								.getString(1).equals("ALL")))
								|| (!rset.getString(1).equals("ALL"))) {
							// stessa cosa per token SEL
							group = new StringTokenizer(rset.getString(2), "-");
							list = new LinkedList<String>();
							while (group.hasMoreTokens()) {
								list.add(group.nextToken());
							}
							if (list.contains(userID))
								proprietari.add(rset.getString(3));

						}
					}
				}
			}

			rset = stmt
					.executeQuery("SELECT subjectid,name,surname from usertable order by surname, name");

			if (rset != null) {
				while (rset.next()) {
					if (proprietari.contains(rset.getString(1))) {
						JSONObject temp = new JSONObject();
						temp.put("id", rset.getString(1));
						temp.put("name", rset.getString(2));
						temp.put("surname", rset.getString(3));
						array.put(temp);
					}
				}
			}

			rset.close();
			stmt.close();

		} catch (Exception e) {
			System.err.println(e.toString());
		}
		connection.closeConnection();

		response.put("values", array);
		return response;
	}
	
	/**
	 * Metodo che restituisce la lista dei file condivisi da un proprietario
	 * specificato a un determinato utente
	 * 
	 * @param String
	 *            userID - Utente con cui vengono condivisi i file
	 * @param String
	 *            ownerID - Utente che condivide i file
	 * 
	 * @return LinkedList<FileListElement> - Lista file condivisi
	 * @throws JSONException 
	 * 
	 */
	public static JSONObject getFilesOfFriend(String userID, String ownerID) throws JSONException {

		LinkedList<FileListElement> fileList = new LinkedList<FileListElement>();

		DBConnection connection = new DBConnection();

		try {
			Statement stmt = connection.getConnection().createStatement();
			ResultSet rset = stmt
					.executeQuery("SELECT keyidsel,keyidsel,objectid,filename from filetable where owner='"
							+ ownerID + "' order by filename");

			if (rset != null) {
				while (rset.next()) {

					// se codice utente è contenuto nel gruppo metto il
					// proprietario nella lista
					StringTokenizer group = new StringTokenizer(rset
							.getString(1), "-");
					LinkedList<String> list = new LinkedList<String>();

					if ((rset.getString(2) == null)
							|| (rset.getString(2).equals(""))
							|| (controllaALL(rset.getString(2), userID))) {
						if ((controllaALL(rset.getString(2), userID))
								&& (rset.getString(1).equals("ALL")))

						{
							FileListElement fle = new FileListElement(rset
									.getString(3), rset.getString(4), rset
									.getString(1), rset.getString(2), ownerID);
							fileList.add(fle);

						} else {
							if ((rset.getString(1).equals("ALL"))
									&& (rset.getString(2).equals(""))) {
								FileListElement fle = new FileListElement(rset
										.getString(3), rset.getString(4), rset
										.getString(1), rset.getString(2),
										ownerID);
								fileList.add(fle);
							}

							if (((controllaALL(rset.getString(2), userID)) && (rset
									.getString(1).equals("ALL")))
									|| (!rset.getString(1).equals("ALL"))) {
								while (group.hasMoreTokens()) {
									list.add(group.nextToken());
								}

								if (list.contains(userID)) {
									FileListElement fle = new FileListElement(
											rset.getString(3), rset
													.getString(4), rset
													.getString(1), rset
													.getString(2), ownerID);
									fileList.add(fle);
								}
							}
						}
					} else {
						// stessa cosa per token SEL
						group = new StringTokenizer(rset.getString(2), "-");
						list = new LinkedList<String>();
						while (group.hasMoreTokens()) {
							list.add(group.nextToken());
						}
						if ((list.contains(userID))
								&& (!list.get(0).equals("ALL"))) {
							FileListElement fle = new FileListElement(rset
									.getString(3), rset.getString(4), rset
									.getString(1), rset.getString(2), ownerID);
							fileList.add(fle);
						}

					}
				}
			}
			rset.close();
			stmt.close();

		} catch (Exception e) {
			System.err.println(e.toString());
		}
		connection.closeConnection();

		JSONObject JSONfileList = new JSONObject();
		JSONArray fileArray = new JSONArray();
		
		for (int i=0; i < fileList.size(); i++) {
			JSONObject temp = new JSONObject();
			temp.put("fileName", fileList.get(i).getFileName());
			temp.put("keyidsel", fileList.get(i).getFileIDKeyBEL());
			temp.put("keyIdSel", fileList.get(i).getFileIDKeySEL());
			temp.put("fileId", fileList.get(i).getID());
			fileArray.put(temp);
		}
		JSONfileList.put("values", fileArray);
		return JSONfileList;

	}
	

	/**
	 * Metodo che recupera la chiave a partire dal suo id grazie all'utilizzo
	 * dei token memorizzati nel DB, quando si conosce la chiave del
	 * proprietario
	 * 
	 * @param ASSENTE
	 * @param ASSENTE
	 * 
	 * @return byte[] - Vettore di byte contenente la chiave ricavata
	 * 
	 */
	public static byte[] getKeyFromOwnerKey(String keyID,
			AccessGraph accessgraph, String ownerID, String userid) {

		byte[] aesKey = null;
		String key = keyID;
		Token newToken;
		DBConnection connection = new DBConnection();
		ACL antenato = new ACL();
		LinkedList<Token> tokenPath = new LinkedList<Token>();

		try {

			ACL acl = new ACL();
			acl = accessgraph.getACLfromID(key);

			LinkedList<String> codici = new LinkedList<String>();
			codici = acl.getUserList();
			LinkedList<ACL> foglie = new LinkedList<ACL>();
			foglie = accessgraph.getAclListBySize(2);
			// String userid= new String();
			if (acl.getSize() == 2)// gruppo da due utenti,chiave da DH
			{
				aesKey = DHKeyAgreementFunction.buildDHKey(userid, ownerID
						.toString());
			} else {

				// se proprietario scarica i suoi file
				if (ownerID.equals(userid)) {
					LinkedList<ACL> list = accessgraph.getAclListBySize(2);
					boolean trovato = false;
					boolean dentroif = false;
					int i = 0;

					do {
						if (list.get(i).getUserList().get(0).equals(
								ownerID.toString())) {
							dentroif = true;
							userid = list.get(i).getUserList().get(1);
						}
						if (list.get(i).getUserList().get(1).equals(
								ownerID.toString())) {
							dentroif = true;
							userid = list.get(i).getUserList().get(0);
						}
						if ((acl.getUserList().contains(userid)) && (dentroif))
							trovato = true;
						dentroif = false;
						++i;
					} while (!trovato);
				}

				antenato.addUser(ownerID);
				antenato.addUser(userid);
				LinkedList<ACL> percorso = new LinkedList<ACL>();

				// trovo percorso di acl da antenato a destinazione
				esplora_albero(accessgraph, antenato.getID(), percorso, acl);

				Statement stmt = connection.getConnection().createStatement(
						ResultSet.TYPE_SCROLL_INSENSITIVE,
						ResultSet.CONCUR_UPDATABLE);
				ResultSet rset = stmt
						.executeQuery("SELECT groupidsource,groupiddestination,token,label from tokentable where level = 'BEL'");
				for (int j = 0; j < percorso.size() - 1; j++) {
					rset.first();
					do {

						if ((rset.getString(1).equals(percorso.get(j).getID()))
								&& (rset.getString(2).equals(percorso
										.get(j + 1).getID()))) {
							newToken = new Token(rset.getString(1), rset
									.getString(2), Conversion.toBytes(rset
									.getString(3)), rset.getString(4));
							tokenPath.add(newToken);

						}
					} while (rset.next());
				}

				aesKey = DHKeyAgreementFunction.buildDHKey(userid, ownerID
						.toString());

				for (int i = 0; i < tokenPath.size(); i++) {

					aesKey = Token.rebuildKey(aesKey, tokenPath.get(i)
							.getToken(), tokenPath.get(i).getLabel());
				}
			}

		} catch (Exception e) {
			System.err.println(e.toString());
		}
		connection.closeConnection();

		return aesKey;
	}

	/**
	 * Salvo il nome del file nel DB con l'id della chiave che l'ha criptato a
	 * livello BEL
	 * 
	 * @param String
	 *            fileName - Nome del file
	 * @param String
	 *            keyidsel - ID della chiave che ha criptato il file a livello
	 *            BEL
	 * 
	 * @return boolean - True -> Inserimento riuscito con successo False ->
	 *         Inserimento non riuscito
	 */
	public boolean putFileInDB(String keyidsel, String keysel) {

		DBConnection connection = new DBConnection();
		String ID;
		try {
			Statement stmt = connection.getConnection().createStatement();

			stmt
					.execute("Insert into filetable (keyidsel,owner,filename,keyidsel)"
							+ "values ( '"
							+ keyidsel
							+ "','"
							+ ownerID
							+ "','"
							+ getFileName(filePath) + "','" + keysel + "')");

			ResultSet rset = stmt
					.executeQuery("SELECT objectID from filetable where keyidsel = '"
							+ keyidsel
							+ "' and owner = '"
							+ ownerID
							+ "' and filename ='" + getFileName(filePath) + "'");

			rset.next();
			ID = rset.getString(1);
			Rename("BEL_File" + File.separatorChar + "To Send"
					+ File.separatorChar + "BEL_" + getFileName(filePath),
					"BEL_File" + File.separatorChar + "To Send"
							+ File.separatorChar + "BEL_" + ID);
			fileID = ID;
			rset.close();
			stmt.close();

		} catch (Exception e) {
			System.err.println(e.toString());
			return false;
		}

		return true;
	}

	public static String putFileInDB(String keyidsel, String ownerID,
			String filePath, String keysel) {

		DBConnection connection = new DBConnection();
		String ID = null;
		try {
			Statement stmt = connection.getConnection().createStatement();

			stmt
					.execute("Insert into filetable (keyidsel,owner,filename,keyidsel)"
							+ "values ( '"
							+ keyidsel
							+ "','"
							+ ownerID
							+ "','"
							+ getFileName(filePath) + "','" + keysel + "')");

			ResultSet rset = stmt
					.executeQuery("SELECT objectID from filetable where keyidsel = '"
							+ keyidsel
							+ "' and owner = '"
							+ ownerID
							+ "' and filename ='" + getFileName(filePath) + "'");

			rset.next();
			ID = rset.getString(1);
			Rename("BEL_File" + File.separatorChar + "To Send"
					+ File.separatorChar + "BEL_" + getFileName(filePath),
					"BEL_File" + File.separatorChar + "To Send"
							+ File.separatorChar + "BEL_" + ID);

			rset.close();
			stmt.close();

		} catch (Exception e) {
			System.err.println(e.toString());

		}

		return ID;
	}

	public static boolean Rename(String nome_prima, String nome_dopo)
			throws IOException {
		File file1 = new File(nome_prima);
		File file2 = new File(nome_dopo);
		boolean success = file1.renameTo(file2);
		return success;
	}

	/**
	 * Metodo che riceve come parametro il path del file e restituisce solo il
	 * nome del file
	 * 
	 * @param String
	 *            path - Path del fiel
	 * 
	 * @return String - Nome del file estratto dal path
	 */
	private static String getFileName(String path) {
		StringBuffer fileName = new StringBuffer();

		for (int c = (path.length() - 1); (c != 0 && path.charAt(c) != File.separatorChar); c--)
			fileName.append(path.charAt(c));

		fileName.reverse();

		return fileName.toString();
	}

	public static boolean controllaALL(String key, String user) {
		StringTokenizer group = new StringTokenizer(key, "-");
		LinkedList<String> list = new LinkedList<String>();
		while (group.hasMoreTokens()) {
			list.add(group.nextToken());
		}
		if (list.size() == 0)
			return false;
		if (!list.get(0).equals("ALL"))
			return false;
		else {
			for (int i = 1; i < list.size(); ++i)
				if (list.get(i).equals(user))
					return false;
			return true;
		}

	}

	/**
	 * Restituisce la lista dei proprietari di file che hanno condiviso almeno
	 * un file con l'utente con l'ID specificato
	 * 
	 * @param userID
	 *            - ID dell'utente
	 * @return LinkedList<UserListElement> - la lista dei proprietari di file
	 *         che hanno condiviso almeno un file
	 */
	public static LinkedList<UserListElement> buildAvailableFileOwnerList(
			String userID) {

		LinkedList<UserListElement> ownerList = new LinkedList<UserListElement>();

		DBConnection connection = new DBConnection();
		LinkedList<String> proprietari = new LinkedList<String>();
		try {
			Statement stmt = connection.getConnection().createStatement();
			ResultSet rset = stmt
					.executeQuery("SELECT keyidsel,keyidsel,owner from filetable");

			if (rset != null) {
				while (rset.next()) {

					StringTokenizer group = new StringTokenizer(rset
							.getString(1), "-");
					LinkedList<String> list = new LinkedList<String>();
					if ((rset.getString(2) == null)
							|| (rset.getString(2).equals(""))
							|| (controllaALL(rset.getString(2), userID))) {

						// se codice utente è contenuto nel gruppo metto il
						// proprietario nella lista
						if ((controllaALL(rset.getString(2), userID))
								&& (rset.getString(1).equals("ALL"))) {
							proprietari.add(rset.getString(3));

						} else {
							if (((rset.getString(1).equals("ALL")))
									&& (rset.getString(2).equals("")))
								proprietari.add(rset.getString(3));

							while (group.hasMoreTokens()) {
								list.add(group.nextToken());
							}
							if (list.contains(userID))
								proprietari.add(rset.getString(3));
						}
					} else {
						if (((controllaALL(rset.getString(2), userID)) && (rset
								.getString(1).equals("ALL")))
								|| (!rset.getString(1).equals("ALL"))) {
							// stessa cosa per token SEL
							group = new StringTokenizer(rset.getString(2), "-");
							list = new LinkedList<String>();
							while (group.hasMoreTokens()) {
								list.add(group.nextToken());
							}
							if (list.contains(userID))
								proprietari.add(rset.getString(3));

						}
					}
				}
			}

			rset = stmt
					.executeQuery("SELECT subjectid,name,surname from usertable");

			if (rset != null) {
				while (rset.next()) {
					if (proprietari.contains(rset.getString(1))) {
						UserListElement user = new UserListElement(rset
								.getString(1), rset.getString(2), rset
								.getString(3));
						ownerList.add(user);
					}
				}
			}

			rset.close();
			stmt.close();

		} catch (Exception e) {
			System.err.println(e.toString());
		}
		connection.closeConnection();

		return ownerList;
	}

	/**
	 * Metodo che restituisce la lista dei file condivisi da un proprietario
	 * specificato a un determinato utente
	 * 
	 * @param String
	 *            userID - Utente con cui vengono condivisi i file
	 * @param String
	 *            ownerID - Utente che condivide i file
	 * 
	 * @return LinkedList<FileListElement> - Lista file condivisi
	 * 
	 */
	public static LinkedList<FileListElement> getAvaiableFileList(
			String userID, String ownerID) {

		LinkedList<FileListElement> fileList = new LinkedList<FileListElement>();

		DBConnection connection = new DBConnection();

		try {
			Statement stmt = connection.getConnection().createStatement();
			ResultSet rset = stmt
					.executeQuery("SELECT keyidsel,keyidsel,objectid,filename from filetable where owner='"
							+ ownerID + "'");

			if (rset != null) {
				while (rset.next()) {

					// se codice utente è contenuto nel gruppo metto il
					// proprietario nella lista
					StringTokenizer group = new StringTokenizer(rset
							.getString(1), "-");
					LinkedList<String> list = new LinkedList<String>();

					if ((rset.getString(2) == null)
							|| (rset.getString(2).equals(""))
							|| (controllaALL(rset.getString(2), userID))) {
						if ((controllaALL(rset.getString(2), userID))
								&& (rset.getString(1).equals("ALL")))

						{
							FileListElement fle = new FileListElement(rset
									.getString(3), rset.getString(4), rset
									.getString(1), rset.getString(2), ownerID);
							fileList.add(fle);

						} else {
							if ((rset.getString(1).equals("ALL"))
									&& (rset.getString(2).equals(""))) {
								FileListElement fle = new FileListElement(rset
										.getString(3), rset.getString(4), rset
										.getString(1), rset.getString(2),
										ownerID);
								fileList.add(fle);
							}

							if (((controllaALL(rset.getString(2), userID)) && (rset
									.getString(1).equals("ALL")))
									|| (!rset.getString(1).equals("ALL"))) {
								while (group.hasMoreTokens()) {
									list.add(group.nextToken());
								}

								if (list.contains(userID)) {
									FileListElement fle = new FileListElement(
											rset.getString(3), rset
													.getString(4), rset
													.getString(1), rset
													.getString(2), ownerID);
									fileList.add(fle);
								}
							}
						}
					} else {
						// stessa cosa per token SEL
						group = new StringTokenizer(rset.getString(2), "-");
						list = new LinkedList<String>();
						while (group.hasMoreTokens()) {
							list.add(group.nextToken());
						}
						if ((list.contains(userID))
								&& (!list.get(0).equals("ALL"))) {
							FileListElement fle = new FileListElement(rset
									.getString(3), rset.getString(4), rset
									.getString(1), rset.getString(2), ownerID);
							fileList.add(fle);
						}

					}
				}
			}

			rset = stmt
					.executeQuery("SELECT subjectid,name,surname from usertable");

			rset.close();
			stmt.close();

		} catch (Exception e) {
			System.err.println(e.toString());
		}
		connection.closeConnection();

		return fileList;

	}

	/**
	 * Metodo che recupera la chiave a partire dal suo id grazie all'utilizzo
	 * dei token memorizzati nel DB, quando si conosce la chiave del
	 * proprietario
	 * 
	 * @param AccessGraph
	 *            accessGraph - Grafo contenente tutti gli ACL
	 * @param String
	 *            keyID - ID della chiave da trovare
	 * @param String
	 *            userID - ID dell'utente che vuole recuperare la chiave
	 * @param String
	 *            ownerID - ID del proprietario del file
	 * 
	 * @return byte[] - Vettore di byte contenente la chiave ricavata
	 * 
	 */
	public static byte[] getKeyFromUserKey(String fileKeyID, String userID,
			String ownerID) {

		byte[] Key = null;
		byte[] userKey = null;
		String key = "own-" + userID;
		String keyidsource;
		String userName = null;
		Token newToken;
		DBConnection connection = new DBConnection();
		LinkedList<Token> tokenPath = new LinkedList<Token>();
		int pos;

		try {
			Statement stmt = connection.getConnection().createStatement();
			ResultSet rset = stmt
					.executeQuery("SELECT username from usertable where subjectid = '"
							+ userID + "' ");
			if (rset != null) {
				rset.next();
				userName = rset.getString(1);
			}

			rset.close();
			stmt.close();

		} catch (Exception e) {
			System.err.println(e.toString());
		}

		try {
			FileInputStream fin;
			DataInputStream dis;
			fin = new FileInputStream("Key" + File.separatorChar + userName);
			dis = new DataInputStream(fin);
			userKey = new byte[16];
			dis.read(userKey);
			fin.close();
		} catch (Exception e) {
			System.err.println(e.toString());
		}

		try {
			Statement stmt = connection.getConnection().createStatement(
					ResultSet.TYPE_SCROLL_INSENSITIVE,
					ResultSet.CONCUR_UPDATABLE);
			ResultSet rset = stmt
					.executeQuery("SELECT * from tokentable where level = 'BEL'");

			if (rset.first()) {
				do {

					if (rset.getString(2).equals(key)
							&& rset.getString(3).equals(
									"usr-" + ownerID + "-" + userID)) {
						newToken = new Token(rset.getString(2), rset
								.getString(3), Conversion.toBytes(rset
								.getString(4)), rset.getString(5));
						tokenPath.add(newToken);
						key = rset.getString(3);
					}

				} while (rset.next());
			}

			if (rset.first()) {
				do {
					if (!key.equals(fileKeyID)) {
						if (rset.getString(2).equals(key)
								&& !rset.getString(2).contains("own-")) {
							pos = rset.getRow();
							keyidsource = rset.getString(3);
							rset.first();
							if (keyidsource.equals(fileKeyID)) {
								rset.absolute(pos);
								newToken = new Token(rset.getString(2), rset
										.getString(3), Conversion.toBytes(rset
										.getString(4)), rset.getString(5));
								tokenPath.add(newToken);
								key = rset.getString(3);
								break;
							} else {
								if (checkPathToID(keyidsource, fileKeyID, rset)) {
									rset.absolute(pos);
									newToken = new Token(rset.getString(2),
											rset.getString(3),
											Conversion.toBytes(rset
													.getString(4)), rset
													.getString(5));
									tokenPath.add(newToken);
									key = rset.getString(3);
									rset.beforeFirst();
								} else {
									rset.absolute(pos);
								}
							}

						}
					}
				} while (rset.next());
			}
			rset.close();
			stmt.close();

		} catch (Exception e) {
			System.err.println(e.toString());
		}
		connection.closeConnection();

		for (int i = 0; i < tokenPath.size(); i++) {
			if (i == 0)
				Key = Token.rebuildKey(userKey, tokenPath.get(i).getToken(),
						tokenPath.get(i).getLabel());
			else
				Key = Token.rebuildKey(Key, tokenPath.get(i).getToken(),
						tokenPath.get(i).getLabel());
		}

		return Key;
	}

	private static boolean checkPathToID(String key, String fileKeyID,
			ResultSet rset) {
		boolean status = false;
		String keyidsource;
		int pos;

		try {

			do {
				if (rset.getString(2).equals(key)) {
					if (rset.getString(3).equals(fileKeyID))
						return true;
					else {
						pos = rset.getRow();
						keyidsource = rset.getString(3);
						rset.first();
						status = checkPathToID(keyidsource, fileKeyID, rset);
						if (status)
							return true;
						rset.absolute(pos);
					}
				}
			} while (rset.next());

		} catch (Exception e) {
			System.err.println(e.toString());
		}

		return status;
	}

	public static boolean FileIsAll(String fileID) {

		String keyidsel = null;

		DBConnection connection = new DBConnection();

		try {

			Statement stmt = connection.getConnection().createStatement();
			ResultSet rset = stmt
					.executeQuery("SELECT * from filetable  where objectid ='"
							+ fileID + "'");
			if (rset != null) {
				while (rset.next()) {

					keyidsel = rset.getString(2);

				}
			}
			rset.close();
			stmt.close();
		} catch (Exception e) {
			System.err.println(e.toString());
		}

		connection.closeConnection();
		if (keyidsel.equals("ALL"))
			return true;
		return false;
	}

	/**
	 * Metodo che restituisce la lista degli utenti che possono accede al file
	 * con ID specificato. Tiene conto sia del livello BEL che del livello SEL
	 * 
	 * @param String
	 *            fileID - ID del file per il quale devo trovare la lista degli
	 *            utenti autorizzati
	 * 
	 * @return UserListElement[] - Lista degli utenti che hanno accesso al file
	 * 
	 */
	public static UserListElement[] getUserListByFileID(String fileID,
			String ownerID) {

		UserListElement[] authListSEL = null;
		String keyidsel = null;
		String keyIdSel = null;
		DBConnection connection = new DBConnection();

		try {

			Statement stmt = connection.getConnection().createStatement();
			ResultSet rset = stmt
					.executeQuery("SELECT * from filetable  where objectid ='"
							+ fileID + "'");
			if (rset != null) {
				while (rset.next()) {

					keyidsel = rset.getString(2);
					keyIdSel = rset.getString(3);
				}
			}
			rset.close();
			stmt.close();
		} catch (Exception e) {
			System.err.println(e.toString());
		}

		connection.closeConnection();

		ACL acl = new ACL(keyidsel + " " + keyIdSel);

		if ((keyIdSel != null) && (!keyIdSel.equals(""))) {
			StringTokenizer group = new StringTokenizer(keyIdSel, "-");
			LinkedList<String> supp = new LinkedList<String>();

			while (group.hasMoreTokens()) {
				supp.add(group.nextToken());
			}

			for (int i = 0; i < supp.size(); ++i) {
				if (!supp.get(i).equals("ALL"))
					acl.addUser(supp.get(i));
			}

		} else {
			StringTokenizer group = new StringTokenizer(keyidsel, "-");
			LinkedList<String> supp = new LinkedList<String>();

			while (group.hasMoreTokens()) {
				supp.add(group.nextToken());
			}

			for (int i = 0; i < supp.size(); ++i) {
				if (!supp.get(i).equals("ALL"))
					acl.addUser(supp.get(i));
			}
		}

		UserListElement[] authListsupp = new UserListElement[acl.getSize()];

		int numeropropr = 0;
		for (int i = 0; i < acl.getSize(); ++i) {

			authListsupp[i] = new UserListElement(acl.getUserList().get(i));
			if ((!authListsupp[i].getID().equals(ownerID))
					&& (!authListsupp[i].getID().equals("0")))
				++numeropropr;
		}

		authListSEL = new UserListElement[numeropropr];

		int cont = 0;
		for (int i = 0; i < authListsupp.length; ++i) {
			if ((!authListsupp[i].getID().equals(ownerID))
					&& (!authListsupp[i].getID().equals("0"))) {
				authListSEL[cont] = getUserbyID(authListsupp[i].getID());
				++cont;
			}
		}

		return authListSEL;
	}

	public static UserListElement getUserbyID(String ID) {
		UserListElement usl = null;
		DBConnection connection = new DBConnection();

		try {

			Statement stmt = connection.getConnection().createStatement();
			ResultSet rset = stmt
					.executeQuery("SELECT subjectid,name,surname from usertable  where subjectid="
							+ ID);
			if (rset != null) {
				while (rset.next()) {
					usl = new UserListElement(rset.getString(1), rset
							.getString(2), rset.getString(3));
				}
			}
			rset.close();
			stmt.close();
		} catch (Exception e) {
			System.err.println(e.toString());
		}

		connection.closeConnection();

		return usl;
	}

	private boolean ingiafatto2(ACL acl, LinkedList<ACL> giafatto) {
		int i = 0;
		while (i < giafatto.size()) {
			if (acl.contains(giafatto.get(i))) {
				return true;
			}
			i++;

		}
		return false;
	}

	/**
	 * Recupera tutte le informazioni di un file memorizzate nel DB a partire
	 * dal suo ID
	 * 
	 * @param String
	 *            fileID - Id del file di cui vogliamo recuperare le informazini
	 * 
	 * @return FileListElement - Variabile contenente tutte le informazioni del
	 *         file
	 */
	public static FileListElement getFileInfo(String fileID) {
		FileListElement fileInfo = null;
		DBConnection connection = new DBConnection();

		try {
			Statement stmt = connection.getConnection().createStatement(
					ResultSet.TYPE_SCROLL_INSENSITIVE,
					ResultSet.CONCUR_UPDATABLE);
			ResultSet rset = stmt
					.executeQuery("SELECT * from filetable where objectid = '"
							+ fileID + "'");

			if (rset != null) {
				while (rset.next()) {
					fileInfo = new FileListElement(rset.getString(1), rset
							.getString(5), rset.getString(2),
							rset.getString(3), rset.getString(4));
				}
			}

		} catch (Exception e) {
			System.err.println(e.toString());
		}
		connection.closeConnection();

		return fileInfo;
	}

	/**
	 * Metodo che restituisce la lista di tutti i file criptati a BEL con chiave
	 * che ha l'ID passato
	 * 
	 * @param String
	 *            keyidsel - Id chiave usata per criptare i file a livello BEL
	 * 
	 * @return FileListElement[] - Lista dei file criptati con chiave con ID
	 *         passato
	 */
	private static FileListElement[] getFileListBykeyidsel(String keyidsel) {
		LinkedList<FileListElement> fileList = new LinkedList<FileListElement>();
		DBConnection connection = new DBConnection();

		try {
			Statement stmt = connection.getConnection().createStatement(
					ResultSet.TYPE_SCROLL_INSENSITIVE,
					ResultSet.CONCUR_UPDATABLE);
			ResultSet rset = stmt
					.executeQuery("SELECT * from filetable where keyidsel='"
							+ keyidsel + "'");

			if (rset != null) {
				while (rset.next()) {
					fileList.add(new FileListElement(rset.getString(1), rset
							.getString(5), rset.getString(2),
							rset.getString(3), rset.getString(4)));
				}
			}

		} catch (Exception e) {
			System.err.println(e.toString());
		}
		connection.closeConnection();

		return fileList.toArray(new FileListElement[fileList.size()]);
	}

	/**
	 * Metodo che controlla che una certa chiave sia raggiungibile mediante solo
	 * token bel
	 * 
	 * 
	 * @param FileListElement
	 *            file - Informazioni sul file
	 * @param byte[] ownerKey - Chiave del proprietario del file
	 * 
	 * @return byte[] - Vettore di byte contenente la chiave ricavata
	 * 
	 */

	public static boolean existPathBEL(String fileIDKeyBEL, String userID,
			String ownerID) {

		LinkedList<ACL> percorso = new LinkedList<ACL>();
		AccessGraph ag = new AccessGraph(0);

		if (userID.equals(ownerID)) {

			LinkedList<ACL> antenati = new LinkedList<ACL>();
			antenati = ag.getAclListBySize(2);
			for (int i = 0; i < antenati.size(); i++) {

				if (antenati.get(i).getUserList().get(0).equals(ownerID)) {
					userID = antenati.get(i).getUserList().get(1);
				}
				if (antenati.get(i).getUserList().get(1).equals(ownerID)) {
					userID = antenati.get(i).getUserList().get(0);
				}

			}
		}

		ACL ant = new ACL();
		ant.addUser(userID);
		ant.addUser(ownerID);
		ACL dest = new ACL(fileIDKeyBEL);

		ag.addAcl(ant);
		ag.CaricaIntervalli();

		esplora_albero(ag, ant.getID(), percorso, dest);

		if (percorso.size() > 0)
			return true;
		return false;

	}

	/**
	 * Metodo che recupera la chiave con cui è stato criptato un file passando
	 * tramite un token hbel
	 * 
	 * 
	 * @param String
	 *            fileIDKeyBEL - chiave con cui è stato criptato a livello bel
	 * @param String
	 *            userID - Codice del utente che vuole fare il download
	 * @param String
	 *            ownerID - Codice del utente proprietario del file
	 * 
	 * @return byte[] - Vettore di byte contenente la chiave ricavata
	 * 
	 */
	public static byte[] getHashedKeyFromUserKey(String fileIDKeyBEL,
			String userID, String ownerID) {
		byte[] Key = null;

		Token newToken;
		DBConnection connection = new DBConnection();

		ACL ant = new ACL();
		ant.addUser(userID);
		ant.addUser(ownerID);
		try {
			Statement stmt = connection.getConnection().createStatement();
			ResultSet rset = stmt
					.executeQuery("SELECT * from tokentable where level = 'HBEL' "
							+ "and groupiddestination ='"
							+ fileIDKeyBEL
							+ "' and groupidsource ='" + ant.getID() + "'");

			if (rset != null) {

				rset.next();
				newToken = new Token(rset.getString(2), rset.getString(3),
						Conversion.toBytes(rset.getString(4)), rset
								.getString(5));

				Key = DHKeyAgreementFunction.buildDHKey(userID, ownerID);

				Key = Token.rebuildKey(Key, newToken.getToken(), newToken
						.getLabel());

			}

			rset.close();
			stmt.close();

		} catch (Exception e) {
			System.err.println(e.toString());
		}

		return Key;
	}

	/**
	 * Metodo che controlla se esistono token hbel che arrivano a derivare
	 * quella chiave
	 * 
	 * 
	 * @param String
	 *            fileID - chiave da controllare
	 * 
	 * 
	 * @return boolean
	 * 
	 */
	public static boolean hasHBELToken(String fileID) {
		DBConnection connection = new DBConnection();
		String keyidsel = null;
		try {
			Statement stmt = connection.getConnection().createStatement();
			ResultSet rset = stmt
					.executeQuery("SELECT keyidsel from filetable where objectid = '"
							+ fileID + "' ");
			if (rset != null) {
				rset.next();
				keyidsel = rset.getString(1);
			}

			stmt = connection.getConnection().createStatement();
			rset = stmt
					.executeQuery("SELECT groupiddestination from tokentable "
							+ "where groupiddestination = '" + keyidsel
							+ "' and level='HBEL' ");
			if (rset != null) {
				if (rset.next())
					return true;
			}

			rset.close();
			stmt.close();
			connection.closeConnection();

		} catch (Exception e) {
			System.err.println(e.toString());
		}
		return false;
	}
	
	public static String getPath(){
	     File dir2 = new File ("..");
	     try {
	//       return dir2.getCanonicalPath() + "/webapps/srv_iOverEncrypt/";
	         return dir2.getCanonicalPath() + "\\webapps\\srv_iOverEncrypt\\";
	       }
	     catch(Exception e) {
	       e.printStackTrace();
	       }
		return null;
	}
	
	
	public static boolean hasSEL(String fileID) {
		
		String keyidsel = "";
		
		try {
			DBConnection connection = new DBConnection();
			Statement stmt = connection.getConnection().createStatement();
			ResultSet rset = stmt
					.executeQuery("SELECT keyidsel from filetable where objectid = '"
							+ fileID + "' ");
			if (rset != null) {
				rset.next();
				keyidsel = rset.getString(1);
			}
		
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		if (("" + keyidsel).length() > 0) return true;
		else return false;
		
	}	
	
	
	public void encrypt(String JSON) {
	
		try{
			
			String path = "";
			String delPath = "";
			String cmdPath = "";
			//Write JSON in
			if(SELSharedFile.getOS().equals("win")){
				path = getWinPath() + "executable\\jsonin.txt";
				delPath = getWinPath() + "upload\\BEL_" + filePath;
			}
			else{
				path = getPath() + "executable/jsonin.txt";
				delPath = getPath() + "upload/BEL_" + filePath;
			}
			FileWriter fileout = new FileWriter(path);
            BufferedWriter filebuf = new BufferedWriter(fileout);
            PrintWriter printout = new PrintWriter(filebuf);
            printout.println(JSON);
            printout.close();
			
			Runtime rt=Runtime.getRuntime();
			new File(delPath).delete();
			
			if(SELSharedFile.getOS().equals("win")) {
				cmdPath ="\""	+	getWinPath() + "executable\\win.exe"		+	"\"" + " e "+ 
						"\""	+	getWinPath() + "executable\\jsonin.txt"	+	"\"" + " " + 
						"\""	+	getWinPath() + "temp\\BEL_" + filePath 	+	"\"" + " " + 
						"\""	+	getWinPath() + "upload\\BEL_" + filePath 	+	"\"" + " " +
						PIN;
			}
			else if(SELSharedFile.getOS().equals("mac")){
				cmdPath = 	getPath() + "executable/mac e " + 
							getPath() + "executable/jsonin.txt " + 
							getPath() + "temp/BEL_" + filePath + " "+ 
							getPath() + "upload/BEL_" + filePath + " "  + 
							PIN;
			}
			
			else if(SELSharedFile.getOS().equals("linux")){
				cmdPath = 	getPath() + "executable/linux e " + 
							getPath() + "executable/jsonin.txt " + 
							getPath() + "temp/BEL_" + filePath + " "+ 
							getPath() + "upload/BEL_" + filePath + " "  + 
							PIN;
			}

			Process proc= rt.exec(cmdPath);
			// It is necessary to handle the error messages and the output messages of the subprocess 
			// otherwise the main process will hang and never complete due to the limited error and 
			// standard output buffer size reserved for the subprocess. Threfore when these buffers 
			// are not emptied promptly by the main process, the subprocess will hang indefinitely.
			// At the moment, the C++ binary prints some error messages or print mgs to the stdout
			BufferedReader aberr = new BufferedReader(new InputStreamReader(proc.getErrorStream()));
			BufferedReader abinp = new BufferedReader(new InputStreamReader(proc.getInputStream()));
			while ( (aberr.readLine() != null) || (abinp.readLine() != null));
			int aexitVal = proc.waitFor();
			
			//metto la chiave sel nel db
			DBConnection connection = new DBConnection();
			try {
				Statement stmt = connection.getConnection().createStatement();
				stmt.execute("Update filetable SET keyidsel = '" + groupIDBEL+ "' WHERE objectid = '" + filePath + "'");
				stmt.close();
				
			} catch (Exception e) {
				e.printStackTrace();
			}
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public static final void moveFile() {
		
		String oldPath = SELSharedFile.getOS().equals("win") ? 
				SELSharedFile.getWinPath() + "upload\\BEL_" + filePath 
				: 
				getPath() + "upload/BEL_" + filePath;
				
		String newPath = SELSharedFile.getOS().equals("win") ? 
				getWinPath() + "temp\\BEL_" + filePath 
				: 
				getPath() + "temp/BEL_" + filePath;
						
		File oldFile = new File(oldPath);
		File newFile = new File(newPath);		
		Boolean success = oldFile.renameTo(newFile);
		
	}
	
	public void decrypt(String JSON) {

		try{
			
			String path = SELSharedFile.getOS().equals("win") ? getWinPath() +"executable\\jsonin.txt" : getPath()+"executable/jsonin.txt";
		
			//Write JSON in
			FileWriter fileout = new FileWriter(path);
			BufferedWriter filebuf = new BufferedWriter(fileout);
			PrintWriter printout = new PrintWriter(filebuf);
			printout.println(JSON);
			printout.close();
            
			Runtime rt=Runtime.getRuntime();
			
			String cmd = "";
			if(SELSharedFile.getOS().equals("win")){
			
			 cmd =		"\""	+	getWinPath() + "executable\\win.exe"	+	"\"" + " e "+ 
						"\""	+	getWinPath() + "executable\\jsonin.txt"	+	"\"" + " " + 
						"\""	+	getWinPath() + "temp\\BEL_" + filePath 	+	"\"" + " " + 
						"\""	+	getWinPath() + "upload\\BEL_" + filePath+	"\"" + " " +
						PIN;
			}
			else if(SELSharedFile.getOS().equals("mac")){
				cmd =	getPath() + "executable/mac d " + 
						getPath() + "executable/jsonin.txt " + 
						getPath() + "upload/BEL_" + filePath + " "+ 
						getPath() + "temp/BEL_" + filePath + " "  + PIN;
				
			}
			else if(SELSharedFile.getOS().equals("linux")){
				cmd =	getPath() + "executable/linux d " + 
						getPath() + "executable/jsonin.txt " + 
						getPath() + "upload/BEL_" + filePath + " "+ 
						getPath() + "temp/BEL_" + filePath + " "  + PIN;
			}
			
			Process proc1=rt.exec(cmd);
			//proc1.waitFor();
			// It is necessary to handle the error messages and the output messages of the subprocess 
			// otherwise the main process will hang and never complete due to the limited error and 
			// standard output buffer size reserved for the subprocess. Threfore when these buffers 
			// are not emptied promptly by the main process, the subprocess will hang indefinitely.
			// At the moment, the C++ binary prints some error messages or print a mgs to the stdout
			BufferedReader berr = new BufferedReader(new InputStreamReader(proc1.getErrorStream()));
			BufferedReader binp = new BufferedReader(new InputStreamReader(proc1.getInputStream()));
			while (( berr.readLine() != null) || ( binp.readLine() != null));
			int exitVal = proc1.waitFor();
			
		} catch(Exception e){
				e.printStackTrace();
		}
	}
	
	
	
	public JSONObject checkHbel(String fileId, String userId) {
		DBConnection connection = new DBConnection();
		String keyidsel = null;
		String keyidbel = null;
		JSONArray array = new JSONArray();
		JSONObject jsonBel = new JSONObject();

		try {
			Statement stmt = connection.getConnection().createStatement();
			ResultSet rset = stmt
					.executeQuery("SELECT keyidsel, keyidbel from filetable where objectid = '"
							+ fileId + "' ");
			if (rset != null) {
				rset.next();
				keyidsel = rset.getString(1);
				keyidbel = rset.getString(2);
			}

			String[] arraySel = keyidsel.split("-");
			String[] arrayBel = keyidbel.split("-");

			//check if all users in sel are authorized in bel
			for (int i = 0; i < arraySel.length; i++) {
				if(Arrays.binarySearch(arrayBel, arraySel[i]) < 0 && !arraySel[i].equals("0")) { //non esiste nel bel
					//guardo se esiste il'hbel
					rset = stmt.executeQuery("SELECT groupidsource from tokentable where level='HBEL' and groupiddestination = '"	+ keyidbel + "' ");
					
					boolean hasHbel = false;
					while(rset.next()) {
						String[] grpsrc = rset.getString(1).split("-");
						if(Arrays.binarySearch(grpsrc, arraySel[i]) >= 0){
							hasHbel = true;
							break;
						}
					}
					
					if (hasHbel == false) {
						rset = stmt.executeQuery("SELECT publickey from dhkatable where subjectid = '"	+ arraySel[i]  + "' ");
						rset.next();
						String[] tempArray = {userId, arraySel[i]};
						Arrays.sort(tempArray);
												
						JSONObject temp = new JSONObject();
						temp.put("hbel_public_key", rset.getString(1));
						temp.put("hbel_grpsrc", tempArray[0] + "-" + tempArray[1]);
						temp.put("hbel_grpdst", keyidbel);
						array.put(temp);
					}
				} 
			}
			
						
			if(array.length() >0) {
				rset = stmt.executeQuery("SELECT publickey, privatekey from dhkatable where subjectid = '"	+ userId  + "' ");
				SharedFile a = new SharedFile();
				jsonBel = a.getJSONBEL(fileId, userId);
				jsonBel.put("hbeldefs", array);
			}
			
			rset.close();
			stmt.close();
			connection.closeConnection();

		} catch (Exception e) {
			System.err.println(e.toString());
		}
		return jsonBel;
	}
}
