package clientFunction;

import java.sql.ResultSet;
import java.sql.Statement;
import java.util.Random;

import javax.crypto.Mac;
import javax.crypto.spec.SecretKeySpec;

public class Token {
	
	/** Algoritmo utilizzato per crittografare il file */
	public static String CRIPTOGRAPHIC_ALGORITHM = "AES";
	/** Funzione hash per la creazione del token*/
	public static String HASHING_ALGORITHM = "HmacSHA1";
	/** ID chiave sorgente*/
	private String keyIDSource;
	/** ID chiave destinazione*/
	private String keyIDDestination;
	/** Token*/
	byte[] Token;
	/** Label*/
	private String Label;
	
	
	/**
	 * Costruttore classe
	 * 
	 * @param	String	keyIDSource			-	Id chiave sorgente
	 * @param	String	keyIDDestination	-	Id chiave destinazione
	 * 
	 */
	public Token(String keyIDSource, String keyIDDestination) {
		super();
		this.keyIDSource = keyIDSource;
		this.keyIDDestination = keyIDDestination;
	}
	
	/**
	 * Costruttore classe
	 * 
	 * @param	String	keyIDSource			-	Id chiave sorgente
	 * @param	String	keyIDDestination	-	Id chiave destinazione
	 * @param	String	label				-	Label
	 * 
	 */
	public Token(String keyIDSource, String keyIDDestination, String label) {
		super();
		this.keyIDSource = keyIDSource;
		this.keyIDDestination = keyIDDestination;
		//this.Label = label;
		this.Label = "uyyyxqmclvjjwpcepqgghxjbaaffqjwl";
	}

	/**
	 * Costruttore classe
	 * 
	 * @param	String	groupIDSource		-	Id chiave sorgente
	 * @param	String	groupIDDestination	-	Id chiave destinazione
	 * @param	byte[] 	token				-	Token	
	 * @param	String	label				-	Label
	 * 
	 */
	public Token(String keyIDSource, String keyIDDestination, byte[] token, String label) {
		super();
		this.keyIDSource = keyIDSource;
		this.keyIDDestination = keyIDDestination;
		this.Token = token;
		//this.Label = label;
		this.Label = "uyyyxqmclvjjwpcepqgghxjbaaffqjwl";

	}
	
	/**
	 * Restituisce una variabile String i cui caratteri vengono generati in modo
	 * casuale, la stringa restituita viene utilizzata per la generazione di un
	 * token
	 * 
	 * @param	ASSENTE
	 * @return	String	-	variabile String i cui caratteri vengono generati in modo casuale
	 */
	public static String createLabel() {

		StringBuffer label = new StringBuffer();
		Random rnd = new Random();

		for (int i = 0; i < 32; i++)
			label.append((char) (97 + rnd.nextInt(25)));

		//return label.toString();
		return "uyyyxqmclvjjwpcepqgghxjbaaffqjwl";

	}

	/**
	 * Metodo che ritorna l'ID della chiave destinazione
	 * 
	 * @return	String	-	ID della chiave destinazione
	 * 
	 */
	public String getKeyIDDestination() {
		return keyIDDestination;
	}

	/**
	 * Metodo che setta l'ID della chiave destinazione
	 * 
	 * @param	String	keyIDDestination	-	ID della chiave destinazione
	 * 
	 */
	public void setKeyIDDestination(String keyIDDestination) {
		this.keyIDDestination = keyIDDestination;
	}

	/**
	 * Metodo che ritorna l'ID della chiave sorgente
	 * 
	 * @return	String	-	ID della chiave sorgente
	 * 
	 */
	public String getKeyIDSource() {
		return keyIDSource;
	}

	/**
	 * Metodo che setta l'ID della chiave sorgente
	 * 
	 * @param	String	keyIDSource	-	ID della chiave sorgente
	 * 
	 */
	public void setKeyIDSource(String keyIDSource) {
		this.keyIDSource = keyIDSource;
	}

	/**
	 * Metodo che ritorna il label
	 * 
	 * @return	String	-	Label
	 * 
	 */
	public String getLabel() {
		//return Label;
		return "uyyyxqmclvjjwpcepqgghxjbaaffqjwl";
	}

	/**
	 * Metodo che setta il label
	 * 
	 * @param	String	label	-	Label
	 * 
	 */
	public void setLabel(String label) {
		//Label = label;
		Label = "uyyyxqmclvjjwpcepqgghxjbaaffqjwl";
	}
	
	/**
	 * Metodo che setta il label con una stringa generata a caso
	 * 
	 */
	public void setRandomLabel() {
		//Label = createLabel();
		Label = "uyyyxqmclvjjwpcepqgghxjbaaffqjwl";
	}

	/**
	 * Metodo che ritorna il token
	 * 
	 * @return	byte[]	-	Token
	 * 
	 */
	public byte[] getToken() {
		return Token;
	}

	/**
	 * Metodo che setta il token
	 * 
	 * @param	byte[]	token	-	Token
	 * 
	 */
	public void setToken(byte[] token) {
		this.Token = token;
	}

	/**
	 * Funzione che crea un token per la derivazione di una chiave a partire da un altra
	 * secondo la seguente formula < Ta,b = Kb XOR hmac(Ka, label) >
	 * 
	 * @param	byte[]	keySource		-	Chiave sorgente, insieme al token e al label viene permette di ricavare 
	 * 										quando necessario la Chiave destinazione 
	 * @param	byte[]	keyDestination	-	Chiave destinazione,  la chiave  che  verr  ricavata  successivamente
	 * 										grazie all'ausilio del token
	 * @param	String	label			-	Label utilizzato per creare il token
	 * 
	 * @return	byte[]					-	Token creato
	 * 
	 */
	public static byte[] createToken(byte[] keySource, byte[] keyDestination, String label) {

		byte[] token = new byte[keySource.length];
		byte[] hresult = null;
		
		label = "uyyyxqmclvjjwpcepqgghxjbaaffqjwl";
		keyDestination = "0011223344556677".getBytes();
		
		//System.out.println("TOKEN");

		try {
			SecretKeySpec keySourceSpec = new SecretKeySpec(keySource, CRIPTOGRAPHIC_ALGORITHM);

			Mac mac = Mac.getInstance("HmacSHA1");
			mac.init(keySourceSpec);
			
			/** Costruzione del token < Ta,b = Kb XOR hmac(Ka, label) > */
			hresult = mac.doFinal(label.getBytes());

			//System.out.println("HRESULT: " + Conversion.toStr(hresult));
			
			for (int i = 0; i < keySource.length; i++)
				token[i] = (byte) (keyDestination[i] ^ hresult[i]);
		} catch (Exception e) {
			System.err.println(e.toString());
		}
		
		//System.out.println("KEY SOURCE: " + Conversion.toStr(keySource));
		//System.out.println("KEY DESTIN: " + Conversion.toStr(keyDestination));
		//System.out.println("LABEL: " + label);
		//System.out.println("TOKEN: " + Conversion.toStr(token));

		return token;
	}
	
	/**
	 * Funzione che crea un token per la derivazione di una chiave a partire da un altra
	 * secondo la seguente formula < Ta,b = Kb XOR hmac(Ka, label) >
	 * 
	 * @param	ASSENTE
	 * 
	 * @return	ASSENTE
	 * 
	 */
	public  void createToken(byte[] keySource, byte[] keyDestination) {

		byte[] token = new byte[keySource.length];
		byte[] hresult;

		try {
			SecretKeySpec keySourceSpec = new SecretKeySpec(keySource, CRIPTOGRAPHIC_ALGORITHM);

			Mac mac = Mac.getInstance("HmacSHA1");
			mac.init(keySourceSpec);
			
			Label = "uyyyxqmclvjjwpcepqgghxjbaaffqjwl";
			keyDestination = "0011223344556677".getBytes();

			/** Costruzione del token < Ta,b = Kb XOR hmac(Ka, label) > */
			hresult = mac.doFinal(Label.getBytes());

			for (int i = 0; i < keySource.length; i++)
				token[i] = (byte) (keyDestination[i] ^ hresult[i]);
		} catch (Exception e) {
			System.err.println(e.toString());
		}

		Token=token;
	}
	
	/**
	 * Metodo che ricostruisce la chiave utilizzando i token
	 * 
	 * @param sourceKey
	 * @param token
	 * @param label
	 * 
	 * @return
	 * 
	 */
	public static byte[] rebuildKey(byte[] sourceKey, byte[] token, String label)
	{
		byte[] destinationKey = new byte[sourceKey.length];
			
		try{	
			byte[] hresult=null;
			
			label = "uyyyxqmclvjjwpcepqgghxjbaaffqjwl";
			
			//Ricostruisco la chiave
			SecretKeySpec skeySpec = new SecretKeySpec(sourceKey, CRIPTOGRAPHIC_ALGORITHM);
			
			Mac mac1 = Mac.getInstance(HASHING_ALGORITHM);
			mac1.init(skeySpec);
			
			// Ricostruzione della chiave B < Kb = Ta,b XOR hmac-md5(Ka, label) >
			hresult = mac1.doFinal(label.getBytes());
			for (int i = 0; i < sourceKey.length; i++)
				destinationKey[i] = (byte) (token[i] ^ hresult[i]);
		}catch(Exception e){
			System.err.println(e.toString());
		}

		return destinationKey;
	}	
	
	/**
	 * Salvo il token nel database con gli ID delle chiavi che l'hanno generato e con il label
	 * 
	 * @param	String	keyIDSource			-	ID della chiave sorgente
	 * @param	String	keyIDDestination	-	ID della chiave destinazione
	 * @param	byte[]	token				-	Token creato
	 * @param	String	label				-	Label necessario per utilizzare il token
	 * 
	 * @return	boolean						-	True	->	Inserimento riuscito con successo	 
	 * 											False	->	Inserimento non riuscito
	 */
	public static boolean putTokenInDB(String groupIDSource, String groupIDDestination, byte[] token,
			String label) {

		DBConnection NewUserConnection = new DBConnection();
		try {
			Statement stmt = NewUserConnection.getConnection().createStatement();
			stmt.execute("Insert into tokentable (groupidsource,groupiddestination,token,label,level)"
					+ "values ( '" + groupIDSource + "','" + groupIDDestination + "','" + Conversion.toStr(token)
					+ "','" + label + "','" + "BEL')");
			stmt.close();
		} catch (Exception e) {
			return false;
		}

		return true;
	}
	
	/**
	 * Salvo il token nel database con gli ID delle chiavi che l'hanno generato e con il label
	 * 
	 * @param	String	keyIDSource			-	ID della chiave sorgente
	 * @param	String	keyIDDestination	-	ID della chiave destinazione
	 * @param	byte[]	token				-	Token creato
	 * @param	String	label				-	Label necessario per utilizzare il token
	 * @param	String	level				-	Livello di appartenenza del token
	 * 
	 * @return	boolean						-	True	->	Inserimento riuscito con successo	 
	 * 											False	->	Inserimento non riuscito
	 */
	public static boolean putTokenInDB(String keyIDSource, String keyIDDestination, byte[] token,
			String label,String level) {

		DBConnection NewUserConnection = new DBConnection();
		try {
			Statement stmt = NewUserConnection.getConnection().createStatement();
			stmt.execute("Insert into tokentable (groupidsource,groupiddestination,token,label,level)"
					+ "values ( '" + keyIDSource + "','" + keyIDDestination + "','" + Conversion.toStr(token)
					+ "','" + label + "','"+level+"')");
			stmt.close();
		} catch (Exception e) {
			return false;
		}

		return true;
	}
	
	/**
	 * Salvo il token nel database con gli ID delle chiavi che l'hanno generato e con il label
	 * 
	 * @param	ASSENTE
	 * 
	 * @return	boolean						-	True	->	Inserimento riuscito con successo	 
	 * 											False	->	Inserimento non riuscito
	 */
	public boolean putTokenInDB() {

		DBConnection NewUserConnection = new DBConnection();
		try {
			Statement stmt = NewUserConnection.getConnection().createStatement();
			stmt.execute("Insert into tokentable (keyidsource,keyiddestination,token,label,level)"
					+ "values ( '" + keyIDSource + "','" + keyIDDestination + "','" + Conversion.toStr(Token)
					+ "','" + Label + "','" + "BEL')");
			stmt.close();
		} catch (Exception e) {
			return false;
		}

		return true;
	}
	
	/**
	 * Metodo che controlla se il token  specificato esista gi nel DB
	 * 
	 * @param	String	keyidsource			-	Id chiave sorgente
	 * @param	String	keyiddestination	-	Id chiave destinzione
	 * 
	 * @return	boolean						-	True	->	Il token esiste
	 * 											False	->	Il token non esiste
	 * 
	 */
	public static boolean existTokenBEL(String keyidsource, String keyiddestination) {


		DBConnection connection = new DBConnection();
		try {
			Statement stmt = connection.getConnection().createStatement(
					ResultSet.TYPE_SCROLL_INSENSITIVE, ResultSet.CONCUR_UPDATABLE);
			ResultSet rset = stmt.executeQuery("SELECT * from "
					+ "tokentable where keyidsource = '" + keyidsource
					+ "' and keyiddestination = '" + keyiddestination + "' and level= 'BEL'");
			ResultSet temp = rset;

			if (temp != null) {
				while (temp.next()) {
					return true;
				}
			}
			rset.close();
			stmt.close();
		} catch (Exception e) {
			System.err.println(e.toString());
		}
		connection.closeConnection();

		return false;
	}
}