--
-- PostgreSQL database dump
--

-- Started on 2009-09-26 16:40:19

SET client_encoding = 'UTF8';
SET standard_conforming_strings = off;
SET check_function_bodies = false;
SET client_min_messages = warning;
SET escape_string_warning = off;

--
-- TOC entry 307 (class 2612 OID 16386)
-- Name: plpgsql; Type: PROCEDURAL LANGUAGE; Schema: -; Owner: postgres
--

CREATE PROCEDURAL LANGUAGE plpgsql;


ALTER PROCEDURAL LANGUAGE plpgsql OWNER TO postgres;

SET search_path = public, pg_catalog;

--
-- TOC entry 1479 (class 1259 OID 25335)
-- Dependencies: 6
-- Name: UserDB_SubjecID_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE "UserDB_SubjecID_seq"
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public."UserDB_SubjecID_seq" OWNER TO postgres;

--
-- TOC entry 1781 (class 0 OID 0)
-- Dependencies: 1479
-- Name: UserDB_SubjecID_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('"UserDB_SubjecID_seq"', 43, true);


SET default_tablespace = '';

SET default_with_oids = false;

--
-- TOC entry 1480 (class 1259 OID 25337)
-- Dependencies: 6
-- Name: dhkatable; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE dhkatable (
    subjectid integer NOT NULL,
    publickey character varying(1000),
    privatekey character varying(1000)
);


ALTER TABLE public.dhkatable OWNER TO postgres;

--
-- TOC entry 1481 (class 1259 OID 25343)
-- Dependencies: 6
-- Name: filetable; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE filetable (
    objectid integer NOT NULL,
    keyidbel character varying(40),
    keyidsel character varying(40),
    owner integer NOT NULL,
    filename character varying(100)
);


ALTER TABLE public.filetable OWNER TO postgres;

--
-- TOC entry 1482 (class 1259 OID 25346)
-- Dependencies: 6 1481
-- Name: filetable_objectid_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE filetable_objectid_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.filetable_objectid_seq OWNER TO postgres;

--
-- TOC entry 1782 (class 0 OID 0)
-- Dependencies: 1482
-- Name: filetable_objectid_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE filetable_objectid_seq OWNED BY filetable.objectid;


--
-- TOC entry 1783 (class 0 OID 0)
-- Dependencies: 1482
-- Name: filetable_objectid_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('filetable_objectid_seq', 560, true);


--
-- TOC entry 1483 (class 1259 OID 25348)
-- Dependencies: 6
-- Name: grouptable; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE grouptable (
    groupid integer NOT NULL,
    name character varying(20) NOT NULL,
    owner character varying(20) NOT NULL,
    users character varying(200)
);


ALTER TABLE public.grouptable OWNER TO postgres;

--
-- TOC entry 1484 (class 1259 OID 25351)
-- Dependencies: 1483 6
-- Name: grouptable_groupid_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE grouptable_groupid_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.grouptable_groupid_seq OWNER TO postgres;

--
-- TOC entry 1784 (class 0 OID 0)
-- Dependencies: 1484
-- Name: grouptable_groupid_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE grouptable_groupid_seq OWNED BY grouptable.groupid;


--
-- TOC entry 1785 (class 0 OID 0)
-- Dependencies: 1484
-- Name: grouptable_groupid_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('grouptable_groupid_seq', 1, false);


--
-- TOC entry 1485 (class 1259 OID 25353)
-- Dependencies: 6
-- Name: keyidbel_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE keyidbel_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.keyidbel_seq OWNER TO postgres;

--
-- TOC entry 1786 (class 0 OID 0)
-- Dependencies: 1485
-- Name: keyidbel_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('keyidbel_seq', 1, false);


--
-- TOC entry 1486 (class 1259 OID 25355)
-- Dependencies: 6
-- Name: keyidsel_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE keyidsel_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.keyidsel_seq OWNER TO postgres;

--
-- TOC entry 1787 (class 0 OID 0)
-- Dependencies: 1486
-- Name: keyidsel_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('keyidsel_seq', 1, false);


--
-- TOC entry 1487 (class 1259 OID 25357)
-- Dependencies: 6
-- Name: tokentable; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE tokentable (
    tokenid integer NOT NULL,
    groupidsource character varying(40) NOT NULL,
    groupiddestination character varying(40) NOT NULL,
    token character varying(32),
    label character varying(32),
    "interval" character varying(100),
    level character varying(4)
);


ALTER TABLE public.tokentable OWNER TO postgres;

--
-- TOC entry 1488 (class 1259 OID 25360)
-- Dependencies: 6 1487
-- Name: tokentable_tokenid_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE tokentable_tokenid_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.tokentable_tokenid_seq OWNER TO postgres;

--
-- TOC entry 1788 (class 0 OID 0)
-- Dependencies: 1488
-- Name: tokentable_tokenid_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE tokentable_tokenid_seq OWNED BY tokentable.tokenid;


--
-- TOC entry 1789 (class 0 OID 0)
-- Dependencies: 1488
-- Name: tokentable_tokenid_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('tokentable_tokenid_seq', 939, true);


--
-- TOC entry 1489 (class 1259 OID 25362)
-- Dependencies: 1759 6
-- Name: usertable; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE usertable (
    subjectid integer DEFAULT nextval('"UserDB_SubjecID_seq"'::regclass) NOT NULL,
    name character varying(20) NOT NULL,
    surname character varying(20) NOT NULL,
    birthdate date NOT NULL,
    birthplace character varying(20),
    nationality character varying(20),
    maritalstatus character varying(20),
    username character varying(20),
    password bytea,
    hashpwd character varying(32)
);


ALTER TABLE public.usertable OWNER TO postgres;

--
-- TOC entry 1756 (class 2604 OID 25369)
-- Dependencies: 1482 1481
-- Name: objectid; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE filetable ALTER COLUMN objectid SET DEFAULT nextval('filetable_objectid_seq'::regclass);


--
-- TOC entry 1757 (class 2604 OID 25370)
-- Dependencies: 1484 1483
-- Name: groupid; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE grouptable ALTER COLUMN groupid SET DEFAULT nextval('grouptable_groupid_seq'::regclass);


--
-- TOC entry 1758 (class 2604 OID 25371)
-- Dependencies: 1488 1487
-- Name: tokenid; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE tokentable ALTER COLUMN tokenid SET DEFAULT nextval('tokentable_tokenid_seq'::regclass);


--
-- TOC entry 1771 (class 0 OID 25337)
-- Dependencies: 1480
-- Data for Name: dhkatable; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY dhkatable (subjectid, publickey, privatekey) FROM stdin;
0	9B4F52B988E1B21EBBF0B9365083EB3B50CC8A0AB76BB10DE8E7D233A391571E6C50005A1063A86D9D8FD3515F9127F54C459B542B7E6A31C85516ADAEBAD0C71A735AF4D08753E141F7A3B1FC21D2BAFA5C267599C253B39C84F90EC5E1C073AE42AC8DC3E13FA94242CE6A9914623EDDAD0E7149F1CEC96069939A4984288C\n	3511ee1b7d04c1dbc338f798bc9924eb3511ee1b7d04c1dbc338f798bc9924eb3511ee1b7d04c1dbc338f798bc9924eb3511ee1b7d04c1dbc338f798bc9924eb3511ee1b7d04c1dbc338f798bc9924eb3511ee1b7d04c1dbc338f798bc9924ebc41ec62d07430b823ff71508dc37c00d90ecc8f4106200d6fc1b3ff48ae48a0ee5d6df24c33f22ed133963507071a49a\n
\.


--
-- TOC entry 1772 (class 0 OID 25343)
-- Dependencies: 1481
-- Data for Name: filetable; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY filetable (objectid, keyidbel, keyidsel, owner, filename) FROM stdin;
\.


--
-- TOC entry 1773 (class 0 OID 25348)
-- Dependencies: 1483
-- Data for Name: grouptable; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY grouptable (groupid, name, owner, users) FROM stdin;
\.


--
-- TOC entry 1774 (class 0 OID 25357)
-- Dependencies: 1487
-- Data for Name: tokentable; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY tokentable (tokenid, groupidsource, groupiddestination, token, label, "interval", level) FROM stdin;
\.


--
-- TOC entry 1775 (class 0 OID 25362)
-- Dependencies: 1489
-- Data for Name: usertable; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY usertable (subjectid, name, surname, birthdate, birthplace, nationality, maritalstatus, username, password, hashpwd) FROM stdin;
0	server	server	2009-03-23	server	server	server	server	\N	\N
\.


--
-- TOC entry 1769 (class 2606 OID 25373)
-- Dependencies: 1489 1489
-- Name: PrimaryKey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY usertable
    ADD CONSTRAINT "PrimaryKey" PRIMARY KEY (subjectid);


--
-- TOC entry 1761 (class 2606 OID 25375)
-- Dependencies: 1480 1480
-- Name: dhkatable_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY dhkatable
    ADD CONSTRAINT dhkatable_pkey PRIMARY KEY (subjectid);


--
-- TOC entry 1763 (class 2606 OID 25377)
-- Dependencies: 1481 1481
-- Name: filetable_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY filetable
    ADD CONSTRAINT filetable_pkey PRIMARY KEY (objectid);


--
-- TOC entry 1765 (class 2606 OID 25379)
-- Dependencies: 1483 1483
-- Name: grouptable_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY grouptable
    ADD CONSTRAINT grouptable_pkey PRIMARY KEY (groupid);


--
-- TOC entry 1767 (class 2606 OID 25381)
-- Dependencies: 1487 1487
-- Name: tokentable_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY tokentable
    ADD CONSTRAINT tokentable_pkey PRIMARY KEY (tokenid);


--
-- TOC entry 1770 (class 2606 OID 25382)
-- Dependencies: 1489 1768 1481
-- Name: filetable_owner_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY filetable
    ADD CONSTRAINT filetable_owner_fkey FOREIGN KEY (owner) REFERENCES usertable(subjectid);


--
-- TOC entry 1780 (class 0 OID 0)
-- Dependencies: 6
-- Name: public; Type: ACL; Schema: -; Owner: postgres
--

REVOKE ALL ON SCHEMA public FROM PUBLIC;
REVOKE ALL ON SCHEMA public FROM postgres;
GRANT ALL ON SCHEMA public TO postgres;
GRANT ALL ON SCHEMA public TO PUBLIC;


-- Completed on 2009-09-26 16:40:19

--
-- PostgreSQL database dump complete
--

