#ifndef DHJSON_H_INCLUDED
#define DHJSON_H_INCLUDED
#include <strings.h>

#include "json_spirit.h"
using namespace std;
using namespace json_spirit;



struct TOKEN
{
    string token;
    string label;
};

/**

*/
struct DHKEY
{
    bool operator==( const DHKEY& lhs ) const
    {
        return ( private_key == lhs.private_key ) &&
               ( public_key  == lhs.public_key ) &&
               ( grpsrc  == lhs.grpsrc ) &&
               ( grpdst  == lhs.grpdst );
    }
    //string keysel;
    string private_key;
    string public_key;
    string grpsrc;
    string grpdst;

    vector<TOKEN>* tokens;
};


struct ResultTokens
{
    bool operator==( const ResultTokens& lhs ) const
    {
        return ( label == lhs.label ) &&
               ( token  == lhs.token ) &&
               ( grpsrc  == lhs.grpsrc ) &&
               ( grpdst  == lhs.grpdst );
    }

    string label;
    string token;
    string grpsrc;
    string grpdst;
};



/**
    Add a pair record to the tree
    \param Object& obj, current object
    \param const string& name, name of the field
    \param const Value& value, value of the field

*/
void add_pair( Object& obj, const string& name, const Value& value );


/**
    Adds a new child object to an existing object,
    \return the new child object
*/
Object& add_child_obj( Object& parent, const string& name );


/**
    Adds a new child object to an existing array,
    \return the new child object
*/
Object& add_child_obj( Array& parent );

/**
    Adds a new array object ,
    \return the new array object
*/
Array& add_array( Object& obj, const string& name );

/**
    Compare
    \param const Pair& pair, field to compare
    \param const string& name, field to compare
    \return true if equals, else otherwise
*/
bool same_name( const Pair& pair, const string& name );

/**
    Find if contain a particular value
    \param const Object& obj, object scanning
    \param const string& name, field to search
    \return Value& find_value, the object find else return Value::null
*/
const Value& find_value( const Object& obj, const string& name );

/**
*/
const Array& find_array( const Object& obj, const string& name );


int find_int( const Object& obj, const string& name );

string find_str( const Object& obj, const string& name );

void read_dhkey( const Object& obj, DHKEY& dhkey );
vector< DHKEY > read_dhkeys( const char* file_name );


void write_dhkey( Array& a, const ResultTokens& resultTokens );
void write_dhkeys( const char* file_name, vector<ResultTokens>resultTokens);

void read_token( const Object& obj, TOKEN& record );

#endif
