#include <iostream>
#include <string.h>
#include "helper.h"
#include "dhjson.h"
#include "hbel.h"

#define VERBOSE


//5 exec e jsonfile filedacifrare pin :
//return the encrypted file in the \temp folder of the ext and the json file in the \temp folder of tokens

// 5exec d jsonofile filedec pin : return the decrypted file

// 3 exec dh pin  fileout : generate the two keys and store them in a json file; and add the key-hash (sha1 of the key)
int main(int argc, char *argv[])
{

     byte* aeskey= NULL;

    if(argc == 6)
    {
        char* prgname   = argv[0];
        char  op        = argv[1][0];
        char* jsonin    = argv[2];
        char* filein    = argv[3];
        char* fileout   = argv[4];
        char* pin       = argv[5];

        byte* ownpriv   = generateOwnerKey(pin);

        string temp = jsonin;
        temp = temp.insert(temp.rfind("."), "out");

        char *jsonout   = new char[255];
        jsonout =(char*)temp.c_str();

        //cout << "op: " << op << endl;
        //cout << "file in: " << filein << endl;
        //cout << "file out " << fileout << endl;
        //cout << "json in: " << jsonin << endl;
        //cout << "json out " << jsonout << endl;

        if(op =='e')
        {
            // Calculation of aeskey for encrytption file
            aeskey = prepareEncryption(jsonin, jsonout, pin);

            if(aeskey == NULL)
            {
                cerr << "Error during obtain key!" << endl;
            }
            else
            {
                encryptFile(aeskey, filein, fileout);
            }

        }

        else if(op == 'd')
        {
           // Calculation of aeskey for encrytption file
           aeskey = prepareDecryption(jsonin, pin);
           vector< DHKEY >  v = read_dhkeys(jsonin);
           decryptFile(aeskey, filein, fileout);
        }

        else
        {
            // undefined operation
            cerr << "No valid param 1. Please use 'd' to decrypt or 'e' to encrypt" << endl;
            return -1;
        }
    }

    else if(argc == 5)
    {
        char* prgname   = argv[0];
        char  op        = argv[1][0];
        char* jsonin    = argv[2];
        char* pin       = argv[3];
        char* fileout   = argv[4];

        if(op == 'h')
        {

            byte* keydest = prepareDecryptionHBEL(jsonin, pin);

            string privatekey = "";

             HBEL* hbel = read_hbel_tree(jsonin);

            for (vector< HBELNODE >::iterator it = hbel->node->begin(); it != hbel->node->end(); ++it)
            {
                privatekey = it->private_key;
            }
            string jsonout = "";
            int i = 0;
            for (vector< HBELDEF >::iterator itd = hbel->def->begin(); itd != hbel->def->end(); ++itd)
            {
                i++;
                byte* kAgree = KeyAgreement((char*)privatekey.c_str(),
                                                (char*)itd->hbel_public_key.c_str(),
                                                bytes(generateOwnerKey(pin)));
                char* label = generateRandomLabel();
                string sLabel = label;
                jsonout +=  (string) "{ " +
                            (string) "\"label"     + (string)"\":\"" +  sLabel +           (string)"\"," +
                            (string) "\"grpsrc"    + (string)"\":\"" +  itd->hbel_grpsrc + (string)"\"," +
                            (string) "\"grpdst"    + (string)"\":\"" +  itd->hbel_grpdst + (string)"\"," +
                            (string) "\"token"     + (string)"\":\"" +  bytes(createTokenHBEL(kAgree, bytes(keydest), label))+
                            (string) "\"}";

                if(i < hbel->def->size())
                    jsonout += ",";
            }
            ofstream out;
            out.open(fileout);
            out << "{ \"values\":[" << jsonout << "]}";
            out.close();
        }
    }
    else if(argc == 4)
    {
        char* prgname   = argv[0];
        char* op        = argv[1];
        char* pin       = argv[2];
        char* fileout   = argv[3];


        if(strcmp(op, "dh") == 0)
        {
            ofstream file;
            file.open(fileout, ios::out);

            if (file.fail())
            {
                cerr << "Error writing DH Keys" << endl;
                return -1;

            }

            char* fileout   = argv[3];
            file << generateDiffieHellmanKeysPair(pin);
            file.close();
        }
        else
        {
             // undefined operation
            cerr << "No valid param 1. Please use 'dh' pin fileout" << endl;
            return -1;
        }
    }
    else
    {
        cerr << "No valid sintax, please use dh [d | e] jsonin file.in  file.out pin" <<endl
             << "Example: ./dh e jsonin.txt file.pdf file.dat 12345" <<endl << endl;

        cerr << "No valid sintax, please use dh dh pin fileout" <<endl
             << "Example: ./dh e jsonin.txt file.pdf file.dat 12345" <<endl << endl;
        return -1;
    }

    return 0;
}
