package clientFunction;

/**
  * This class converts a byte vector into a an hexadecimal string and viceversa 
 */
public class Conversion {
	
	public static String toStr(byte[] block) {
		StringBuffer buf = new StringBuffer();

		int len = block.length;

		for (int i = 0; i < len; i++) {
			byte2hex(block[i], buf);
		}

		return buf.toString();
	}

	private static void byte2hex(byte b, StringBuffer buf) {
		char[] hexChars = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D',
				'E', 'F'};
		int high = ((b & 0xf0) >> 4);
		int low = (b & 0x0f);
		buf.append(hexChars[high]);
		buf.append(hexChars[low]);
	}
	
	public static byte[] toBytes(String strToConvert) {

		byte[] byteSeq = new byte[strToConvert.length() / 2];

		for (int i = 0; i < strToConvert.length() / 2; i++) {

			byteSeq[i] = (byte) 0xff;
			switch (strToConvert.charAt(i * 2)) {
				case '0' :
					byteSeq[i] = (byte) (byteSeq[i] & (byte) 0x0f);
					break;
				case '1' :
					byteSeq[i] = (byte) (byteSeq[i] & (byte) 0x1f);
					break;
				case '2' :
					byteSeq[i] = (byte) (byteSeq[i] & (byte) 0x2f);
					break;
				case '3' :
					byteSeq[i] = (byte) (byteSeq[i] & (byte) 0x3f);
					break;
				case '4' :
					byteSeq[i] = (byte) (byteSeq[i] & (byte) 0x4f);
					break;
				case '5' :
					byteSeq[i] = (byte) (byteSeq[i] & (byte) 0x5f);
					break;
				case '6' :
					byteSeq[i] = (byte) (byteSeq[i] & (byte) 0x6f);
					break;
				case '7' :
					byteSeq[i] = (byte) (byteSeq[i] & (byte) 0x7f);
					break;
				case '8' :
					byteSeq[i] = (byte) (byteSeq[i] & (byte) 0x8f);
					break;
				case '9' :
					byteSeq[i] = (byte) (byteSeq[i] & (byte) 0x9f);
					break;
				case 'A' :
					byteSeq[i] = (byte) (byteSeq[i] & (byte) 0xaf);
					break;
				case 'B' :
					byteSeq[i] = (byte) (byteSeq[i] & (byte) 0xbf);
					break;
				case 'C' :
					byteSeq[i] = (byte) (byteSeq[i] & (byte) 0xcf);
					break;
				case 'D' :
					byteSeq[i] = (byte) (byteSeq[i] & (byte) 0xdf);
					break;
				case 'E' :
					byteSeq[i] = (byte) (byteSeq[i] & (byte) 0xef);
					break;
				case 'F' :
					byteSeq[i] = (byte) (byteSeq[i] & (byte) 0xff);
					break;
			}
			switch (strToConvert.charAt((i * 2) + 1)) {
				case '0' :
					byteSeq[i] = (byte) (byteSeq[i] & (byte) 0xf0);
					break;
				case '1' :
					byteSeq[i] = (byte) (byteSeq[i] & (byte) 0xf1);
					break;
				case '2' :
					byteSeq[i] = (byte) (byteSeq[i] & (byte) 0xf2);
					break;
				case '3' :
					byteSeq[i] = (byte) (byteSeq[i] & (byte) 0xf3);
					break;
				case '4' :
					byteSeq[i] = (byte) (byteSeq[i] & (byte) 0xf4);
					break;
				case '5' :
					byteSeq[i] = (byte) (byteSeq[i] & (byte) 0xf5);
					break;
				case '6' :
					byteSeq[i] = (byte) (byteSeq[i] & (byte) 0xf6);
					break;
				case '7' :
					byteSeq[i] = (byte) (byteSeq[i] & (byte) 0xf7);
					break;
				case '8' :
					byteSeq[i] = (byte) (byteSeq[i] & (byte) 0xf8);
					break;
				case '9' :
					byteSeq[i] = (byte) (byteSeq[i] & (byte) 0xf9);
					break;
				case 'A' :
					byteSeq[i] = (byte) (byteSeq[i] & (byte) 0xfa);
					break;
				case 'B' :
					byteSeq[i] = (byte) (byteSeq[i] & (byte) 0xfb);
					break;
				case 'C' :
					byteSeq[i] = (byte) (byteSeq[i] & (byte) 0xfc);
					break;
				case 'D' :
					byteSeq[i] = (byte) (byteSeq[i] & (byte) 0xfd);
					break;
				case 'E' :
					byteSeq[i] = (byte) (byteSeq[i] & (byte) 0xfe);
					break;
				case 'F' :
					byteSeq[i] = (byte) (byteSeq[i] & (byte) 0xff);
					break;
			}
		}
		return byteSeq;
	}
}
