package clientFunction;

import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.LinkedList;
import java.util.StringTokenizer;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

public class SharedFile {
	String filePath;
	public String ownerID;

	public String userID;

	public String fileID;

	byte[] ownerKey;

	byte[] ownerPrivateDHKey;

	UserListElement[] authList;

	static AccessGraph accessGraph;

	String groupIDBEL = null;

	public String getGroupIDBEL() {
		return groupIDBEL;
	}

	public SharedFile() {
		return;
	}

	public SharedFile(String filePath, String ownerID, String ownerUserName,
			UserListElement[] authList) {
		this.filePath = filePath;
		this.ownerID = ownerID;
		this.authList = authList;

		try {
			FileInputStream fin;
			DataInputStream dis;
			fin = new FileInputStream("Key" + File.separatorChar
					+ ownerUserName);
			dis = new DataInputStream(fin);
			ownerKey = new byte[16];
			dis.read(this.ownerKey);
			fin.close();
		} catch (Exception e) {
			System.err.println(e.toString());
		}

	}

	public void setSharedFile(String filePath, String ownerID,
			UserListElement[] authList) {
		this.filePath = filePath;
		this.ownerID = ownerID;
		this.authList = authList;
	}

	public void setFileToEncrypt(String filePath, String ownerID,
			String[] authList) {
		this.filePath = filePath;
		this.ownerID = ownerID;

		int numUser = authList.length;

		if (authList[0].equals(""))
			numUser = 0;

		UserListElement[] userAuth = new UserListElement[numUser + 1];
		for (int i = 0; i < authList.length; i++) {
			if (!authList[i].equals(""))
				userAuth[i] = new UserListElement(authList[i]);
		}

		userAuth[numUser] = new UserListElement(ownerID.toString());

		this.authList = userAuth;
	}

	public void setID(String id) {
		this.fileID = id;
	}

	private void setOwnerId(String id) {
		this.ownerID = id;
	}

	public boolean createBEL(String keysel) {

		String groupIDBEL = null;
		accessGraph = new AccessGraph(0);

		ACL newAcl = new ACL();

		for (int a = 0; a < authList.length; a++) {
			newAcl.addUser(authList[a].getID());
		}
		groupIDBEL = newAcl.getID();

		LinkedList<String> listcod = new LinkedList<String>();
		for (int t = 0; t < accessGraph.getAllAcl().size(); ++t)
			listcod.add(accessGraph.getAllAcl().get(t).getID());

		if (!listcod.contains(newAcl.getID()))
		{
			if (authList.length == 1) { 

			} else {
				accessGraph.addAcl(newAcl);
				if (newAcl.getSize() == 2) 
				{
					String userID = null;
					if (newAcl.getUserList().get(0).equals(ownerID.toString()))
						userID = newAcl.getUserList().get(1);
					if (newAcl.getUserList().get(1).equals(ownerID.toString()))
						userID = newAcl.getUserList().get(0);
				} else
					try {
						System.err.println(createTokenToEncrypt(accessGraph,
								groupIDBEL));
					} catch (JSONException e) {
						
						e.printStackTrace();
					}

			}
		} else {
			accessGraph.CaricaIntervalli();

			try {
				System.err.println(createTokenToEncrypt(accessGraph, groupIDBEL));
			} catch (JSONException e) {
				e.printStackTrace();
			}

		}

		return true;

	}

	private static void abort(String msg) throws IOException {
		throw new IOException("FileCopy: " + msg);
	}

	public static void copy(String from_name, String to_name)
			throws IOException {
		File from_file = new File(from_name); // Get File objects from Strings
		File to_file = new File(to_name);

		// First make sure the source file exists, is a file, and is readable.
		if (!from_file.exists())
			abort("no such source file: " + from_name);
		if (!from_file.isFile())
			abort("can't copy directory: " + from_name);
		if (!from_file.canRead())
			abort("source file is unreadable: " + from_name);

		// If the destination is a directory, use the source file name
		// as the destination file name
		if (to_file.isDirectory())
			to_file = new File(to_file, from_file.getName());

		// If file doesn't exist, check if directory exists and is
		// writeable. If getParent() returns null, then the directory is
		// the current dir. so look up the user.dir system property to
		// find out what that is.
		String parent = to_file.getParent(); // The destination directory
		if (parent == null) // If none, use the current directory
			parent = System.getProperty("user.dir");
		File dir = new File(parent); // Convert it to a file.
		if (!dir.exists())
			abort("destination directory doesn't exist: " + parent);
		if (dir.isFile())
			abort("destination is not a directory: " + parent);
		if (!dir.canWrite())
			abort("destination directory is unwriteable: " + parent);
		// }

		// If we've gotten this far, then everything is okay.
		// So we copy the file, a buffer of bytes at a time.
		FileInputStream from = null; // Stream to read from source
		FileOutputStream to = null; // Stream to write to destination
		try {
			from = new FileInputStream(from_file); // Create input stream
			to = new FileOutputStream(to_file); // Create output stream
			byte[] buffer = new byte[4096]; // To hold file contents
			int bytes_read; // How many bytes in buffer

			// Read a chunk of bytes into the buffer, then write them out,
			// looping until we reach the end of the file (when read() returns
			// -1). Note the combination of assignment and comparison in this
			// while loop. This is a common I/O programming idiom.
			while ((bytes_read = from.read(buffer)) != -1)
				// Read until EOF
				to.write(buffer, 0, bytes_read); // write
		}
		// Always close the streams, even if exceptions were thrown
		finally {
			if (from != null)
				try {
					from.close();
				} catch (IOException e) {
					;
				}
			if (to != null)
				try {
					to.close();
				} catch (IOException e) {
					;
				}
		}
	}

	private boolean ingiafatto(ACL acl, LinkedList<ACL> giafatto) {
		int i = 0;
		while (i < giafatto.size()) {
			if (giafatto.get(i).contains(acl)) {
				return true;
			}
			i++;

		}
		return false;
	}

	public static byte[] getKeySEL(String keyID, AccessGraphSEL accessgraph,
			String ownerID, String userid) {

		byte[] aesKey = null;
		String key = keyID;
		Token newToken;
		DBConnection connection = new DBConnection();
		ACL antenato = new ACL();
		LinkedList<Token> tokenPath = new LinkedList<Token>();

		try {

			ACLSEL acl = new ACLSEL();
			acl = accessgraph.getACLfromID(key);

			LinkedList<String> codici = new LinkedList<String>();
			codici = acl.getUserList();
			LinkedList<ACLSEL> foglie = new LinkedList<ACLSEL>();
			foglie = accessgraph.getAclListBySize(2);
			// String userid= new String();
			if (acl.getSize() == 2)
			{

				aesKey = DHKeyAgreementFunction.buildDHKey(userid, ownerID
						.toString());

			} else {

				antenato.addUser(ownerID);
				antenato.addUser(userid);
				LinkedList<ACLSEL> percorso = new LinkedList<ACLSEL>();

				
				esplora_albero(accessgraph, antenato.getID(), percorso, acl);

				Statement stmt = connection.getConnection().createStatement(
						ResultSet.TYPE_SCROLL_INSENSITIVE,
						ResultSet.CONCUR_UPDATABLE);
				ResultSet rset = stmt
						.executeQuery("SELECT groupidsource,groupiddestination,token,label from tokentable where level = 'SEL'");
				for (int j = 0; j < percorso.size() - 1; j++) {
					rset.first();
					do {

						if ((rset.getString(1).equals(percorso.get(j).getID()))
								&& (rset.getString(2).equals(percorso
										.get(j + 1).getID()))) {
							newToken = new Token(rset.getString(1), rset
									.getString(2), Conversion.toBytes(rset
									.getString(3)), rset.getString(4));
							tokenPath.add(newToken);

						}
					} while (rset.next());
				}

				aesKey = DHKeyAgreementFunction.buildDHKey(userid, ownerID
						.toString());

				for (int i = 0; i < tokenPath.size(); i++) {

					aesKey = Token.rebuildKey(aesKey, tokenPath.get(i)
							.getToken(), tokenPath.get(i).getLabel());
				}
			}

		} catch (Exception e) {
			System.err.println(e.toString());
		}
		connection.closeConnection();

		return aesKey;
	}

	public static boolean checkEncStatus(String fileID) {
		DBConnection connection = new DBConnection();
		boolean status = true;
		String keyidsel;

		try {
			Statement stmt = connection.getConnection().createStatement();
			ResultSet rset = stmt
					.executeQuery("SELECT * from filetable  where objectid ='"
							+ fileID + "'");
			if (rset != null) {
				while (rset.next()) {
					keyidsel = rset.getString(3);
					if ((keyidsel.equals("")) || (keyidsel == null)) {
						status = false;
					}
				}
			}
			rset.close();
			stmt.close();
		} catch (Exception e) {
			System.err.println(e.toString());
		}
		connection.closeConnection();
		return status;
	}

	private static void pulisci(ACL newAcl, ACL figlio) {

		LinkedList<ACL> padri = newAcl.getAncestor();
		for (int i = 0; i < padri.size(); ++i) {
			if (figlio.contains(padri.get(i))) {
				removeTokenFromDB(padri.get(i).getID(), figlio.getID(), "BEL");
			}
		}
	}

	private static boolean removeTokenFromDB(String keyIDSource,
			String keyIDDestination, String tipo) {

		DBConnection connection = new DBConnection();
		try {
			Statement stmt = connection.getConnection().createStatement();
			ResultSet rset = stmt
					.executeQuery("select * from tokentable where groupidsource = '"
							+ keyIDSource
							+ "' and groupiddestination ="
							+ "'"
							+ keyIDDestination + "'and level='" + tipo + "'");
			if (rset != null) {
				stmt.execute("delete from tokentable where groupidsource = '"
						+ keyIDSource + "' and groupiddestination =" + "'"
						+ keyIDDestination + "'and level='" + tipo + "'");
				stmt.close();
			}

			rset.close();
			stmt.close();

		} catch (Exception e) {
			System.err.println(e.toString());
			return false;
		}

		return true;
	}

	private static void esplora_albero(AccessGraph ag, String sorgente,
			LinkedList<ACL> list, ACL destinazione) {
		int ndest = ag.getACLfromID(destinazione.getID()).getNum();

		String corr = sorgente;
		do {
			list.add(ag.getACLfromID(corr));
			ACL acl = ag.getACLfromID(corr);
			String copia = corr;
			for (int i = 0; i < acl.getDescendents().size(); ++i) {
				ACL disc = ag.getACLfromID(acl.getDescendents().get(i).getID());
				for (int j = 0; j < disc.getIntervalli().size(); ++j) {
					if (disc.getIntervalli().get(j).contiene(ndest)) {
						corr = disc.getID();
					}
				}
			}
			if (copia.equals(corr))  break;
		} while (!corr.equals(destinazione));
		if (corr.equals(destinazione.getID())) {
			
		} else {
			list.clear();
			list = new LinkedList<ACL>();

		}

		return;

	}

	private static void esplora_albero(AccessGraphSEL ag, String sorgente,
			LinkedList<ACLSEL> list, ACLSEL destinazione) {
		int ndest = ag.getACLfromID(destinazione.getID()).getNum();

		String corr = sorgente;
		do {
			list.add(ag.getACLfromID(corr));
			ACLSEL acl = ag.getACLfromID(corr);
			String copia = corr;
			for (int i = 0; i < acl.getDescendents().size(); ++i) {
				ACLSEL disc = ag.getACLfromID(acl.getDescendents().get(i)
						.getID());
				for (int j = 0; j < disc.getIntervalli().size(); ++j)
					if (disc.getIntervalli().get(j).contiene(ndest))
						corr = disc.getID();
			}
			if (copia.equals(corr))
				break;
		} while (!corr.equals(destinazione));
		if (corr.equals(destinazione.getID())) {
			
		} else {
			list.clear();
			list = new LinkedList<ACLSEL>();

		}

		return;

	}

	private JSONObject createTokenToEncrypt(AccessGraph accessGraph,
			String newGroup) throws JSONException {

		ACL newAcl = new ACL();
		accessGraph.CaricaIntervalli();
		JSONObject response = new JSONObject();
		JSONArray array = new JSONArray();

		for (int a = 0; a < authList.length; a++) {
			newAcl.addUser(authList[a].getID());
		}

		LinkedList<String> userList = newAcl.getUserList();
		if (newAcl.getSize() > 2)

		{
			LinkedList<ACL> antenati = new LinkedList<ACL>();
			for (int i = 0; i < userList.size(); i++) {
				if (!userList.get(i).equals(ownerID.toString()))
				{
					ACL nuovo = new ACL();
					nuovo.addUser(ownerID.toString());
					nuovo.addUser(userList.get(i));
					antenati.add(nuovo);
				}
			}

			for (int i = 0; i < antenati.size(); i++) {
				if (!accessGraph.getAllAcl().contains(antenati.get(i)))
				{
					accessGraph.addAcl(antenati.get(i));
				}
			}
		}

		LinkedList<ACL> giafatto = new LinkedList<ACL>();
		LinkedList<ACL> list = new LinkedList<ACL>();

		for (int i = newAcl.getSize() - 1; i > 1; --i) {

			list = accessGraph.getAclListBySize(i);
			if (list != null) {

				for (int j = 0; j < list.size(); ++j) {
					if (list.get(j).getUserList().contains(ownerID.toString()))
						if (newAcl.contains(list.get(j))
								&& (!ingiafatto(list.get(j), giafatto))) {
							list.get(j).addDescendent(newAcl);
							newAcl.addAncestor(list.get(j));
							JSONObject keys = getTokenToEncrypt(list.get(j)
									.getID(), accessGraph);
							AccessGraph temp = new AccessGraph(0);
							temp.CaricaIntervalli();
							if (list.get(j).getSize() > 2)
								keys = getExistentTokenToEncrypt(list.get(j)
										.getID(), temp);


							JSONObject ob = new JSONObject();
							ob.put("private", keys.get("private"));
							ob.put("public", keys.get("public"));
							ob.put("grpsrc", list.get(j).getID());
							ob.put("grpdst", newGroup);
							ob.put("tokens", keys.get("tokens"));
							array.put(ob);

							giafatto.add(list.get(j));
						}

				}
			}
		}

		response.put("values", array);
		return response;

	}
	private JSONObject getTokenToEncrypt(String keyID, AccessGraph accessgraph) {

		byte[] aesKey = null;
		String key = keyID;
		Token newToken;
		DBConnection connection = new DBConnection();
		ACL antenato = new ACL();
		LinkedList<Token> tokenPath = new LinkedList<Token>();

		// RETURN
		JSONObject ob = new JSONObject();
		JSONArray array = new JSONArray();
		JSONObject temp = new JSONObject();

		try {

			ACL acl = new ACL();
			acl = accessgraph.getACLfromID(key);

			LinkedList<String> codici = new LinkedList<String>();
			codici = acl.getUserList();
			LinkedList<ACL> foglie = new LinkedList<ACL>();
			foglie = accessgraph.getAclListBySize(2);
			String userid = new String();
			if (acl.getSize() == 2)
			{
				if (acl.getUserList().get(0).equals(ownerID.toString())) {
					userid = acl.getUserList().get(1);
				}
				if (acl.getUserList().get(1).equals(ownerID.toString())) {
					userid = acl.getUserList().get(0);
				}

				Statement stmt = connection.getConnection().createStatement(
						ResultSet.TYPE_SCROLL_INSENSITIVE,
						ResultSet.CONCUR_UPDATABLE);
				ResultSet rset = stmt
						.executeQuery("SELECT privatekey from dhkatable where subjectid = "
								+ ownerID.toString());
				rset.first();

				ob.put("private", rset.getString(1));

				rset = stmt
						.executeQuery("SELECT publickey from dhkatable where subjectid = "
								+ userid);
				rset.first();

				ob.put("public", rset.getString(1));
				ob.put("tokens", array);

				// ---------------------------------------------------------------------------------------

			} else {


				for (int i = 0; i < foglie.size(); ++i) {
					LinkedList<String> list = new LinkedList<String>();
					list = foglie.get(i).getUserList();

					if (ownerID.toString().equals(list.get(0))) {
						for (int j = 0; j < codici.size(); ++j)
							if (list.get(1).equals(codici.get(j)))
								antenato = foglie.get(i);
					}
					if (ownerID.toString().equals(list.get(1))) {
						for (int j = 0; j < codici.size(); ++j)
							if (list.get(0).equals(codici.get(j)))
								antenato = foglie.get(i);
					}

				}

				LinkedList<ACL> percorso = new LinkedList<ACL>();
				esplora_albero(accessgraph, antenato.getID(), percorso, acl);

				Statement stmt = connection.getConnection().createStatement(
						ResultSet.TYPE_SCROLL_INSENSITIVE,
						ResultSet.CONCUR_UPDATABLE);
				ResultSet rset = stmt
						.executeQuery("SELECT groupidsource,groupiddestination,token,label from tokentable where level = 'BEL'");
				for (int j = 0; j < percorso.size() - 1; j++) {

					rset.first();
					do {

						if ((rset.getString(1).equals(percorso.get(j).getID()))
								&& (rset.getString(2).equals(percorso
										.get(j + 1).getID()))) {
							temp.put("token", rset.getString(3));
							temp.put("label", rset.getString(4));
							array.put(temp);

						}
					} while (rset.next());
				}

				if (antenato.getUserList().get(0).equals(ownerID.toString())) {
					userid = antenato.getUserList().get(1);
				}
				if (antenato.getUserList().get(1).equals(ownerID.toString())) {
					userid = antenato.getUserList().get(0);
				}
				rset = stmt
						.executeQuery("SELECT privatekey from dhkatable where subjectid = "
								+ ownerID.toString());
				rset.first();

				ob.put("private", rset.getString(1));

				rset = stmt
						.executeQuery("SELECT publickey from dhkatable where subjectid = "
								+ userid);
				rset.first();

				ob.put("public", rset.getString(1));

				ob.put("tokens", array);
			}

		} catch (Exception e) {
			System.err.println(e.toString());
		}
		connection.closeConnection();

		return ob;
	}

	private JSONObject getTokenToDecrypt(String keyID, AccessGraph accessgraph) {

		byte[] aesKey = null;
		String key = keyID;
		Token newToken;
		DBConnection connection = new DBConnection();
		ACL antenato = new ACL();
		LinkedList<Token> tokenPath = new LinkedList<Token>();

		// RETURN
		JSONObject ob = new JSONObject();
		JSONArray array = new JSONArray();
		JSONObject temp = new JSONObject();

		try {

			ACL acl = new ACL();
			acl = accessgraph.getACLfromID(key);

			LinkedList<String> codici = new LinkedList<String>();
			codici = acl.getUserList();
			LinkedList<ACL> foglie = new LinkedList<ACL>();
			foglie = accessgraph.getAclListBySize(2);
			String userid = new String();
			if (acl.getSize() == 2)
			{
				if (acl.getUserList().get(0).equals(ownerID.toString())) {
					userid = acl.getUserList().get(1);
				}
				if (acl.getUserList().get(1).equals(ownerID.toString())) {
					userid = acl.getUserList().get(0);
				}

				Statement stmt = connection.getConnection().createStatement(
						ResultSet.TYPE_SCROLL_INSENSITIVE,
						ResultSet.CONCUR_UPDATABLE);
				ResultSet rset = stmt
						.executeQuery("SELECT privatekey from dhkatable where subjectid = "
								+ userid);
				rset.first();

				ob.put("private", rset.getString(1));

				rset = stmt
						.executeQuery("SELECT publickey from dhkatable where subjectid = "
								+ userID);
				rset.first();

				ob.put("public", rset.getString(1));
				ob.put("tokens", array);

				// ---------------------------------------------------------------------------------------

			} else {

				for (int i = 0; i < foglie.size(); ++i) {
					LinkedList<String> list = new LinkedList<String>();
					list = foglie.get(i).getUserList();

					if (ownerID.toString().equals(list.get(0))) {
						for (int j = 0; j < codici.size(); ++j)
							if (list.get(1).equals(codici.get(j)))
								antenato = foglie.get(i);
					}
					if (ownerID.toString().equals(list.get(1))) {
						for (int j = 0; j < codici.size(); ++j)
							if (list.get(0).equals(codici.get(j)))
								antenato = foglie.get(i);
					}

				}

				LinkedList<ACL> percorso = new LinkedList<ACL>();
				esplora_albero(accessgraph, antenato.getID(), percorso, acl);

				Statement stmt = connection.getConnection().createStatement(
						ResultSet.TYPE_SCROLL_INSENSITIVE,
						ResultSet.CONCUR_UPDATABLE);
				ResultSet rset = stmt
						.executeQuery("SELECT groupidsource,groupiddestination,token,label from tokentable where level = 'BEL'");
				for (int j = 0; j < percorso.size() - 1; j++) {

					rset.first();
					do {

						if ((rset.getString(1).equals(percorso.get(j).getID()))
								&& (rset.getString(2).equals(percorso
										.get(j + 1).getID()))) {
							temp.put("token", rset.getString(3));
							temp.put("label", rset.getString(4));
							array.put(temp);

						}
					} while (rset.next());
				}

				if (antenato.getUserList().get(0).equals(ownerID.toString())) {
					userid = antenato.getUserList().get(1);
				}
				if (antenato.getUserList().get(1).equals(ownerID.toString())) {
					userid = antenato.getUserList().get(0);
				}
				rset = stmt
						.executeQuery("SELECT privatekey from dhkatable where subjectid = "
								+ ownerID.toString());
				rset.first();

				ob.put("private", rset.getString(1));

				rset = stmt
						.executeQuery("SELECT publickey from dhkatable where subjectid = "
								+ userid);
				rset.first();

				ob.put("public", rset.getString(1));

				ob.put("tokens", array);
			}

		} catch (Exception e) {
			System.err.println(e.toString());
		}
		connection.closeConnection();

		return ob;
	}

	private JSONObject getExistentTokenToDecrypt(String keyID,
			AccessGraph accessgraph) {

		String key = keyID;
		DBConnection connection = new DBConnection();
		ACL antenato = new ACL();

		// RETURN
		JSONObject ob = new JSONObject();
		JSONArray array = new JSONArray();
		JSONObject temp = new JSONObject();

		try {

			ACL acl = new ACL();
			acl = accessgraph.getACLfromID(key);

			String userid = new String();

			if (groupLength(key) == 2) {

				userid = userID;
				Statement stmt = connection.getConnection().createStatement(
						ResultSet.TYPE_SCROLL_INSENSITIVE,
						ResultSet.CONCUR_UPDATABLE);
				ResultSet rset = stmt
						.executeQuery("SELECT privatekey from dhkatable where subjectid = "
								+ userid);
				rset.first();

				ob.put("private", rset.getString(1));

				rset = stmt
						.executeQuery("SELECT publickey from dhkatable where subjectid = "
								+ ownerID);
				rset.first();

				ob.put("public", rset.getString(1));
				ob.put("tokens", array);

			} else {

				String idPubblica = null;
				String idPrivata = null;

				String corr = keyID;
				String dest = keyID;
				String currentGroup = "";
				int count = 0; 
				Statement stmt = connection.getConnection().createStatement(
						ResultSet.TYPE_SCROLL_INSENSITIVE,
						ResultSet.CONCUR_UPDATABLE);
				ResultSet rset;

				do {
					ACL tempAcl = accessgraph.getACLfromID(dest);
					for (int i = 0; i < tempAcl.getAncestor().size(); ++i) {
						count++;
						currentGroup = tempAcl.getAncestor().get(i).getID();
						if (groupContainsUser(currentGroup, userID)
								&& (groupLength(currentGroup) < groupLength(dest))) {
							dest = currentGroup;
							count = 0;
						}

						
						if (groupLength(currentGroup) == 2 && count > i + 10)
							dest = "0-0";
					}
				} while (groupLength(dest) > 2);

				if (dest.equals("0-0")) {
					
					rset = stmt
							.executeQuery("SELECT groupidsource from tokentable where level = 'HBEL' and groupiddestination = '"
									+ keyID + "'");
					while (rset.next()) {
						if (groupContainsUser(rset.getString(1), userID)) {
							dest = rset.getString(1);
						}
					}

					if (userID.equals(dest.split("-")[0])) {
						idPrivata = dest.split("-")[0];
						idPubblica = dest.split("-")[1];
					} else if (userID.equals(dest.split("-")[1])) {
						idPrivata = dest.split("-")[1];
						idPubblica = dest.split("-")[0];
					}

					rset = stmt
							.executeQuery("SELECT groupidsource,groupiddestination,token,label from tokentable where level = 'HBEL' and groupidsource = '" + dest + "' and groupiddestination = '" + keyID + "'");
					rset.next();
					
					temp = new JSONObject();

					temp.put("token", rset.getString(3));
					temp.put("label", rset.getString(4));

					array.put(temp);
					
				} else {

					antenato = accessgraph.getACLfromID(dest);
					
					if (userID.equals(antenato.getUserList().get(0))) {
						idPrivata = antenato.getUserList().get(0);
						idPubblica = antenato.getUserList().get(1);
					} else if (userID.equals(antenato.getUserList().get(1))) {
						idPrivata = antenato.getUserList().get(1);
						idPubblica = antenato.getUserList().get(0);
					}

					LinkedList<ACL> percorso = new LinkedList<ACL>();

					esplora_albero(accessgraph, antenato.getID(), percorso, acl);

					rset = stmt
							.executeQuery("SELECT groupidsource,groupiddestination,token,label from tokentable where level = 'BEL'");
					for (int j = 0; j < percorso.size() - 1; j++) {

						rset.first();
						do {

							if ((rset.getString(1).equals(percorso.get(j)
									.getID()))
									&& (rset.getString(2).equals(percorso.get(
											j + 1).getID()))) {

								temp = new JSONObject();

								temp.put("token", rset.getString(3));
								temp.put("label", rset.getString(4));

								array.put(temp);

							}
						} while (rset.next());

					}
				}

				rset = stmt
						.executeQuery("SELECT privatekey from dhkatable where subjectid = "
								+ idPrivata);
				rset.first();

				ob.put("private", rset.getString(1));

				rset = stmt
						.executeQuery("SELECT publickey from dhkatable where subjectid = "
								+ idPubblica);
				rset.first();

				ob.put("public", rset.getString(1));

				ob.put("tokens", array);

			}

		} catch (Exception e) {
			System.err.println(e.toString());
		}
		connection.closeConnection();

		return ob;
	}

	private boolean groupContainsUser(String group, String user) {
		StringTokenizer users = new StringTokenizer(group, "-");
		while (users.hasMoreTokens()) {
			if (users.nextToken().equals(user))
				return true;
		}
		return false;
	}

	private int groupLength(String group) {
		StringTokenizer users = new StringTokenizer(group, "-");
		return users.countTokens();
	}

	private JSONObject getExistentTokenToEncrypt(String keyID,
			AccessGraph accessgraph) {

		byte[] aesKey = null;
		String key = keyID;
		Token newToken;
		DBConnection connection = new DBConnection();
		ACL antenato = new ACL();
		LinkedList<Token> tokenPath = new LinkedList<Token>();

	
		JSONObject ob = new JSONObject();
		JSONArray array = new JSONArray();
		JSONObject temp = new JSONObject();

		try {

			ACL acl = new ACL();
			acl = accessgraph.getACLfromID(key);

			LinkedList<String> codici = new LinkedList<String>();
			codici = acl.getUserList();
			LinkedList<ACL> foglie = new LinkedList<ACL>();
			foglie = accessgraph.getAclListBySize(2);
			String userid = new String();
			if (acl.getSize() == 2)
			{
				if (acl.getUserList().get(0).equals(ownerID.toString())) {
					userid = acl.getUserList().get(1);
				}
				if (acl.getUserList().get(1).equals(ownerID.toString())) {
					userid = acl.getUserList().get(0);
				}

				Statement stmt = connection.getConnection().createStatement(
						ResultSet.TYPE_SCROLL_INSENSITIVE,
						ResultSet.CONCUR_UPDATABLE);
				ResultSet rset = stmt
						.executeQuery("SELECT privatekey from dhkatable where subjectid = "
								+ ownerID.toString());
				rset.first();

				ob.put("private", rset.getString(1));

				rset = stmt
						.executeQuery("SELECT publickey from dhkatable where subjectid = "
								+ userid);
				rset.first();

				ob.put("public", rset.getString(1));
				ob.put("tokens", array);

				// ---------------------------------------------------------------------------------------

			} else {
				

				String corr = keyID;
				String dest = keyID;
				String currentGroup = "";
				do {
					ACL tempAcl = accessgraph.getACLfromID(dest);
					for (int i = 0; i < tempAcl.getAncestor().size(); ++i) {
						
						currentGroup = tempAcl.getAncestor().get(i).getID();
						if (groupContainsUser(currentGroup, ownerID)
								&& (groupLength(currentGroup) < groupLength(dest))) {
							dest = currentGroup;
						}
					}
				} while (groupLength(dest) > 2);

				antenato = accessgraph.getACLfromID(dest);

				LinkedList<ACL> percorso = new LinkedList<ACL>();

				esplora_albero(accessgraph, antenato.getID(), percorso, acl);

				Statement stmt = connection.getConnection().createStatement(
						ResultSet.TYPE_SCROLL_INSENSITIVE,
						ResultSet.CONCUR_UPDATABLE);
				ResultSet rset = stmt
						.executeQuery("SELECT groupidsource,groupiddestination,token,label from tokentable where level = 'BEL'");
				for (int j = 0; j < percorso.size() - 1; j++) {

					rset.first();
					do {

						if ((rset.getString(1).equals(percorso.get(j).getID()))
								&& (rset.getString(2).equals(percorso
										.get(j + 1).getID()))) {
							temp = new JSONObject();
							temp.put("token", rset.getString(3));
							temp.put("label", rset.getString(4));
							array.put(temp);

						}
					} while (rset.next());
				}


				if (antenato.getUserList().get(0).equals(ownerID.toString())) {
					userid = antenato.getUserList().get(1);
				}
				if (antenato.getUserList().get(1).equals(ownerID.toString())) {
					userid = antenato.getUserList().get(0);
				}

				rset = stmt
						.executeQuery("SELECT privatekey from dhkatable where subjectid = "
								+ ownerID);
				rset.first();

				ob.put("private", rset.getString(1));

				rset = stmt
						.executeQuery("SELECT publickey from dhkatable where subjectid = "
								+ userid);
				rset.first();

				ob.put("public", rset.getString(1));

				ob.put("tokens", array);
			}

		} catch (Exception e) {
			System.err.println(e.toString());
		}
		connection.closeConnection();

		return ob;
	}

	public static boolean putTokensInDB(String input, String belType)
			throws Exception {

		Connection NewUserConnection = Configuration.getConnection();
		Statement stmt = NewUserConnection.createStatement();

		JSONObject tokens = new JSONObject(input);
		JSONArray array = tokens.getJSONArray("values");
		JSONObject temp;

		try {
			for (int i = 0; i < array.length(); i++) {
				temp = array.getJSONObject(i);
				stmt
						.execute("Insert into tokentable (groupidsource,groupiddestination,token,label,level)"
								+ "values ( '"
								+ temp.getString("grpsrc")
								+ "','"
								+ temp.getString("grpdst")
								+ "','"
								+ temp.getString("token")
								+ "','"
								+ temp.getString("label")
								+ "','"
								+ belType
								+ "')");
			}
			stmt.close();
			accessGraph = new AccessGraph(0);
			accessGraph.CreaIntervalli();

		} catch (Exception e) {
			return false;
		}

		return true;
	}
	public JSONObject getJSONBEL(String fileId, String userId)
			throws SQLException, Exception {

		accessGraph = new AccessGraph(0);

		ACL newAcl = new ACL();

		Statement stmt = Configuration.getConnection().createStatement(
				ResultSet.TYPE_SCROLL_INSENSITIVE, ResultSet.CONCUR_UPDATABLE);
		ResultSet rset = stmt
				.executeQuery("SELECT * from filetable where objectid = "
						+ fileId);
		rset.first();

		ownerID = rset.getString("owner");

		this.ownerID = ownerID;
		this.userID = userId;

		if (ownerID.toString().equals(userId)) {
													// cui sono il proprietario
			StringTokenizer tempStringTokenizer = new StringTokenizer(rset
					.getString("keyidbel"), "-");
			String tempToken;
			while (tempStringTokenizer.hasMoreTokens()) {
				tempToken = (String) tempStringTokenizer.nextElement();
				if (!tempToken.equals(ownerID.toString())) {
					ownerID = (String) tempToken;
					break;
				}

			}
		}

		
		StringTokenizer tempStringTokenizer = new StringTokenizer(rset
				.getString("keyidbel"), "-");
		UserListElement[] userAuth = new UserListElement[tempStringTokenizer
				.countTokens()];
		int cont = 0;
		while (tempStringTokenizer.hasMoreTokens()) {
			userAuth[cont] = new UserListElement((String) tempStringTokenizer
					.nextElement());
			cont++;
		}
		this.authList = userAuth;
		
		for (int a = 0; a < authList.length; a++) {
			newAcl.addUser(authList[a].getID());
		}

		groupIDBEL = newAcl.getID();

		LinkedList<String> listcod = new LinkedList<String>();
		for (int t = 0; t < accessGraph.getAllAcl().size(); ++t)
			listcod.add(accessGraph.getAllAcl().get(t).getID());

		accessGraph.CaricaIntervalli();
		if (authList.length == 1) {
			JSONObject temp = new JSONObject();
			JSONArray array = new JSONArray();
			temp.put("values", array);
			return temp;
		} else {
			JSONObject result = new JSONObject();
			JSONArray array = new JSONArray();
			JSONObject temp = new JSONObject();

			temp = getExistentTokenToDecrypt(groupIDBEL, accessGraph);
			temp.put("grpsrc", "");
			temp.put("grpdst", "");
			array.put(temp);
			result.put("values", array);
			return result;
		}
	}

	public JSONObject createJSONBEL(String keysel) throws SQLException,
			Exception {

		accessGraph = new AccessGraph(0);

		ACL newAcl = new ACL();

		for (int a = 0; a < authList.length; a++) {
			newAcl.addUser(authList[a].getID());
		}
		groupIDBEL = newAcl.getID();

		LinkedList<String> listcod = new LinkedList<String>();
		for (int t = 0; t < accessGraph.getAllAcl().size(); ++t)
			listcod.add(accessGraph.getAllAcl().get(t).getID());

		if (!listcod.contains(newAcl.getID()))
		{
		        if (authList.length == 1) { 
				
				JSONObject temp = new JSONObject();
				JSONArray array = new JSONArray();
				temp.put("values", array);
				return temp;

			} else {
				accessGraph.addAcl(newAcl);
				if (newAcl.getSize() == 2) 
				
				{
					String userID = null;
					if (newAcl.getUserList().get(0).equals(ownerID.toString()))
						userID = newAcl.getUserList().get(1);
					if (newAcl.getUserList().get(1).equals(ownerID.toString()))
						userID = newAcl.getUserList().get(0);

					// ----------------------------------------------------------------
					JSONObject temp = new JSONObject();

					Statement stmt = Configuration.getConnection()
							.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE,
									ResultSet.CONCUR_UPDATABLE);
					ResultSet rset = stmt
							.executeQuery("SELECT privatekey from dhkatable where subjectid = "
									+ ownerID.toString());
					rset.first();

					temp.put("private", rset.getString(1));

					rset = stmt
							.executeQuery("SELECT publickey from dhkatable where subjectid = "
									+ userID);
					rset.first();

					temp.put("public", rset.getString(1));
					temp.put("tokens", new JSONArray());
					temp.put("grpsrc", "");
					temp.put("grpdst", "");

					JSONObject response = new JSONObject();
					JSONArray array = new JSONArray();
					array.put(temp);

					response.put("values", array);
					return response;
				} else
	
					try {
						return createTokenToEncrypt(accessGraph, groupIDBEL);
					} catch (JSONException e) {
						e.printStackTrace();
					}

			}
			
		} else {
			
			accessGraph.CaricaIntervalli();

			if (authList.length == 1) {
				JSONObject temp = new JSONObject();
				temp.put("values", "ownerkey");
				return temp;
			} else {
				JSONObject result = new JSONObject();
				JSONArray array = new JSONArray();
				JSONObject temp = new JSONObject();

				temp = getExistentTokenToEncrypt(groupIDBEL, accessGraph);
				temp.put("grpsrc", "");
				temp.put("grpdst", "");
				array.put(temp);
				result.put("values", array);
				return result;
			}
		}
		return null;

	}

	public String putJSONFileInDB(String keyIdBEL) {

		DBConnection connection = new DBConnection();
		String ID;
		try {
			Statement stmt = connection.getConnection().createStatement();

			stmt
					.execute("Insert into filetable (keyidbel,owner,filename,keyidsel)"
							+ "values ( '"
							+ keyIdBEL
							+ "','"
							+ ownerID
							+ "','"
							+ filePath + "','')");

			ResultSet rset = stmt
					.executeQuery("SELECT max(objectID) from filetable");

			rset.next();
			ID = rset.getString(1);

			rset.close();
			stmt.close();

			return ID;

		} catch (Exception e) {
			System.err.println(e.toString());
			return "";
		}
	}

	public static JSONObject getFriendList(String userID) throws JSONException {

		JSONObject response = new JSONObject();
		JSONArray array = new JSONArray();

		DBConnection connection = new DBConnection();
		LinkedList<String> proprietari = new LinkedList<String>();
		try {
			Statement stmt = connection.getConnection().createStatement();
			ResultSet rset = stmt
					.executeQuery("SELECT keyidbel,keyidsel,owner from filetable");

			if (rset != null) {
				while (rset.next()) {

					StringTokenizer group = new StringTokenizer(rset
							.getString(1), "-");
					LinkedList<String> list = new LinkedList<String>();
					if ((rset.getString(2) == null)
							|| (rset.getString(2).equals(""))
							|| (controllaALL(rset.getString(2), userID))) {
						if ((controllaALL(rset.getString(2), userID))
								&& (rset.getString(1).equals("ALL"))) {
							proprietari.add(rset.getString(3));

						} else {
							if (((rset.getString(1).equals("ALL")))
									&& (rset.getString(2).equals("")))
								proprietari.add(rset.getString(3));

							while (group.hasMoreTokens()) {
								list.add(group.nextToken());
							}
							if (list.contains(userID))
								proprietari.add(rset.getString(3));
						}
					} else {
						if (((controllaALL(rset.getString(2), userID)) && (rset
								.getString(1).equals("ALL")))
								|| (!rset.getString(1).equals("ALL"))) {

							group = new StringTokenizer(rset.getString(2), "-");
							list = new LinkedList<String>();
							while (group.hasMoreTokens()) {
								list.add(group.nextToken());
							}
							if (list.contains(userID))
								proprietari.add(rset.getString(3));

						}
					}
				}
			}

			rset = stmt
					.executeQuery("SELECT subjectid,name,surname from usertable order by surname, name");

			if (rset != null) {
				while (rset.next()) {
					if (proprietari.contains(rset.getString(1))) {
						JSONObject temp = new JSONObject();
						temp.put("id", rset.getString(1));
						temp.put("name", rset.getString(2));
						temp.put("surname", rset.getString(3));
						array.put(temp);
					}
				}
			}

			rset.close();
			stmt.close();

		} catch (Exception e) {
			System.err.println(e.toString());
		}
		connection.closeConnection();

		response.put("values", array);
		return response;
	}

	public static JSONObject getFilesOfFriend(String userID, String ownerID)
			throws JSONException {

		LinkedList<FileListElement> fileList = new LinkedList<FileListElement>();

		DBConnection connection = new DBConnection();

		try {
			Statement stmt = connection.getConnection().createStatement();
			ResultSet rset = stmt
					.executeQuery("SELECT keyidbel,keyidsel,objectid,filename from filetable where owner='"
							+ ownerID + "' order by filename");

			if (rset != null) {
				while (rset.next()) {
					StringTokenizer group = new StringTokenizer(rset
							.getString(1), "-");
					LinkedList<String> list = new LinkedList<String>();

					if ((rset.getString(2) == null)
							|| (rset.getString(2).equals(""))
							|| (controllaALL(rset.getString(2), userID))) {
						if ((controllaALL(rset.getString(2), userID))
								&& (rset.getString(1).equals("ALL")))

						{
							FileListElement fle = new FileListElement(rset
									.getString(3), rset.getString(4), rset
									.getString(1), rset.getString(2), ownerID);
							fileList.add(fle);

						} else {
							if ((rset.getString(1).equals("ALL"))
									&& (rset.getString(2).equals(""))) {
								FileListElement fle = new FileListElement(rset
										.getString(3), rset.getString(4), rset
										.getString(1), rset.getString(2),
										ownerID);
								fileList.add(fle);
							}

							if (((controllaALL(rset.getString(2), userID)) && (rset
									.getString(1).equals("ALL")))
									|| (!rset.getString(1).equals("ALL"))) {
								while (group.hasMoreTokens()) {
									list.add(group.nextToken());
								}

								if (list.contains(userID)) {
									FileListElement fle = new FileListElement(
											rset.getString(3), rset
													.getString(4), rset
													.getString(1), rset
													.getString(2), ownerID);
									fileList.add(fle);
								}
							}
						}
					} else {

						group = new StringTokenizer(rset.getString(2), "-");
						list = new LinkedList<String>();
						while (group.hasMoreTokens()) {
							list.add(group.nextToken());
						}
						if ((list.contains(userID))
								&& (!list.get(0).equals("ALL"))) {
							FileListElement fle = new FileListElement(rset
									.getString(3), rset.getString(4), rset
									.getString(1), rset.getString(2), ownerID);
							fileList.add(fle);
						}

					}
				}
			}

			rset.close();
			stmt.close();

		} catch (Exception e) {
			System.err.println(e.toString());
		}
		connection.closeConnection();

		JSONObject JSONfileList = new JSONObject();
		JSONArray fileArray = new JSONArray();

		for (int i = 0; i < fileList.size(); i++) {
			JSONObject temp = new JSONObject();
			temp.put("fileName", fileList.get(i).getFileName());
			temp.put("keyIdBel", fileList.get(i).getFileIDKeyBEL());
			temp.put("keyIdSel", fileList.get(i).getFileIDKeySEL());
			temp.put("fileId", fileList.get(i).getID());
			fileArray.put(temp);
		}
		JSONfileList.put("values", fileArray);
		return JSONfileList;

	}
	public static byte[] getKeyFromOwnerKey(String keyID,
			AccessGraph accessgraph, String ownerID, String userid) {

		byte[] aesKey = null;
		String key = keyID;
		Token newToken;
		DBConnection connection = new DBConnection();
		ACL antenato = new ACL();
		LinkedList<Token> tokenPath = new LinkedList<Token>();

		try {

			ACL acl = new ACL();
			acl = accessgraph.getACLfromID(key);

			LinkedList<String> codici = new LinkedList<String>();
			codici = acl.getUserList();
			LinkedList<ACL> foglie = new LinkedList<ACL>();
			foglie = accessgraph.getAclListBySize(2);

			if (acl.getSize() == 2)
			{
				aesKey = DHKeyAgreementFunction.buildDHKey(userid, ownerID
						.toString());
			} else {

				if (ownerID.equals(userid)) {
					LinkedList<ACL> list = accessgraph.getAclListBySize(2);
					boolean trovato = false;
					boolean dentroif = false;
					int i = 0;

					do {
						if (list.get(i).getUserList().get(0).equals(
								ownerID.toString())) {
							dentroif = true;
							userid = list.get(i).getUserList().get(1);
						}
						if (list.get(i).getUserList().get(1).equals(
								ownerID.toString())) {
							dentroif = true;
							userid = list.get(i).getUserList().get(0);
						}
						if ((acl.getUserList().contains(userid)) && (dentroif))
							trovato = true;
						dentroif = false;
						++i;
					} while (!trovato);
				}

				antenato.addUser(ownerID);
				antenato.addUser(userid);
				LinkedList<ACL> percorso = new LinkedList<ACL>();

				esplora_albero(accessgraph, antenato.getID(), percorso, acl);

				Statement stmt = connection.getConnection().createStatement(
						ResultSet.TYPE_SCROLL_INSENSITIVE,
						ResultSet.CONCUR_UPDATABLE);
				ResultSet rset = stmt
						.executeQuery("SELECT groupidsource,groupiddestination,token,label from tokentable where level = 'BEL'");
				for (int j = 0; j < percorso.size() - 1; j++) {
					rset.first();
					do {

						if ((rset.getString(1).equals(percorso.get(j).getID()))
								&& (rset.getString(2).equals(percorso
										.get(j + 1).getID()))) {
							newToken = new Token(rset.getString(1), rset
									.getString(2), Conversion.toBytes(rset
									.getString(3)), rset.getString(4));
							tokenPath.add(newToken);

						}
					} while (rset.next());
				}

				aesKey = DHKeyAgreementFunction.buildDHKey(userid, ownerID
						.toString());

				for (int i = 0; i < tokenPath.size(); i++) {

					aesKey = Token.rebuildKey(aesKey, tokenPath.get(i)
							.getToken(), tokenPath.get(i).getLabel());
				}
			}

		} catch (Exception e) {
			System.err.println(e.toString());
		}
		connection.closeConnection();

		return aesKey;
	}
	public boolean putFileInDB(String keyIdBEL, String keysel) {

		DBConnection connection = new DBConnection();
		String ID;
		try {
			Statement stmt = connection.getConnection().createStatement();

			stmt
					.execute("Insert into filetable (keyidbel,owner,filename,keyidsel)"
							+ "values ( '"
							+ keyIdBEL
							+ "','"
							+ ownerID
							+ "','"
							+ getFileName(filePath) + "','" + keysel + "')");

			ResultSet rset = stmt
					.executeQuery("SELECT objectID from filetable where keyidbel = '"
							+ keyIdBEL
							+ "' and owner = '"
							+ ownerID
							+ "' and filename ='" + getFileName(filePath) + "'");

			rset.next();
			ID = rset.getString(1);
			Rename("BEL_File" + File.separatorChar + "To Send"
					+ File.separatorChar + "BEL_" + getFileName(filePath),
					"BEL_File" + File.separatorChar + "To Send"
							+ File.separatorChar + "BEL_" + ID);
			fileID = ID;
			rset.close();
			stmt.close();

		} catch (Exception e) {
			System.err.println(e.toString());
			return false;
		}

		return true;
	}

	public static String putFileInDB(String keyIdBEL, String ownerID,
			String filePath, String keysel) {

		DBConnection connection = new DBConnection();
		String ID = null;
		try {
			Statement stmt = connection.getConnection().createStatement();

			stmt
					.execute("Insert into filetable (keyidbel,owner,filename,keyidsel)"
							+ "values ( '"
							+ keyIdBEL
							+ "','"
							+ ownerID
							+ "','"
							+ getFileName(filePath) + "','" + keysel + "')");

			ResultSet rset = stmt
					.executeQuery("SELECT objectID from filetable where keyidbel = '"
							+ keyIdBEL
							+ "' and owner = '"
							+ ownerID
							+ "' and filename ='" + getFileName(filePath) + "'");

			rset.next();
			ID = rset.getString(1);
			Rename("BEL_File" + File.separatorChar + "To Send"
					+ File.separatorChar + "BEL_" + getFileName(filePath),
					"BEL_File" + File.separatorChar + "To Send"
							+ File.separatorChar + "BEL_" + ID);

			rset.close();
			stmt.close();

		} catch (Exception e) {
			System.err.println(e.toString());

		}
		return ID;
	}

	public static boolean Rename(String nome_prima, String nome_dopo)
			throws IOException {
		File file1 = new File(nome_prima);
		File file2 = new File(nome_dopo);
		boolean success = file1.renameTo(file2);
		return success;
	}

	private static String getFileName(String path) {
		StringBuffer fileName = new StringBuffer();

		for (int c = (path.length() - 1); (c != 0 && path.charAt(c) != File.separatorChar); c--)
			fileName.append(path.charAt(c));

		fileName.reverse();

		return fileName.toString();
	}

	public static boolean controllaALL(String key, String user) {
		StringTokenizer group = new StringTokenizer(key, "-");
		LinkedList<String> list = new LinkedList<String>();
		while (group.hasMoreTokens()) {
			list.add(group.nextToken());
		}
		if (list.size() == 0)
			return false;
		if (!list.get(0).equals("ALL"))
			return false;
		else {
			for (int i = 1; i < list.size(); ++i)
				if (list.get(i).equals(user))
					return false;
			return true;
		}

	}

	public static LinkedList<UserListElement> buildAvailableFileOwnerList(
			String userID) {

		LinkedList<UserListElement> ownerList = new LinkedList<UserListElement>();

		DBConnection connection = new DBConnection();
		LinkedList<String> proprietari = new LinkedList<String>();
		try {
			Statement stmt = connection.getConnection().createStatement();
			ResultSet rset = stmt
					.executeQuery("SELECT keyidbel,keyidsel,owner from filetable");

			if (rset != null) {
				while (rset.next()) {

					StringTokenizer group = new StringTokenizer(rset
							.getString(1), "-");
					LinkedList<String> list = new LinkedList<String>();
					if ((rset.getString(2) == null)
							|| (rset.getString(2).equals(""))
							|| (controllaALL(rset.getString(2), userID))) {

						if ((controllaALL(rset.getString(2), userID))
								&& (rset.getString(1).equals("ALL"))) {
							proprietari.add(rset.getString(3));

						} else {
							if (((rset.getString(1).equals("ALL")))
									&& (rset.getString(2).equals("")))
								proprietari.add(rset.getString(3));

							while (group.hasMoreTokens()) {
								list.add(group.nextToken());
							}
							if (list.contains(userID))
								proprietari.add(rset.getString(3));
						}
					} else {
						if (((controllaALL(rset.getString(2), userID)) && (rset
								.getString(1).equals("ALL")))
								|| (!rset.getString(1).equals("ALL"))) {
							group = new StringTokenizer(rset.getString(2), "-");
							list = new LinkedList<String>();
							while (group.hasMoreTokens()) {
								list.add(group.nextToken());
							}
							if (list.contains(userID))
								proprietari.add(rset.getString(3));

						}
					}
				}
			}

			rset = stmt
					.executeQuery("SELECT subjectid,name,surname from usertable");

			if (rset != null) {
				while (rset.next()) {
					if (proprietari.contains(rset.getString(1))) {
						UserListElement user = new UserListElement(rset
								.getString(1), rset.getString(2), rset
								.getString(3));
						ownerList.add(user);
					}
				}
			}

			rset.close();
			stmt.close();

		} catch (Exception e) {
			System.err.println(e.toString());
		}
		connection.closeConnection();

		return ownerList;
	}

	public static LinkedList<FileListElement> getAvaiableFileList(
			String userID, String ownerID) {

		LinkedList<FileListElement> fileList = new LinkedList<FileListElement>();

		DBConnection connection = new DBConnection();

		try {
			Statement stmt = connection.getConnection().createStatement();
			ResultSet rset = stmt
					.executeQuery("SELECT keyidbel,keyidsel,objectid,filename from filetable where owner='"
							+ ownerID + "'");

			if (rset != null) {
				while (rset.next()) {
					StringTokenizer group = new StringTokenizer(rset
							.getString(1), "-");
					LinkedList<String> list = new LinkedList<String>();

					if ((rset.getString(2) == null)
							|| (rset.getString(2).equals(""))
							|| (controllaALL(rset.getString(2), userID))) {
						if ((controllaALL(rset.getString(2), userID))
								&& (rset.getString(1).equals("ALL")))

						{
							FileListElement fle = new FileListElement(rset
									.getString(3), rset.getString(4), rset
									.getString(1), rset.getString(2), ownerID);
							fileList.add(fle);

						} else {
							if ((rset.getString(1).equals("ALL"))
									&& (rset.getString(2).equals(""))) {
								FileListElement fle = new FileListElement(rset
										.getString(3), rset.getString(4), rset
										.getString(1), rset.getString(2),
										ownerID);
								fileList.add(fle);
							}

							if (((controllaALL(rset.getString(2), userID)) && (rset
									.getString(1).equals("ALL")))
									|| (!rset.getString(1).equals("ALL"))) {
								while (group.hasMoreTokens()) {
									list.add(group.nextToken());
								}

								if (list.contains(userID)) {
									FileListElement fle = new FileListElement(
											rset.getString(3), rset
													.getString(4), rset
													.getString(1), rset
													.getString(2), ownerID);
									fileList.add(fle);
								}
							}
						}
					} else {

						group = new StringTokenizer(rset.getString(2), "-");
						list = new LinkedList<String>();
						while (group.hasMoreTokens()) {
							list.add(group.nextToken());
						}
						if ((list.contains(userID))
								&& (!list.get(0).equals("ALL"))) {
							FileListElement fle = new FileListElement(rset
									.getString(3), rset.getString(4), rset
									.getString(1), rset.getString(2), ownerID);
							fileList.add(fle);
						}

					}
				}
			}

			rset = stmt
					.executeQuery("SELECT subjectid,name,surname from usertable");

			rset.close();
			stmt.close();

		} catch (Exception e) {
			System.err.println(e.toString());
		}
		connection.closeConnection();

		return fileList;

	}
	public static byte[] getKeyFromUserKey(String fileKeyID, String userID,
			String ownerID) {

		byte[] Key = null;
		byte[] userKey = null;
		String key = "own-" + userID;
		String keyidsource;
		String userName = null;
		Token newToken;
		DBConnection connection = new DBConnection();
		LinkedList<Token> tokenPath = new LinkedList<Token>();
		int pos;

		try {
			Statement stmt = connection.getConnection().createStatement();
			ResultSet rset = stmt
					.executeQuery("SELECT username from usertable where subjectid = '"
							+ userID + "' ");
			if (rset != null) {
				rset.next();
				userName = rset.getString(1);
			}

			rset.close();
			stmt.close();

		} catch (Exception e) {
			System.err.println(e.toString());
		}

		try {
			FileInputStream fin;
			DataInputStream dis;
			fin = new FileInputStream("Key" + File.separatorChar + userName);
			dis = new DataInputStream(fin);
			userKey = new byte[16];
			dis.read(userKey);
			fin.close();
		} catch (Exception e) {
			System.err.println(e.toString());
		}

		try {
			Statement stmt = connection.getConnection().createStatement(
					ResultSet.TYPE_SCROLL_INSENSITIVE,
					ResultSet.CONCUR_UPDATABLE);
			ResultSet rset = stmt
					.executeQuery("SELECT * from tokentable where level = 'BEL'");

			if (rset.first()) {
				do {

					if (rset.getString(2).equals(key)
							&& rset.getString(3).equals(
									"usr-" + ownerID + "-" + userID)) {
						newToken = new Token(rset.getString(2), rset
								.getString(3), Conversion.toBytes(rset
								.getString(4)), rset.getString(5));
						tokenPath.add(newToken);
						key = rset.getString(3);
					}

				} while (rset.next());
			}

			if (rset.first()) {
				do {
					if (!key.equals(fileKeyID)) {
						if (rset.getString(2).equals(key)
								&& !rset.getString(2).contains("own-")) {
							pos = rset.getRow();
							keyidsource = rset.getString(3);
							rset.first();
							if (keyidsource.equals(fileKeyID)) {
								rset.absolute(pos);
								newToken = new Token(rset.getString(2), rset
										.getString(3), Conversion.toBytes(rset
										.getString(4)), rset.getString(5));
								tokenPath.add(newToken);
								key = rset.getString(3);
								break;
							} else {
								if (checkPathToID(keyidsource, fileKeyID, rset)) {
									rset.absolute(pos);
									newToken = new Token(rset.getString(2),
											rset.getString(3),
											Conversion.toBytes(rset
													.getString(4)), rset
													.getString(5));
									tokenPath.add(newToken);
									key = rset.getString(3);
									rset.beforeFirst();
								} else {
									rset.absolute(pos);
								}
							}

						}
					}
				} while (rset.next());
			}
			rset.close();
			stmt.close();

		} catch (Exception e) {
			System.err.println(e.toString());
		}
		connection.closeConnection();

		for (int i = 0; i < tokenPath.size(); i++) {
			if (i == 0)
				Key = Token.rebuildKey(userKey, tokenPath.get(i).getToken(),
						tokenPath.get(i).getLabel());
			else
				Key = Token.rebuildKey(Key, tokenPath.get(i).getToken(),
						tokenPath.get(i).getLabel());
		}

		return Key;
	}

	private static boolean checkPathToID(String key, String fileKeyID,
			ResultSet rset) {
		boolean status = false;
		String keyidsource;
		int pos;

		try {

			do {
				if (rset.getString(2).equals(key)) {
					if (rset.getString(3).equals(fileKeyID))
						return true;
					else {
						pos = rset.getRow();
						keyidsource = rset.getString(3);
						rset.first();
						status = checkPathToID(keyidsource, fileKeyID, rset);
						if (status)
							return true;
						rset.absolute(pos);
					}
				}
			} while (rset.next());

		} catch (Exception e) {
			System.err.println(e.toString());
		}

		return status;
	}

	public static boolean FileIsAll(String fileID) {

		String keyIdBel = null;

		DBConnection connection = new DBConnection();

		try {

			Statement stmt = connection.getConnection().createStatement();
			ResultSet rset = stmt
					.executeQuery("SELECT * from filetable  where objectid ='"
							+ fileID + "'");
			if (rset != null) {
				while (rset.next()) {

					keyIdBel = rset.getString(2);

				}
			}
			rset.close();
			stmt.close();
		} catch (Exception e) {
			System.err.println(e.toString());
		}

		connection.closeConnection();
		if (keyIdBel.equals("ALL"))
			return true;
		return false;
	}
	public static UserListElement[] getUserListByFileID(String fileID,
			String ownerID) {

		UserListElement[] authListSEL = null;
		String keyIdBel = null;
		String keyIdSel = null;
		DBConnection connection = new DBConnection();

		try {

			Statement stmt = connection.getConnection().createStatement();
			ResultSet rset = stmt
					.executeQuery("SELECT * from filetable  where objectid ='"
							+ fileID + "'");
			if (rset != null) {
				while (rset.next()) {

					keyIdBel = rset.getString(2);
					keyIdSel = rset.getString(3);
				}
			}
			rset.close();
			stmt.close();
		} catch (Exception e) {
			System.err.println(e.toString());
		}

		connection.closeConnection();

		ACL acl = new ACL(keyIdBel + " " + keyIdSel);

		if ((keyIdSel != null) && (!keyIdSel.equals(""))) {
			StringTokenizer group = new StringTokenizer(keyIdSel, "-");
			LinkedList<String> supp = new LinkedList<String>();

			while (group.hasMoreTokens()) {
				supp.add(group.nextToken());
			}

			for (int i = 0; i < supp.size(); ++i) {
				if (!supp.get(i).equals("ALL"))
					acl.addUser(supp.get(i));
			}

		} else {
			StringTokenizer group = new StringTokenizer(keyIdBel, "-");
			LinkedList<String> supp = new LinkedList<String>();

			while (group.hasMoreTokens()) {
				supp.add(group.nextToken());
			}

			for (int i = 0; i < supp.size(); ++i) {
				if (!supp.get(i).equals("ALL"))
					acl.addUser(supp.get(i));
			}
		}

		UserListElement[] authListsupp = new UserListElement[acl.getSize()];

		int numeropropr = 0;
		for (int i = 0; i < acl.getSize(); ++i) {

			authListsupp[i] = new UserListElement(acl.getUserList().get(i));
			if ((!authListsupp[i].getID().equals(ownerID))
					&& (!authListsupp[i].getID().equals("0")))
				++numeropropr;
		}

		authListSEL = new UserListElement[numeropropr];

		int cont = 0;
		for (int i = 0; i < authListsupp.length; ++i) {
			if ((!authListsupp[i].getID().equals(ownerID))
					&& (!authListsupp[i].getID().equals("0"))) {
				authListSEL[cont] = getUserbyID(authListsupp[i].getID());
				++cont;
			}
		}

		return authListSEL;
	}

	public static UserListElement getUserbyID(String ID) {
		UserListElement usl = null;
		DBConnection connection = new DBConnection();

		try {

			Statement stmt = connection.getConnection().createStatement();
			ResultSet rset = stmt
					.executeQuery("SELECT subjectid,name,surname from usertable  where subjectid="
							+ ID);
			if (rset != null) {
				while (rset.next()) {
					usl = new UserListElement(rset.getString(1), rset
							.getString(2), rset.getString(3));
				}
			}
			rset.close();
			stmt.close();
		} catch (Exception e) {
			System.err.println(e.toString());
		}

		connection.closeConnection();

		return usl;
	}

	private boolean ingiafatto2(ACL acl, LinkedList<ACL> giafatto) {
		int i = 0;
		while (i < giafatto.size()) {
			if (acl.contains(giafatto.get(i))) {
				return true;
			}
			i++;

		}
		return false;
	}

	public static FileListElement getFileInfo(String fileID) {
		FileListElement fileInfo = null;
		DBConnection connection = new DBConnection();

		try {
			Statement stmt = connection.getConnection().createStatement(
					ResultSet.TYPE_SCROLL_INSENSITIVE,
					ResultSet.CONCUR_UPDATABLE);
			ResultSet rset = stmt
					.executeQuery("SELECT * from filetable where objectid = '"
							+ fileID + "'");

			if (rset != null) {
				while (rset.next()) {
					fileInfo = new FileListElement(rset.getString(1), rset
							.getString(5), rset.getString(2),
							rset.getString(3), rset.getString(4));
				}
			}

		} catch (Exception e) {
			System.err.println(e.toString());
		}
		connection.closeConnection();

		return fileInfo;
	}

	private static FileListElement[] getFileListByKeyIdBel(String keyIdBel) {
		LinkedList<FileListElement> fileList = new LinkedList<FileListElement>();
		DBConnection connection = new DBConnection();

		try {
			Statement stmt = connection.getConnection().createStatement(
					ResultSet.TYPE_SCROLL_INSENSITIVE,
					ResultSet.CONCUR_UPDATABLE);
			ResultSet rset = stmt
					.executeQuery("SELECT * from filetable where keyidbel='"
							+ keyIdBel + "'");

			if (rset != null) {
				while (rset.next()) {
					fileList.add(new FileListElement(rset.getString(1), rset
							.getString(5), rset.getString(2),
							rset.getString(3), rset.getString(4)));
				}
			}

		} catch (Exception e) {
			System.err.println(e.toString());
		}
		connection.closeConnection();

		return fileList.toArray(new FileListElement[fileList.size()]);
	}


	public static boolean existPathBEL(String fileIDKeyBEL, String userID,
			String ownerID) {

		LinkedList<ACL> percorso = new LinkedList<ACL>();
		AccessGraph ag = new AccessGraph(0);

		if (userID.equals(ownerID)) {

			LinkedList<ACL> antenati = new LinkedList<ACL>();
			antenati = ag.getAclListBySize(2);
			for (int i = 0; i < antenati.size(); i++) {

				if (antenati.get(i).getUserList().get(0).equals(ownerID)) {
					userID = antenati.get(i).getUserList().get(1);
				}
				if (antenati.get(i).getUserList().get(1).equals(ownerID)) {
					userID = antenati.get(i).getUserList().get(0);
				}

			}
		}

		ACL ant = new ACL();
		ant.addUser(userID);
		ant.addUser(ownerID);
		ACL dest = new ACL(fileIDKeyBEL);

		ag.addAcl(ant);
		ag.CaricaIntervalli();

		esplora_albero(ag, ant.getID(), percorso, dest);

		if (percorso.size() > 0)
			return true;
		return false;

	}

	public static byte[] getHashedKeyFromUserKey(String fileIDKeyBEL,
			String userID, String ownerID) {
		byte[] Key = null;

		Token newToken;
		DBConnection connection = new DBConnection();

		ACL ant = new ACL();
		ant.addUser(userID);
		ant.addUser(ownerID);
		try {
			Statement stmt = connection.getConnection().createStatement();
			ResultSet rset = stmt
					.executeQuery("SELECT * from tokentable where level = 'HBEL' "
							+ "and groupiddestination ='"
							+ fileIDKeyBEL
							+ "' and groupidsource ='" + ant.getID() + "'");

			if (rset != null) {

				rset.next();
				newToken = new Token(rset.getString(2), rset.getString(3),
						Conversion.toBytes(rset.getString(4)), rset
								.getString(5));

				Key = DHKeyAgreementFunction.buildDHKey(userID, ownerID);

				Key = Token.rebuildKey(Key, newToken.getToken(), newToken
						.getLabel());

			}

			rset.close();
			stmt.close();

		} catch (Exception e) {
			System.err.println(e.toString());
		}

		return Key;
	}

	public static boolean hasHBELToken(String fileID) {
		DBConnection connection = new DBConnection();
		String keyidbel = null;
		try {
			Statement stmt = connection.getConnection().createStatement();
			ResultSet rset = stmt
					.executeQuery("SELECT keyidbel from filetable where objectid = '"
							+ fileID + "' ");
			if (rset != null) {
				rset.next();
				keyidbel = rset.getString(1);
			}

			stmt = connection.getConnection().createStatement();
			rset = stmt
					.executeQuery("SELECT groupiddestination from tokentable "
							+ "where groupiddestination = '" + keyidbel
							+ "' and level='HBEL' ");
			if (rset != null) {
				if (rset.next())
					return true;
			}

			rset.close();
			stmt.close();
			connection.closeConnection();

		} catch (Exception e) {
			System.err.println(e.toString());
		}
		return false;
	}

	public static String getUsers(String fileID) {

		String users = "";

		try {
			DBConnection connection = new DBConnection();
			Statement stmt = connection.getConnection().createStatement();
			ResultSet rset = stmt
					.executeQuery("SELECT keyidsel from filetable where objectid = '"
							+ fileID + "' ");
			if (rset != null) {
				rset.next();
				users = rset.getString(1);

				if (users.length() <= 0) {
					rset = stmt
							.executeQuery("SELECT keyidbel from filetable where objectid = '"
									+ fileID + "' ");
					if (rset != null) {
						rset.next();
						users = rset.getString(1);
					}
				}

			}

		} catch (Exception e) {
			e.printStackTrace();
		}

		return users;

	}

}
